Package: pcaExplorer
Type: Package
Title: Interactive Visualization of RNA-seq Data Using a Principal
        Components Approach
Version: 3.6.0
Date: 2025-12-01
Authors@R: c(person("Federico", "Marini", role = c("aut", "cre"), 
    email ="marinif@uni-mainz.de", 
    comment = c(ORCID = '0000-0003-3252-7758')))
Description: This package provides functionality for interactive visualization 
    of RNA-seq datasets based on Principal Components Analysis. The methods provided
    allow for quick information extraction and effective data exploration. A Shiny
    application encapsulates the whole analysis.
License: MIT + file LICENSE
Imports: DESeq2, SummarizedExperiment, mosdef (>= 1.1.0),
        GenomicRanges, IRanges, S4Vectors, genefilter, ggplot2 (>=
        2.0.0), heatmaply, plotly, scales, NMF, plyr, topGO, limma,
        GOstats, GO.db, AnnotationDbi, shiny (>= 0.12.0),
        shinydashboard, shinyBS, ggrepel, DT, shinyAce, threejs,
        biomaRt, pheatmap, knitr, rmarkdown, base64enc, tidyr,
        grDevices, methods
Suggests: testthat, BiocStyle, markdown, airway, org.Hs.eg.db,
        htmltools
URL: https://github.com/federicomarini/pcaExplorer,
        https://federicomarini.github.io/pcaExplorer/
BugReports: https://github.com/federicomarini/pcaExplorer/issues
biocViews: ImmunoOncology, Visualization, RNASeq, DimensionReduction,
        PrincipalComponent, QualityControl, GUI, ReportWriting,
        ShinyApps
VignetteBuilder: knitr
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: no
Roxygen: list(markdown = TRUE)
git_url: https://git.bioconductor.org/packages/pcaExplorer
git_branch: RELEASE_3_23
git_last_commit: 27ac356
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 23:50:24 UTC; biocbuild
Author: Federico Marini [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-3252-7758>)
Maintainer: Federico Marini <marinif@uni-mainz.de>

<img src="man/figures/pcaExplorer.png" align="right" alt="" width="120" />

# pcaExplorer - Interactive exploration of Principal Components of Samples and Genes in RNA-seq data 

<a href="https://doi.org/10.1186/s12859-019-2879-1"><img src="https://img.shields.io/badge/doi-pcaExplorer-blue.svg"><a>
<a href="https://doi.org/10.1002/cpz1.411"><img src="https://img.shields.io/badge/doi-pcaExplorer_protocol-blue.svg"><a>

## Software status

[![R build status](https://github.com/federicomarini/pcaExplorer/workflows/R-CMD-check/badge.svg)](https://github.com/federicomarini/pcaExplorer/actions)

| Platforms |  OS  | R CMD check |
|:----------------:|:----------------:|:----------------:|
| Bioc ([_devel_](http://bioconductor.org/packages/devel/bioc/html/pcaExplorer.html)) | Multiple | [![Bioconductor-devel Build Status](http://bioconductor.org/shields/build/devel/bioc/pcaExplorer.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/pcaExplorer) |
| Bioc ([_release_](http://bioconductor.org/packages/release/bioc/html/pcaExplorer.html)) | Multiple | [![Bioconductor-release Build Status](http://bioconductor.org/shields/build/release/bioc/pcaExplorer.svg)](http://bioconductor.org/checkResults/release/bioc-LATEST/pcaExplorer) |

[![codecov.io](https://codecov.io/github/federicomarini/pcaExplorer/coverage.svg?branch=master)](https://codecov.io/github/federicomarini/pcaExplorer?branch=master)

`pcaExplorer` is a Bioconductor package containing a Shiny application for
analyzing expression data in different conditions and experimental factors. 

It is a general-purpose interactive companion tool for RNA-seq analysis, which 
guides the user in exploring the Principal Components of the data under inspection.

`pcaExplorer` provides tools and functionality to detect outlier samples, genes
that show particular patterns, and additionally provides a functional interpretation of 
the principal components for further quality assessment and hypothesis generation
on the input data. 

Moreover, a novel visualization approach is presented to simultaneously assess 
the effect of more than one experimental factor on the expression levels.

Thanks to its interactive/reactive design, it is designed to become a practical
companion to any RNA-seq dataset analysis, making exploratory data analysis 
accessible also to the bench biologist, while providing additional insight also
for the experienced data analyst.

## Installation

`pcaExplorer` can be easily installed using `BiocManager::install()`:

``` r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("pcaExplorer")
```

or, optionally, 

``` r
BiocManager::install("federicomarini/pcaExplorer")
# or alternatively...
devtools::install_github("federicomarini/pcaExplorer")
```

## Quick start

This command loads the `pcaExplorer` package

``` r
library("pcaExplorer")
```

The `pcaExplorer` app can be launched in different modes:

- `pcaExplorer(dds = dds, dst = dst)`, where `dds` is a `DESeqDataSet` object and `dst` is a `DESeqTransform`
object, which were created during an existing session for the analysis of an RNA-seq
dataset with the `DESeq2` package

- `pcaExplorer(dds = dds)`, where `dds` is a `DESeqDataSet` object. The `dst` object is automatically 
computed upon launch.

- `pcaExplorer(countmatrix = countmatrix, coldata = coldata)`, where `countmatrix` is a count matrix, generated
after assigning reads to features such as genes via tools such as `HTSeq-count` or `featureCounts`, and `coldata`
is a data frame containing the experimental covariates of the experiments, such as condition, tissue, cell line,
run batch and so on.

- `pcaExplorer()`, and then subsequently uploading the count matrix and the covariates data frame through the 
user interface. These files need to be formatted as tab separated files, which is a common format for storing
such count values.

Additional parameters and objects that can be provided to the main `pcaExplorer` function are:

- `pca2go`, which is an object created by the `pca2go` function, which scans the genes with high loadings in 
each principal component and each direction, and looks for functions (such as GO Biological Processes) that 
are enriched above the background. The offline `pca2go` function is based on the routines and algorithms of 
the `topGO` package, but as an alternative, this object can be computed live during the execution of the app
exploiting the `goana` function, provided by the `limma` package. Although this likely provides more general
(and probably less informative) functions, it is a good compromise for obtaining a further data interpretation.

- `annotation`, a data frame object, with `row.names` as gene identifiers (e.g. ENSEMBL ids) identical to the 
row names of the count matrix or `dds` object, and an extra column `gene_name`, containing e.g. HGNC-based 
gene symbols. This can be used for making information extraction easier, as ENSEMBL ids (a usual choice when
assigning reads to features) do not provide an immediate readout for which gene they refer to. This can be
either passed as a parameter when launching the app, or also uploaded as a tab separated text file.

## Contact

For additional details regarding the functions of **pcaExplorer**, please consult the documentation or 
write an email to marinif@uni-mainz.de. 

## Code of Conduct

Please note that the pcaExplorer project is released with a [Contributor Code of Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

### Bug reports/Issues/New features

Please use https://github.com/federicomarini/pcaExplorer/issues for reporting bugs, issues or for 
suggesting new features to be implemented. 

#' Explore a dataset from a PCA perspective
#'
#' Launch a Shiny App for interactive exploration of a dataset from the perspective
#' of Principal Components Analysis
#'
#' @param dds A [DESeq2::DESeqDataSet()] object. If not provided, then a `countmatrix`
#' and a `coldata` need to be provided. If none of the above is provided, it is possible
#' to upload the data during the execution of the Shiny App
#' @param dst A [DESeq2::DESeqTransform()] object. Can be computed from the `dds` object
#' if left NULL. If none is provided, then a `countmatrix`
#' and a `coldata` need to be provided. If none of the above is provided, it is possible
#' to upload the data during the execution of the Shiny App
#' @param countmatrix A count matrix, with genes as rows and samples as columns. If not provided, it is possible
#' to upload the data during the execution of the Shiny App
#' @param coldata A data.frame containing the info on the covariates of each sample. If not provided, it is possible
#' to upload the data during the execution of the Shiny App
#' @param pca2go An object generated by the [pca2go()] function, which contains
#' the information on enriched functional categories in the genes that show the top or bottom loadings
#' in each principal component of interest. If not provided, it is possible
#' to compute live during the execution of the Shiny App
#' @param annotation A `data.frame` object, with row.names as gene identifiers (e.g. ENSEMBL ids)
#' and a column, `gene_name`, containing e.g. HGNC-based gene symbols
#' @param runLocal A logical indicating whether the app is to be run locally or remotely on a server, which determines how documentation will be accessed.
#'
#' @return A Shiny App is launched for interactive data exploration
#'
#' @examples
#' library("airway")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
#'                                              colData = colData(airway),
#'                                              design = ~dex+cell)
#' \dontrun{
#' rld_airway <- DESeq2::rlogTransformation(dds_airway)
#'
#' pcaExplorer(dds_airway, rld_airway)
#'
#' pcaExplorer(countmatrix = counts(dds_airway), coldata = colData(dds_airway))
#'
#' pcaExplorer() # and then upload count matrix, covariate matrix (and eventual annotation)
#' }
#' 
#' @importFrom mosdef gene_plot
#' 
#' @export
pcaExplorer <- function(dds = NULL,
                        dst = NULL,
                        countmatrix = NULL,
                        coldata = NULL,
                        pca2go = NULL,
                        annotation = NULL,
                        runLocal = TRUE) {

  if (!requireNamespace("shiny", quietly = TRUE)) {
    stop("pcaExplorer requires 'shiny'. Please install it using
         install.packages('shiny')")
  }

  # get modes and themes for the ace editor
  modes <- shinyAce::getAceModes()
  themes <- shinyAce::getAceThemes()

  # create environment for storing inputs and values
  ## i need the assignment like this to export it up one level - i.e. "globally"
  pcaexplorer_env <<- new.env(parent = emptyenv())

  ## upload max 300mb files - can be changed if necessary
  options(shiny.maxRequestSize = 300 * 1024^2)

  # ui definition -----------------------------------------------------------
  pcaexplorer_ui <- shinydashboard::dashboardPage(
    # header definition -----------------------------------------------------------
    dashboardHeader(
      title = paste0("pcaExplorer - Interactive exploration of Principal Components ",
                     "of Samples and Genes in RNA-seq data - version ",
                     packageVersion("pcaExplorer")),
      titleWidth = 900,

      # task menu for saving state to environment or binary data
      shinydashboard::dropdownMenu(
        type = "tasks", icon = icon("cog"), badgeStatus = NULL,
        headerText = "pcaExplorer task menu",
        notificationItem(
          text = actionButton("exit_and_save", "Exit pcaExplorer & save",
                              class = "btn_no_border",
                              onclick = "setTimeout(function(){window.close();}, 100); "),
          icon = icon("sign-out"), status = "primary"),
        menuItem(
          text = downloadButton("state_save_sc", "Save State as .RData"))
      )
    ),
    # sidebar definition -----------------------------------------------------------
    dashboardSidebar(
      width = 280,

      menuItem(
        "App settings",
        icon = icon("cogs"),
        startExpanded = TRUE,
        selectInput("pc_x", label = "x-axis PC: ", choices = 1:8, selected = 1),
        shinyBS::bsTooltip(
          "pc_x", paste0("Select the principal component to display on the x axis"),
          "right", options = list(container = "body")),
        selectInput("pc_y", label = "y-axis PC: ", choices = 1:8, selected = 2),
        shinyBS::bsTooltip(
          "pc_y", paste0("Select the principal component to display on the y axis"),
          "right", options = list(container = "body")),
        uiOutput("color_by"),
        shinyBS::bsTooltip(
          "color_by",
          paste0("Select the group of samples to stratify the analysis. Can also assume multiple values"),
          "right", options = list(container = "body")),
        numericInput("pca_nrgenes", label = "Nr of (most variable) genes:",
                     value = 300, min = 50, max = 20000),
        shinyBS::bsTooltip(
          "pca_nrgenes", paste0(
            "Number of genes to select for computing the principal components. The top n genes are",
            " selected ranked by their variance inter-samples"),
          "right", options = list(container = "body")),
        numericInput("pca_point_alpha", label = "Alpha: ", value = 1, min = 0, max = 1, step = 0.01),
        shinyBS::bsTooltip(
          "pca_point_alpha",
          paste0("Color transparency for the plots. Can assume values from 0 (transparent) ",
                 "to 1 (opaque)"),
          "right", options = list(container = "body")),
        numericInput("pca_label_size", label = "Labels size: ", value = 2, min = 1, max = 8),
        shinyBS::bsTooltip(
          "pca_label_size", paste0("Size of the labels for the samples in the principal components plots. ",
                                   "This also controls the size of the gene labels in the Genes View panel."),
          "right", options = list(container = "body")),
        numericInput("pca_point_size", label = "Points size: ", value = 2, min = 1, max = 8),
        shinyBS::bsTooltip(
          "pca_point_size", paste0("Size of the points to be plotted in the principal components plots"),
          "right", options = list(container = "body")),
        numericInput("pca_varname_size", label = "Variable name size: ", value = 4, min = 1, max = 8),
        shinyBS::bsTooltip(
          "pca_varname_size", paste0("Size of the labels for the genes PCA - correspond to the samples names"),
          "right", options = list(container = "body")),
        numericInput("pca_scale_arrow", label = "Scaling factor : ", value = 1, min = 0.01, max = 10),
        shinyBS::bsTooltip(
          "pca_scale_arrow", paste0("Scale value for resizing the arrow corresponding to the variables in the ",
                                    "PCA for the genes. It should be used for mere visualization purposes"),
          "right", options = list(container = "body")),
        selectInput("col_palette", "Color palette", choices = list("hue", "set1", "rainbow")),
        selectInput("plot_style", "Plot style for gene counts", choices = list("boxplot", "violin plot")),
        shinyBS::bsTooltip(
          "col_palette", paste0("Select the color palette to be used in the principal components plots. The number of ",
                                "colors is selected automatically according to the number of samples and to the levels ",
                                "of the factors of interest and their interactions"),
          "right", options = list(container = "body"))
      ), # end of menuItem
      menuItem(
        "Plot export settings",
        icon = icon("paint-brush"),
        startExpanded = TRUE,

        numericInput("export_width",
                     label = "Width of exported figures (cm)", value = 10, min = 2),
        shinyBS::bsTooltip(
          "export_width", paste0("Width of the figures to export, expressed in cm"),
          "right", options = list(container = "body")),
        numericInput("export_height", label = "Height of exported figures (cm)", value = 10, min = 2),
        shinyBS::bsTooltip(
          "export_height", paste0("Height of the figures to export, expressed in cm"),
          "right", options = list(container = "body"))
      ) # end of menuItem
    ),

    # body definition ---------------------------------------------------------
    dashboardBody(
      ## Define output size and style of error messages
      tags$head(
        tags$style(HTML("
                        .shiny-output-error-validation {
                        font-size: 15px;
                        color: forestgreen;
                        text-align: center;
                        }
                        ")
        )
      ),

      # ui main tabBox -------------------------------------------------------
      tabBox(
        width = 12,
        # ui panel data upload -------------------------------------------------------
        tabPanel(
          "Data Upload", icon = icon("upload"),
          fluidRow(
            column(
              width = 4,
              uiOutput("upload_count_matrix"),
              shinyBS::bsTooltip(
                "upload_count_matrix", paste0("Select the file containing the count matrix"),
                "right", options = list(container = "body"))),
            column(
              width = 4,
              uiOutput("upload_metadata"),
              shinyBS::bsTooltip(
                "upload_metadata", paste0("Select the file containing the samples metadata"),
                "right", options = list(container = "body"))),
            column(
              width = 3,
              # help button?
              br(), br(), br(),
              uiOutput("ui_createDDS"),
              actionButton("help_format", label = "", icon = icon("question-circle"),
                           style = "color: #0092AC; background-color: #FFFFFF; border-color: #FFFFFF"),
              shinyBS::bsTooltip(
                "help_format",
                "How to provide your input data in pcaExplorer",
                "bottom", options = list(container = "body"))
              #####              ,verbatimTextOutput("debugdebug")
            )),
          fluidRow(
            column(
              width = 4,
              uiOutput("upload_annotation"),
              shinyBS::bsTooltip(
                "upload_annotation", paste0("Select the file containing the annotation data"),
                "right", options = list(container = "body")),
              br(),
              "... or you can also ",
              actionButton("btn_loaddemo", "Load the demo airway data",
                           icon = icon("play-circle"), style = "color: #0092AC"),
              # class = "btn btn-info"),
              shinyBS::bsTooltip(
                "btn_loaddemo", paste0("Clicking on this button will load the airway data as DESeqDataSet, apply the regularized log transformation, and prepare the annotation for displaying gene symbols"),
                "bottom", options = list(container = "body"))
            )
          )
          ,
          br(),
          p(),
          uiOutput("ui_computetransform"),

          h4("Preview on the available data"),
          fluidRow(
            column(
              width = 10,
              splitLayout(
                uiOutput("ui_showcm"),
                uiOutput("ui_showmetadata"),
                uiOutput("ui_showdds"),
                uiOutput("ui_showannotation")
              )
            )
          )
        ),

        # ui panel instructions -------------------------------------------------------
        tabPanel(
          "Instructions",  icon = icon("info-circle"),
          fluidRow(
            column(
              width = 12,
              p("These buttons will open the fully rendered vignettes, either built locally or directly from the Bioconductor package page."),
              actionButton(
                "open_vignette_full", label = "Open the User Guide (main vignette)",
                icon = icon("book"),
                onclick = ifelse(runLocal, "",
                                 # Use web vignette, with varying paths depending on whether we're release or devel.
                                 sprintf("window.open('http://bioconductor.org/packages/%s/bioc/vignettes/pcaExplorer/inst/doc/pcaExplorer.html', '_blank')",
                                         ifelse(unlist(packageVersion("pcaExplorer"))[2] %% 2L == 0L, "release", "devel")
                                 )
                )
              ),
              actionButton(
                "open_vignette_quickstart", label = "Open the 'Up and running' vignette",
                icon = icon("rocket"),
                onclick = ifelse(runLocal, "",
                                 # Use web vignette, with varying paths depending on whether we're release or devel.
                                 sprintf("window.open('http://bioconductor.org/packages/%s/bioc/vignettes/pcaExplorer/inst/doc/upandrunning.html', '_blank')",
                                         ifelse(unlist(packageVersion("pcaExplorer"))[2] %% 2L == 0L, "release", "devel")
                                 )
                )
              ),
              br(), br(),
              p("Otherwise, you can click on the collapsible element below to display a quickstart guide."),
              shinyBS::bsCollapse(
                id = "help_fulluserguide", open = NULL,
                shinyBS::bsCollapsePanel(
                  "Up and running with pcaExplorer",
                  includeMarkdown(system.file("extdata", "instructions_unr.md", package = "pcaExplorer"))
                )
              )
            )
          )

        ),
        # ui panel counts table -------------------------------------------------------
        tabPanel(
          "Counts Table",
          icon = icon("table"),
          conditionalPanel(
            condition = "!output.checkdds",
            h3("Counts table"),

            selectInput("countstable_unit", label = "Data scale in the table",
                        choices = list("Counts (raw)" = "raw_counts",
                                       "Counts (normalized)" = "normalized_counts",
                                       "Regularized logarithm transformed" = "rlog_counts",
                                       "Log10 (pseudocount of 1 added)" = "log10_counts",
                                       "TPM (Transcripts Per Million)" = "tpm_counts")),

            DT::dataTableOutput("showcountmat"),

            downloadButton("downloadData", "Download", class = "btn btn-success"),
            hr(),
            h3("Sample to sample scatter plots"),
            selectInput("corr_method", "Correlation method palette",
                        choices = list("pearson", "spearman", "kendall")),
            checkboxInput(inputId = "corr_uselogs", label = "Use log2 values for plot axes and values",
                          value = TRUE),
            checkboxInput(inputId = "corr_usesubset", label = "Use a subset of max 1000 genes (quicker to plot)",
                          value = TRUE),

            p("Compute sample to sample correlations on the normalized counts - warning, it can take a while to plot all points (depending mostly on the number of samples you provided)."),
            actionButton("compute_pairwisecorr", "Run", class = "btn btn-primary"),
            uiOutput("pairwise_plotUI"),
            uiOutput("heatcorr_plotUI")
          ),
          conditionalPanel(
            condition = "output.checkdds",
            h2("You did not create the dds object yet. Please go the main tab and generate it"))
        ),
        # ui panel data overview -------------------------------------------------------
        tabPanel(
          "Data Overview", icon = icon("eye"),
          conditionalPanel(
            condition = "!output.checkrlt",
            h1("Sneak peek in the data"),
            h3("Design metadata"),
            DT::dataTableOutput("showcoldata"),

            h3("Sample to sample distance heatmap"),
            fluidRow(
              column(
                width = 8,
                selectInput(inputId = "sampledist_distance", label = "Select the distance method to use:",
                            choices =
                              c(Euclidean="euclidean", Manhattan = "manhattan", `Correlation-based` = "cor"),
                            selected = "euclidean"),
                plotOutput("heatmapsampledist"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplessamplesheat", "Download Plot"),
                    textInput("filename_samplessamplesheat", label = "Save as...", value = "pcae_sampletosample.pdf")))
            ),
            hr(),
            h3("General information on the provided SummarizedExperiment/DESeqDataSet"),
            shiny::verbatimTextOutput("showdata"),
            h3("Number of million of reads per sample"),
            fluidRow(
              column(
                width = 8,
                plotOutput("reads_barplot"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_readsbarplot", "Download Plot"),
                    textInput("filename_readsbarplot", label = "Save as...", value = "pcae_readsbarplot.pdf")))),
            h3("Basic summary for the counts"),
            p("Number of uniquely aligned reads assigned to each sample"),
            verbatimTextOutput("reads_summary"),
            wellPanel(
              fluidRow(
                column(
                  width = 4,
                  numericInput("threshold_rowsums", "Threshold on the row sums of the counts", value = 0, min = 0)),
                column(
                  width = 4,
                  numericInput("threshold_rowmeans", "Threshold on the row means of the normalized counts", value = 0, min = 0))
              )),
            p("According to the selected filtering criteria, this is an overview on the provided count data"),
            verbatimTextOutput("detected_genes")),
          conditionalPanel(
            condition = "output.checkrlt",
            h2("You did not create the dst object yet. Please go the main tab and generate it")
          )
        ),
        # ui panel samples view -------------------------------------------------------
        tabPanel(
          "Samples View",
          icon = icon("share-alt"),
          conditionalPanel(
            condition = "!output.checkrlt",

            p(h1("Principal Component Analysis on the samples"),
              "PCA projections of sample expression profiles onto any pair of components."),
            fluidRow(
              column(
                width = 4,
                wellPanel(checkboxInput("sample_labels", "Display sample labels", value = TRUE),
                          checkboxInput("pca_ellipse", "Draw a confidence ellipse for each group", value = FALSE),
                          sliderInput("pca_cislider", "Select the confidence interval level", min = 0, max = 1, value = 0.95)))),
            fluidRow(
              column(
                width = 6,
                plotOutput("samples_pca", brush = "pca_brush"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplesPca", "Download Plot"),
                    textInput("filename_samplesPca", label = "Save as...", value = "samplesPca.pdf"))
              ),
              column(
                width = 6,
                plotOutput("samples_scree"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplesScree", "Download Plot"),
                    textInput("filename_samplesScree", label = "Save as...", value = "samplesScree.pdf")),
                wellPanel(fluidRow(
                  column(
                    width = 6,
                    radioButtons("scree_type", "Scree plot type:",
                                 choices = list("Proportion of explained variance" = "pev",
                                                "Cumulative proportion of explained variance" = "cev"), "pev")
                  ),
                  column(
                    width = 6,
                    numericInput("scree_pcnr", "Number of PCs to display", value = 8, min = 2)
                  )
                ))
              )
            ),
            hr(),
            fluidRow(
              column(
                width = 6,
                plotOutput("samples_pca_zoom"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplesPcazoom", "Download Plot"),
                    textInput("filename_samplesPcazoom", label = "Save as...", value = "samplesPcazoom.pdf"))
              ),
              column(
                width = 6,
                numericInput("ntophiload", "Nr of genes to display (top & bottom)", value = 10, min = 1, max = 40),
                plotOutput("geneshiload"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplesPca_hiload", "Download Plot"),
                    textInput("filename_samplesPca_hiload", label = "Save as...", value = "pcae_hiload.pdf"))
              )
            ),
            hr(),
            fluidRow(
              column(
                width = 6,
                p(h4("Outlier Identification"), "Toggle which samples to remove - suspected to be considered as outliers"),
                uiOutput("ui_outliersamples"),
                plotOutput("samples_outliersremoved"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_samplesPca_sampleout", "Download Plot"),
                    textInput("filename_samplesPca_sampleout", label = "Save as...", value = "samplesPca_sampleout.pdf"))
              )
            ),
            fluidRow(
              column(
                width = 8,
                selectInput("pc_z", "Select the principal component to display on the z axis", choices = 1:8, selected = 3),
                scatterplotThreeOutput("pca3d")
              )
            )
          ),
          conditionalPanel(
            condition = "output.checkrlt",
            h2("You did not create the dst object yet. Please go the main tab and generate it"))
        ),
        # ui panel genes view -------------------------------------------------------
        tabPanel(
          "Genes View",
          icon = icon("yelp"),
          conditionalPanel(
            condition = "!output.checkrlt",

            p(h1("Principal Component Analysis on the genes"), "PCA projections of genes abundances onto any pair of components."),

            fluidRow(
              column(
                width = 6,
                checkboxInput("variable_labels", "Display variable labels", value = TRUE),
                checkboxInput("ylimZero_genes", "Set y axis limit to 0", value = TRUE)
              )
            ),
            fluidRow(
              column(
                width = 6,
                h4("Main Plot - interact!"),
                plotOutput("genes_biplot", brush = "pcagenes_brush", click = "pcagenes_click"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genesPca", "Download Plot"),
                    textInput("filename_genesPca", label = "Save as...", value = "genesPca.pdf"))),
              column(
                width = 6,
                h4("Zoomed window"),
                plotOutput("genes_biplot_zoom", click = "pcagenes_zoom_click"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genesZoom", "Download Plot"),
                    textInput("filename_genesZoom", label = "Save as...", value = "genesPca_zoomed.pdf")))
            ),

            fluidRow(
              column(
                width = 6,
                h4("Profile explorer"),

                checkboxInput("zprofile", "Display scaled expression values", value = TRUE),
                plotOutput("genes_profileexplorer"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genesPca_profile", "Download Plot"),
                    textInput("filename_genesPca_profile", label = "Save as...", value = "genesPca_profile.pdf")
                )
              ),
              column(
                width = 6,
                h4("Boxplot of selected gene"),

                plotOutput("genes_biplot_boxplot"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genesPca_countsplot", "Download Plot"),
                    textInput("filename_genesPca_countsplot", label = "Save as...", value = "genesPca_countsplot.pdf")))
            ),

            fluidRow(
              column(
                width = 6,
                h4("Zoomed heatmap"),
                plotOutput("heatzoom"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genesHeatmap", "Download Plot"),
                    textInput("filename_genesHeatmap", label = "Save as...", value = "genesHeatmap.pdf"))),
              column(
                width = 6,
                h4("Zoomed interactive heatmap"),
                fluidRow(radioButtons("heatmap_colv", "Cluster samples", choices = list("Yes" = TRUE, "No" = FALSE), selected = TRUE)),
                fluidRow(plotlyOutput("heatzoomly")))),

            hr(),
            box(
              title = "Table export options", status = "primary", solidHeader = TRUE,
              collapsible = TRUE, collapsed = TRUE, width = 12,
              fluidRow(
                column(
                  width = 6,
                  h4("Points selected by brushing - clicking and dragging:"),
                  DT::dataTableOutput("pca_brush_out"),
                  downloadButton("downloadData_brush", "Download brushed points"),
                  textInput("brushedPoints_filename", "File name...")),
                column(
                  width = 6,
                  h4("Points selected by clicking:"),
                  DT::dataTableOutput("pca_click_out"),
                  downloadButton("downloadData_click", "Download clicked (or nearby) points")),
                textInput("clickedPoints_filename", "File name...")
              )
            )
          ),
          conditionalPanel(
            condition = "output.checkrlt",
            h2("You did not create the dst object yet. Please go the main tab and generate it"))
        ),
        # ui panel gene finder -------------------------------------------------------
        tabPanel(
          "Gene Finder",
          icon = icon("crosshairs"),
          conditionalPanel(
            condition = "!output.checkdds",
            p(h1("GeneFinder")),
            fluidRow(
              column(
                width = 6,
                wellPanel(
                  width = 5,
                  textInput("genefinder", label = "Type in the name of the gene to search", value = NULL),
                  shinyBS::bsTooltip(
                    "genefinder", paste0(
                      "Type in the name of the gene to search. If no annotation is ",
                      "provided, you need to use IDs that are the row names of the ",
                      "objects you are using - count matrix, SummarizedExperiments ",
                      "or similar. If an annotation is provided, that also contains ",
                      "gene symbols or similar, the gene finder tries to find the ",
                      "name and the ID, and it suggests if some characters are in a ",
                      "different case"),
                    "bottom", options = list(container = "body")),
                  checkboxInput("ylimZero", "Set y axis limit to 0", value = TRUE),
                  checkboxInput("addsamplelabels", "Annotate sample labels to the dots in the plot", value = TRUE)),

                verbatimTextOutput("searchresult"),
                verbatimTextOutput("debuggene")
              )
            ),
            fluidRow(
              column(
                width = 8,
                plotOutput("genefinder_plot"),
                div(align = "right", style = "margin-right:15px; margin-bottom:10px",
                    downloadButton("download_genefinder_countsplot", "Download Plot"),
                    textInput("filename_genefinder_countsplot", label = "Save as...", value = "pcae_genefinder.pdf"))),
              column(
                width = 4,
                DT::dataTableOutput("genefinder_table"),
                downloadButton("download_genefinder_countstable", "Download Table")
              )
            )
          ),
          conditionalPanel(
            condition = "output.checkdds",
            h2("You did not create the dds object yet. Please go the main tab and generate it")
          )
        ),
        # ui panel pca2go -------------------------------------------------------
        tabPanel(
          "PCA2GO",
          icon = icon("magic"),
          conditionalPanel(
            condition = "!output.checkrlt",

            h1("pca2go - Functional annotation of Principal Components"),
            h4("Functions enriched in the genes with high loadings on the selected principal components"),
            # verbatimTextOutput("enrichinfo"),
            wellPanel(column(
              width = 6,
              uiOutput("ui_selectspecies")
            ),
            column(
              width = 6,
              uiOutput("ui_inputtype")
            ),

            shinyBS::bsTooltip(
              "ui_selectspecies",
              paste0("Select the species for the functional enrichment analysis, ",
                     "choosing among the ones currently supported by limma::goana. ",
                     "Alternatively, for other species, it can be possible to use one ",
                     "of the available annotation packages in Bioconductor, and pre-",
                     "computing the pca2go object in advance"),
              "bottom", options = list(container = "body")),
            verbatimTextOutput("speciespkg"),
            checkboxInput("compact_pca2go", "Display compact tables (for topGO tables)", value = FALSE),
            shinyBS::bsTooltip(
              "compact_pca2go",
              paste0("Should I display all the columns? If the information content of the ",
                     "tables is somehow too much for the screen width, as it can be for ",
                     "objects generated by pca2go with the topGO routines, the app can ",
                     "display just an essential subset of the columns"),
              "bottom", options = list(container = "body")),

            uiOutput("ui_computePCA2GO"),
            shinyBS::bsTooltip(
              "ui_computePCA2GO",
              paste0("Compute a pca2go object, using the limma::goana function, ",
                     "after selecting the species of the experiment under investigation"),
              "bottom", options = list(container = "body"))),

            fluidRow(
              column(width = 3),
              column(
                width = 6,
                DT::dataTableOutput("dt_pcver_pos")),
              column(width = 3)
            ),

            fluidRow(
              column(4,
                     DT::dataTableOutput("dt_pchor_neg")),
              column(4,
                     plotOutput("pca2go")),
              column(4,
                     DT::dataTableOutput("dt_pchor_pos"))
            ),
            fluidRow(
              column(width = 3),
              column(
                width = 6,
                DT::dataTableOutput("dt_pcver_neg")),
              column(width = 3)
            )
          ),
          conditionalPanel(
            condition = "output.checkrlt",
            h2("You did not create the dst object yet. Please go the main tab and generate it"))
        ),

        # ui panel multifactor exploration -----------------------------------------------------
        tabPanel(
          "Multifactor Exploration",
          icon = icon("th-large"),
          conditionalPanel(
            condition = "!output.checkrlt",
            h1("Multifactor exploration of datasets with 2 or more experimental factors"),

            verbatimTextOutput("intro_multifac"),

            wellPanel(fluidRow(
              column(
                width = 6,
                uiOutput("covar1")
              ),
              column(
                width = 6,
                uiOutput("covar2")
              )
            ),
            fluidRow(
              column(
                width = 6,
                uiOutput("c1levels")
              ),
              column(
                width = 6,
                uiOutput("c2levels")
              )
            ),
            fluidRow(
              column(
                width = 6,
                uiOutput("colnames1"),
                uiOutput("colnames2")
              )
            ),

            shinyBS::bsTooltip(
              "covar1", paste0("Select the first experimental factor"),
              "bottom", options = list(container = "body")),
            shinyBS::bsTooltip(
              "covar2", paste0("Select the second experimental factor"),
              "bottom", options = list(container = "body")),
            shinyBS::bsTooltip(
              "c1levels", paste0("For factor 1, select two levels to contrast"),
              "bottom", options = list(container = "body")),
            shinyBS::bsTooltip(
              "c2levels", paste0("For factor 2, select two or more levels to contrast"),
              "bottom", options = list(container = "body")),
            shinyBS::bsTooltip(
              "colnames1", paste0("Combine samples belonging to Factor1-Level1 samples for each level in Factor 2"),
              "bottom", options = list(container = "body")),
            shinyBS::bsTooltip(
              "colnames2", paste0("Combine samples belonging to Factor1-Level2 samples for each level in Factor 2"),
              "bottom", options = list(container = "body"))),

            actionButton("composemat", "Compose the matrix", icon = icon("spinner"), class = "btn btn-primary"),
            shinyBS::bsTooltip(
              "composemat",
              paste0("Select first two different experimental factors, for example ",
                     "condition and tissue. For each factor, select two or more ",
                     "levels. The corresponding samples which can be used are then displayed ",
                     "in the select boxes. Select an equal number of samples for each of ",
                     "the levels in factor 1, and then click the button to compute the ",
                     "new matrix which will be used for the visualizations below"),
              "bottom", options = list(container = "body")),

            wellPanel(fluidRow(
              column(4,
                     selectInput("pc_x_multifac", label = "x-axis PC: ", choices = 1:8,
                                 selected = 1)
              ),
              column(4,
                     selectInput("pc_y_multifac", label = "y-axis PC: ", choices = 1:8,
                                 selected = 2)
              ))),

            # fluidRow(verbatimTextOutput("multifacdebug")),
            fluidRow(
              column(6,
                     plotOutput("pcamultifac", brush = "pcamultifac_brush")),
              column(6,
                     plotOutput("multifaczoom"))
            ),
            fluidRow(downloadButton("downloadData_brush_multifac", "Download brushed points"),
                     textInput("brushedPoints_filename_multifac", "File name..."),
                     DT::dataTableOutput("pcamultifac_out"))
          ),
          conditionalPanel(
            condition = "output.checkrlt",
            h2("You did not create the dst object yet. Please go the main tab and generate it")
          )
        ),
        # ui panel report editor -------------------------------------------------------
        tabPanel(
          "Report Editor",
          icon = icon("pencil"),

          h1("Report Editor"),
          fluidRow(
            column(
              width = 6,
              box(
                title = "Markdown options", status = "primary", solidHeader = TRUE, collapsible = TRUE, collapsed = TRUE, width = 9,
                radioButtons("rmd_dl_format", label = "Choose Format:", c("HTML" = "html", "R Markdown" = "rmd"), inline = TRUE),
                textInput("report_title", "Title: "),
                textInput("report_author", "Author: "),
                radioButtons("report_toc", "Table of Contents", choices = list("Yes" = "true", "No" = "false")),
                radioButtons("report_ns", "Number sections", choices = list("Yes" = "true", "No" = "false")),
                selectInput("report_theme", "Theme",
                            choices = list("Default" = "default", "Cerulean" = "cerulean",
                                           "Journal" = "journal", "Flatly" = "flatly",
                                           "Readable" = "readable", "Spacelab" = "spacelab",
                                           "United" = "united", "Cosmo" = "cosmo")),
                radioButtons("report_echo", "Echo the commands in the output", choices = list("Yes" = "TRUE", "No" = "FALSE")))),
            column(
              width = 6,
              box(
                title = "Editor options", status = "primary", solidHeader = TRUE, collapsible = TRUE, collapsed = TRUE, width = 9,
                checkboxInput("enableAutocomplete", "Enable AutoComplete", TRUE),
                conditionalPanel(
                  "input.enableAutocomplete",
                  wellPanel(
                    checkboxInput("enableLiveCompletion", "Live auto completion", TRUE),
                    checkboxInput("enableRCompletion", "R code completion", TRUE)
                  )
                ),

                selectInput("mode", "Mode: ", choices = modes, selected = "markdown"),
                selectInput("theme", "Theme: ", choices = themes, selected = "solarized_light"))
            )
            # ,
            # column( # kept for debugging purposes!
            #   width = 6,
            #   verbatimTextOutput("loadedRmd")
            # )
          ),
          fluidRow(
            column(3,
                   actionButton("updatepreview_button", "Update report", class = "btn btn-primary"), p()
            ),
            column(3, downloadButton("saveRmd", "Generate & Save", class = "btn btn-success"))
          ),

          tabBox(
            width = NULL,
            id = "report_tabbox",
            tabPanel("Report preview",
                     icon = icon("file-text"),
                     htmlOutput("knitDoc")
            ),

            tabPanel("Edit report",
                     icon = icon("pencil-square-o"),
                     aceEditor("acereport_rmd", mode = "markdown", theme = "solarized_light", autoComplete = "live",
                               value = "_Initialization of the_ `pcaExplorer` _report generation..._",
                               placeholder = "You can enter some code and text in R Markdown format",
                               height = "800px"))
          )
        ),
        # ui panel about -------------------------------------------------------
        tabPanel(
          "About", icon = icon("institution"),
          includeMarkdown(system.file("extdata", "about.md", package = "pcaExplorer")),
          hr(),

          h4("Session Info"),
          verbatimTextOutput("sessioninfo")
        )

        #           tabPanel(
        #             "Session manager",
        #             ## will put here the things to save/restore the sessions
        #             p("something"),
        #           )
      ) # end of tabBox
      , footer()
    ), # end of dashboardBody
    skin = "blue"
  )

  # server definition -------------------------------------------------------
  #nocov start
  pcaexplorer_server <- shinyServer(function(input, output, session) {
    # server setup reactives --------------------------------------------------------
    ## placeholder for the figures to export
    exportPlots <- reactiveValues(
      samplessamples_heatmap = NULL,
      reads_barplot = NULL,

      samplesPca = NULL,
      samplesZoom = NULL,
      samplesScree = NULL,
      samplesHiload = NULL,
      samplesOutlier = NULL,

      genesPca = NULL,
      genesZoom = NULL,
      genesProfile = NULL,
      genesBoxplot = NULL,
      genesHeatmap = NULL,

      genefinder_countsplot = NULL
    )

    if (!is.null(dds)) {
      if (is.null(sizeFactors(dds))) {
        withProgress({
          dds <- estimateSizeFactors(dds)
        },
        message = "Calculating size factors...",
        detail = "Using the DESeq normalization method.")
      }
    }

    ## reactive values to use in the app
    values <- reactiveValues()
    values$mydds <- dds
    values$mydst <- dst
    values$mycountmatrix <- countmatrix
    values$mymetadata <- coldata
    values$mypca2go <- pca2go

    if (!is.null(annotation)) {
      if ("gene_id" %in% colnames(annotation)) {
        rownames(annotation) <- annotation$gene_id
      }
    }
    values$myannotation <- annotation

    user_settings <- reactiveValues(save_width = 15, save_height = 11)

    if (!is.null(dds)) {
      # if provided as dds, can fill in the count matrix and metadata
      values$mycountmatrix <- counts(dds)
      values$mymetadata <- colData(dds)
    }
    output$checkdds <- reactive({
      is.null(values$mydds)
    })
    output$checkrlt <- reactive({
      is.null(values$mydst)
    })

    outputOptions(output, "checkdds", suspendWhenHidden = FALSE)
    outputOptions(output, "checkrlt", suspendWhenHidden = FALSE)

    if (runLocal) {
      observeEvent(input$open_vignette_full, {
        path <- system.file("doc", "pcaExplorer.html", package = "pcaExplorer")
        if (path == "") {
          showNotification("This vignette (User Guide) has not been built on this system, please run pcaExplorer with runLocal=FALSE or install the package with the option to build the vignettes", type = "error")
        } else {
          browseURL(path)
        }
      })
      observeEvent(input$open_vignette_quickstart, {
        path <- system.file("doc", "upandrunning.html", package = "pcaExplorer")
        if (path == "") {
          showNotification("This vignette (Up and running) has not been built on this system, please run pcaExplorer with runLocal=FALSE or install the package with the option to build the vignettes", type = "error")
        } else {
          browseURL(path)
        }
      })
    }


    # server setup dataset --------------------------------------------------------
    if (!is.null(dds)) {
      if (!is(dds, "DESeqDataSet"))
        stop("dds must be a DESeqDataSet object. If it is a simple counts matrix, provide it to the countmatrix parameter!")

      if (is.null(sizeFactors(dds))) {
        withProgress({
          dds <- estimateSizeFactors(dds)
        },
        message = "Calculating size factors...",
        detail = "Using the DESeq normalization method.")
      }
    }
    if (!is.null(dst)) {
      if (!is(dst, "DESeqTransform"))
        stop("dds must be a DESeqTransform object")
    }

    output$ui_computetransform <- renderUI({
      if (is.null(values$mydds))
        return(NULL)
      tagList(
        h4("Select one of the following transformations for your count data:"),
        actionButton("btn_computevst",
                     HTML("Compute variance stabilized </br>transformed data from the <code>dds</code> object"),
                     class = "btn btn-primary", icon = icon("spinner")),
        actionButton("btn_computerlog",
                     HTML("Compute regularized logarithm </br>transformed data from the <code>dds</code> object"),
                     class = "btn btn-primary", icon = icon("spinner")),
        actionButton("btn_computeshiftedlog",
                     HTML("Compute log2 data (with pseudocount 1)</br> from the <code>dds</code> object"),
                     class = "btn btn-primary", icon = icon("spinner"))
      )
    })

    observeEvent(input$btn_computevst, {
      withProgress(message = "Computing the variance stabilized transformed data...",
                   detail = "This step can take a little while",
                   value = 0, {
                     values$mydst <- vst(values$mydds)
                     values$transformation_type <- "vst"
                   })
    })

    observeEvent(input$btn_computerlog, {
      withProgress(message = "Computing the rlog transformed data...",
                   detail = "This step can take a little while",
                   value = 0, {
                     values$mydst <- rlog(values$mydds)
                     values$transformation_type <- "rlog"
                   })
    })

    observeEvent(input$btn_computeshiftedlog,
                 {
                   withProgress(message = "Computing the log2 transformed data...",
                                detail = "This step can take a little while",
                                value = 0, {
                                  values$mydst <- normTransform(values$mydds)
                                  values$transformation_type <- "shiftedlog"
                                })
                 })


    # server renderUI elements --------------------------------------------------------
    output$color_by <- renderUI({
      if (is.null(values$mydds))
        return(NULL)
      poss_covars <- names(colData(values$mydds))
      selectInput("color_by", label = "Group/color by: ",
                  choices = c(NULL, poss_covars), selected = NULL, multiple = TRUE)
    })

    ## Render the UI element to upload the count matrix
    output$upload_count_matrix <- renderUI({
      if (!is.null(dds) | !is.null(countmatrix)) {
        NULL
      } else {
        return(
          tagList(
            wellPanel(
              fileInput(inputId = "uploadcmfile",
                        label = "Upload a count matrix file",
                        accept = c("text/csv", "text/comma-separated-values",
                                   "text/tab-separated-values", "text/plain",
                                   ".csv", ".tsv"), multiple = FALSE,
                        width = "80%"),
              radioButtons(inputId = "uploadcm_sep",
                           label = "Separator",
                           choices = c(Comma = ",", Semicolon = ";", Tab = "\t"),
                           selected = "\t",
                           inline = TRUE)
            )
          )
        )
      }
    })

    readCountmatrix <- reactive({
      if (is.null(input$uploadcmfile))
        return(NULL)
      cm <- utils::read.delim(input$uploadcmfile$datapath, header = TRUE,
                              as.is = TRUE, sep = input$uploadcm_sep, quote = "",
                              row.names = 1, # https://github.com/federicomarini/pcaExplorer/issues/1
                              check.names = FALSE)
      return(cm)
    })

    output$upload_metadata <- renderUI({
      if (!is.null(dds) | !is.null(coldata)) {
        NULL
      } else {
        return(
          tagList(
            wellPanel(
              fileInput(inputId = "uploadmetadatafile",
                        label = "Upload a sample metadata matrix file",
                        accept = c("text/csv", "text/comma-separated-values",
                                   "text/tab-separated-values", "text/plain",
                                   ".csv", ".tsv"), multiple = FALSE,
                        width = "80%"),
              radioButtons(inputId = "uploadmeta_sep",
                           label = "Separator",
                           choices = c(Comma = ",", Semicolon = ";", Tab = "\t"),
                           selected = "\t",
                           inline = TRUE)
            )
          )
        )
      }
    })

    readMetadata <- reactive({
      if (is.null(input$uploadmetadatafile))
        return(NULL)
      coldata <- utils::read.delim(input$uploadmetadatafile$datapath, header = TRUE,
                                   as.is = TRUE, sep = input$uploadmeta_sep, quote = "",
                                   check.names = FALSE)
      return(coldata)
    })

    output$upload_annotation <- renderUI({
      if (!is.null(annotation)) {
        NULL
      } else {
        return(
          tagList(
            wellPanel(
              fileInput(inputId = "uploadannotationfile",
                        label = "Upload an annotation file (optional)",
                        accept = c("text/csv", "text/comma-separated-values",
                                   "text/tab-separated-values", "text/plain",
                                   ".csv", ".tsv"), multiple = FALSE,
                        width = "80%"),
              radioButtons(inputId = "uploadanno_sep",
                           label = "Separator",
                           choices = c(Comma = ",", Semicolon = ";", Tab = "\t"),
                           selected = "\t",
                           inline = TRUE)
            )
          )
        )
      }
    })

    readAnnotation <- reactive({
      if (is.null(input$uploadannotationfile))
        return(NULL)
      annodata <- utils::read.delim(input$uploadannotationfile$datapath, header = TRUE,
                                    as.is = TRUE, sep = input$uploadanno_sep, quote = "",
                                    check.names = FALSE)

      if ("gene_id" %in% colnames(annodata)) {
        rownames(annodata) <- annodata$gene_id
      }
      return(annodata)
    })

    output$ui_showcm <- renderUI({
      shiny::validate(
        need(!is.null(values$mycountmatrix),
             "No count matrix provided, please upload it or pass it as a parameter"
        )
      )
      actionButton(inputId = "show_cm", label = HTML("Show </br>count matrix"), class = "btn btn-success")
    })

    output$ui_showmetadata <- renderUI({
      shiny::validate(
        need(!is.null(values$mymetadata),
             "No sample metadata provided, please upload it or pass it as a parameter"
        )
      )
      actionButton(inputId = "show_metadata", label = HTML("Show </br>sample metadata"), class = "btn btn-success")
    })

    output$ui_showdds <- renderUI({
      shiny::validate(
        need(!is.null(values$mydds),
             "No dds object provided or computed, please upload its components (count matrix and metadata) or pass it as a parameter"
        )
      )
      actionButton(inputId = "show_dds", label = HTML("Show </br><code>dds</code> object"), class = "btn btn-success")
    })

    output$ui_showannotation <- renderUI({
      shiny::validate(
        need(!is.null(values$myannotation),
             "No gene annotation provided, please upload it or pass it as a parameter"
        )
      )
      actionButton(inputId = "show_annotation", label =  HTML("Show </br>gene annotation"), class = "btn btn-success")
    })

    # output$ddsprint <- renderPrint({
    #   values$mydds
    # })

    observeEvent(input$show_cm, {
      showModal(modalDialog(
        title = "Preview - Count matrix",
        div(style = "display:block;overflow-y:auto; overflow-x:auto;",
            DT::renderDataTable(values$mycountmatrix)),
        easyClose = TRUE,
        footer = NULL,
        size = "l"
      ))
    })
    observeEvent(input$show_metadata, {
      showModal(modalDialog(
        title = "Preview - Sample metadata",
        div(style = "display:block;overflow-y:auto; overflow-x:auto;",
            DT::renderDataTable(as.data.frame(values$mymetadata))),
        easyClose = TRUE,
        footer = NULL,
        size = "l"
      ))
    })
    observeEvent(input$show_dds, {
      showModal(modalDialog(
        title = "Preview - dds object",
        renderPrint(values$mydds),
        easyClose = TRUE,
        footer = NULL
      ))
    })
    observeEvent(input$show_annotation, {
      showModal(modalDialog(
        title = "Preview - gene annotation",
        div(style = "display:block;overflow-y:auto; overflow-x:auto;",
            DT::renderDataTable(values$myannotation)),
        easyClose = TRUE,
        footer = NULL,
        size = "l"
      ))
    })

    output$ui_createDDS <- renderUI({
      if (is.null(values$mycountmatrix) | is.null(values$mymetadata))
        return(NULL)
      tagList(
        actionButton("button_diydds", label = HTML("Generate the dds and </br>dst objects"), class = "btn btn-success"),
        shinyBS::bsTooltip(
          "button_diydds",
          paste0("This will create the dds object, normalize it using the DESeq method, and generate ",
                 "a DESeqTransform object, where variance stabilized values are stored by default."),
          "bottom", options = list(container = "body"))
      )
    })

    observeEvent(input$help_format, {
      showModal(modalDialog(
        title = "Format specifications for pcaExplorer",
        includeMarkdown(system.file("extdata", "datainput.md", package = "pcaExplorer")),
        h4("Example:"),
        tags$img(
          src = base64enc::dataURI(file = system.file("www", "help_dataformats.png", package = "pcaExplorer"), mime = "image/png"),
          width = 750
        ),
        easyClose = TRUE,
        footer = NULL,
        size = "l"
      ))
    })

    #####    output$debugdebug <- renderPrint({
    #####      print((ncol(values$mycountmatrix) == nrow(values$mymetadata)))
    #####    })

    observeEvent(input$button_diydds,
                 {
                   withProgress(message = "Computing the objects...", value = 0, {
                     if (ncol(values$mycountmatrix) == nrow(values$mymetadata)) {
                       values$mydds <- DESeqDataSetFromMatrix(countData = values$mycountmatrix,
                                                              colData = values$mymetadata,
                                                              design = ~1)

                       incProgress(0.1, detail = "Computing size factors for normalization")
                       values$mydds <- estimateSizeFactors(values$mydds)
                       incProgress(0.1, detail = "Generating DESeqTransform")
                       values$mydst <- vst(values$mydds)
                       values$transformation_type <- "vst"
                       showNotification("All objects required for the next steps have been computed, good to go!",
                                        type = "message")
                       if (is.null(values$myannotation))
                         showNotification("You might want to provide a gene annotation object, it can help increase the readability of the remainder functions (gene symbols can be displayed instead of ENSEMBL/Entrez ids, ...).")
                     } else {
                       showNotification("You possibly uploaded/provided non matching count data and samples metadata, please inspect these objects in the preview modals below.",
                                        type = "warning")
                     }
                   })
                 }

    )


    # as in http://stackoverflow.com/questions/29716868/r-shiny-how-to-get-an-reactive-data-frame-updated-each-time-pressing-an-actionb
    observeEvent(input$uploadcmfile,
                 {
                   values$mycountmatrix <- readCountmatrix()
                 })

    observeEvent(input$uploadmetadatafile,
                 {
                   values$mymetadata <- readMetadata()
                 })

    observeEvent(input$uploadannotationfile,
                 {
                   values$myannotation <- readAnnotation()
                 })

    # load the demo data
    observeEvent(input$btn_loaddemo, withProgress(
      message = "Loading demo data...",
      detail = "Generating DESeqDataSet", value = 0,
      {
        aw <- requireNamespace("airway", quietly = TRUE)
        if (aw) {
          data_env <- new.env(parent = emptyenv())
          data("airway", envir = data_env, package = "airway")
          airway <- data_env[["airway"]]

          cm_airway <- assay(airway)
          ed_airway <- as.data.frame(colData(airway))

          values$mycountmatrix <- cm_airway
          values$mymetadata <- ed_airway

          # just to be sure, overwrite the annotation and the rest

          values$mydds <- DESeqDataSetFromMatrix(countData = values$mycountmatrix,
                                                 colData = values$mymetadata,
                                                 design = ~cell + dex)
          incProgress(0.1, detail = "Computing size factors for normalization")
          values$mydds <- estimateSizeFactors(values$mydds)
          incProgress(0.1, detail = "Generating DESeqTransform")
          values$mydst <- vst(values$mydds)
          values$transformation_type <- "vst"
          incProgress(0.7, detail = "Retrieving annotation")

          values$myannotation <- get_annotation_orgdb(values$mydds, "org.Hs.eg.db", "ENSEMBL")
          showNotification("All objects required for the next steps have been computed, good to go!",
                           type = "message")
        } else {
          showNotification("The 'airway' package is currently not installed. Please do so by executing BiocManager::install('airway') before launching pcaExplorer", type = "warning")
        }
      })
    )

    colSel <- reactive({
      # find out how many colors to generate: if no factor is selected, either
      # return all say steelblue or all different

      if (!is.null(input$color_by)) {
        expgroups <- as.data.frame(colData(values$mydst)[, input$color_by])
        expgroups <- interaction(expgroups)
      } else {
        expgroups <- factor(colnames(values$mydst))
        # return(rep("steelblue",ncol(values$mydst))) # to return all same
      }

      nrgroups <- length(levels(expgroups))

      if (input$col_palette == "hue"){
        return(hue_pal()(nrgroups))
      }
      # hue_pal()(ncol(values$mydst)/2) # or somewhat other way
      if (input$col_palette == "set1"){
        if (nrgroups <= 9) { # max color nr allowed for set1
          return(brewer_pal(palette = "Set1")(nrgroups))
        } else {
          return(hue_pal()(nrgroups)) # plus print message?
        }
      }
      # (ncol(values$mydst)/2) # or somewhat other way
      if (input$col_palette == "rainbow"){
        return(rainbow(nrgroups))
      }
    })

    output$sessioninfo <- renderPrint({
      sessionInfo()
    })

    output$showdata <- renderPrint({
      values$mydds
    })

    output$showcoldata <- DT::renderDataTable({
      totreads <- (colSums(counts(values$mydds)))
      df <- data.frame(
        colData(values$mydds),
        "Total number of reads" = totreads
      )

      datatable(df)
    })

    current_countmat <- reactive({
      if (input$countstable_unit == "raw_counts")
        return(counts(values$mydds, normalized = FALSE))
      if (input$countstable_unit == "normalized_counts")
        return(counts(values$mydds, normalized = TRUE))
      if (input$countstable_unit == "rlog_counts")
        return(assay(values$mydst))
      if (input$countstable_unit == "log10_counts")
        return(log10(1 + counts(values$mydds, normalized = TRUE)))
      if (input$countstable_unit == "tpm_counts")
        return(NULL) ## TODO!: assumes length of genes/exons as known, and is currently not required in the dds
    })

    output$showcountmat <- DT::renderDataTable({
      datatable(current_countmat())
    })

    output$downloadData <- downloadHandler(
      filename = function() {
        paste0(input$countstable_unit, "table.csv")
      },
      content = function(file) {
        write.csv(current_countmat(), file)
      }
    )

    output$download_genefinder_countstable <- downloadHandler(
      filename = function() {
        paste0("genefinder_pcaE_", "table.csv")
      },
      content = function(file) {

        anno_id <- rownames(values$mydst)
        anno_gene <- values$myannotation$gene_name

        if (is.null(input$color_by) & input$genefinder != "")
          return(NULL)
        if (is.null(input$color_by) & input$genefinder == "")
          return(NULL)
        if (input$genefinder == "")
          return(NULL)
        if (!input$genefinder %in% anno_gene & !input$genefinder %in% anno_id)
          return(NULL)

        if (input$genefinder %in% anno_id) {
          selectedGene <- rownames(values$mydst)[match(input$genefinder, rownames(values$mydst))]
          selectedGeneSymbol <- values$myannotation$gene_name[match(selectedGene, rownames(values$myannotation))]
        }
        if (input$genefinder %in% anno_gene) {
          selectedGeneSymbol <- values$myannotation$gene_name[which(values$myannotation$gene_name == input$genefinder)]
          if (length(selectedGeneSymbol) > 1) return(ggplot() + annotate("text", label = paste0("Type in a gene name/id of the following:\n", paste(selectedGene, collapse = ", ")), 0, 0) + theme_bw())
          selectedGene <- rownames(values$myannotation)[which(values$myannotation$gene_name == input$genefinder)]
        }
        genedata <- plotCounts(values$mydds, gene = selectedGene, intgroup = input$color_by, returnData = TRUE)
        genedata

        write.csv(genedata, file)
      }
    )

    output$corrplot <- renderPlot({
      if (input$compute_pairwisecorr)
        withProgress(
          message = "Generating the scatterplot matrix...",
          detail = "This operation can take a while to render all points",
          value = 0,
          {
            pair_corr(current_countmat(), method = input$corr_method, log = input$corr_uselogs,
                      use_subset = input$corr_usesubset)
          })
    })

    output$heatcorr <- renderPlot({
      if (input$compute_pairwisecorr)
        pheatmap(cor(current_countmat()))
    })

    output$pairwise_plotUI <- renderUI({
      shiny::validate(
        need(input$compute_pairwisecorr,
             "Click on the Run button to generate the scatterplot matrix")
      )
      plotOutput("corrplot", height = "1000px")
    })

    output$heatcorr_plotUI <- renderUI({
      shiny::validate(
        need(input$compute_pairwisecorr,
             "Click on the Run button to generate the heatmap")
      )
      plotOutput("heatcorr")
    })

    # overview on number of detected genes on different threshold types
    output$detected_genes <- renderPrint({
      t1 <- rowSums(counts(values$mydds))
      t2 <- rowMeans(counts(values$mydds, normalized = TRUE))

      thresh_rowsums <- input$threshold_rowsums
      thresh_rowmeans <- input$threshold_rowmeans
      abs_t1 <- sum(t1 > thresh_rowsums)
      rel_t1 <- 100 * mean(t1 > thresh_rowsums)
      abs_t2 <- sum(t2 > thresh_rowmeans)
      rel_t2 <- 100 * mean(t2 > thresh_rowmeans)

      cat("Number of detected genes:\n")
      # TODO: parametrize the thresholds
      cat(abs_t1, "genes have at least a sample with more than", thresh_rowsums, "counts\n")
      cat(paste0(round(rel_t1, 3), "%"), "of the", nrow(values$mydds),
          "genes have at least a sample with more than", thresh_rowsums, "counts\n")
      cat(abs_t2, "genes have more than", thresh_rowmeans, "counts (normalized) on average\n")
      cat(paste0(round(rel_t2, 3), "%"), "of the", nrow(values$mydds),
          "genes have more than", thresh_rowsums, "counts (normalized) on average\n")
      cat("Counts are ranging from", min(counts(values$mydds)), "to", max(counts(values$mydds)))
    })

    output$heatmapsampledist <- renderPlot({
      if(input$sampledist_distance == "euclidean") {
        mydistmat <- as.matrix(dist(t(assay(values$mydst))))
      } else if(input$sampledist_distance == "manhattan") {
        mydistmat <- as.matrix(dist(t(assay(values$mydst)), method = "manhattan"))
      } else {
        # corr based
        mydistmat <- as.matrix(1 - cor(assay(values$mydst)))
      }
      if (!is.null(input$color_by)) {
        expgroups <- as.data.frame(colData(values$mydst)[, input$color_by])
        # expgroups <- interaction(expgroups)
        rownames(expgroups) <- colnames(values$mydst)
        colnames(expgroups) <- input$color_by

        pheatmap(mydistmat, annotation_col = expgroups)
      } else {
        pheatmap(mydistmat)
      }
    })

    output$reads_barplot <- renderPlot({
      rr <- colSums(counts(values$mydds)) / 1e6
      if (is.null(names(rr)))
        names(rr) <- paste0("sample_", 1:length(rr))
      rrdf <- data.frame(Reads = rr, Sample = names(rr), stringsAsFactors = FALSE)
      if (!is.null(input$color_by)) {
        selGroups <- as.data.frame(colData(values$mydds)[input$color_by])
        rrdf$Group <- interaction(selGroups)
        p <- ggplot(rrdf, aes_string("Sample", weight = "Reads")) + geom_bar(aes_string(fill = "Group")) + theme_bw()
        p
      } else {
        p <- ggplot(rrdf, aes_string("Sample", weight = "Reads")) + geom_bar() + theme_bw()

        exportPlots$reads_barplot <- p
        p
      }
    })

    output$reads_summary <- renderPrint({
      print(colSums(counts(values$mydds)))
      summary(colSums(counts(values$mydds)) / 1e6)
    })

    # server samples view --------------------------------------------------------
    output$samples_pca <- renderPlot({
      res <- pcaplot(values$mydst, intgroup = input$color_by, ntop = input$pca_nrgenes,
                     pcX = as.integer(input$pc_x), pcY = as.integer(input$pc_y),
                     text_labels = input$sample_labels,
                     point_size = input$pca_point_size, title = "Samples PCA",
                     ellipse = input$pca_ellipse, ellipse.prob = input$pca_cislider)

      res <- res + theme_bw()
      exportPlots$samplesPca <- res
      res
    })

    output$samples_pca_zoom <- renderPlot({
      shiny::validate(
        need(!is.null(input$pca_brush),
             "Zoom in by brushing in the main plot panel above"
        )
      )
      # if(is.null(input$pca_brush))
      # return(ggplot() + annotate("text",label="zoom in by brushing",0,0) + theme_bw())
      res <- pcaplot(values$mydst, intgroup = input$color_by, ntop = input$pca_nrgenes,
                     pcX = as.integer(input$pc_x), pcY = as.integer(input$pc_y),
                     text_labels = input$sample_labels,
                     point_size = input$pca_point_size, title = "Samples PCA - zoom in",
                     ellipse = input$pca_ellipse, ellipse.prob = input$pca_cislider
      )
      res <- res +
        coord_cartesian(
          xlim = c(input$pca_brush$xmin, input$pca_brush$xmax),
          ylim = c(input$pca_brush$ymin, input$pca_brush$ymax))
      res <- res + theme_bw()
      exportPlots$samplesZoom <- res
      res
    })

    output$samples_scree <- renderPlot({
      rv <- rowVars(assay(values$mydst))
      select <- order(rv, decreasing = TRUE)[seq_len(min(input$pca_nrgenes, length(rv)))]
      pca <- prcomp(t(assay(values$mydst)[select, ]))

      res <- pcascree(pca, type = input$scree_type, pc_nr = input$scree_pcnr, title = "Scree plot for the samples PCA")
      res <- res + theme_bw()
      exportPlots$samplesScree <- res
      res
    })

    output$geneshiload <- renderPlot({
      rv <- rowVars(assay(values$mydst))
      select <- order(rv, decreasing = TRUE)[seq_len(min(input$pca_nrgenes, length(rv)))]
      pca <- prcomp(t(assay(values$mydst)[select, ]))

      par(mfrow = c(2,1))
      hi_loadings(pca, whichpc = as.integer(input$pc_x), topN = input$ntophiload, annotation = values$myannotation)
      hi_loadings(pca, whichpc = as.integer(input$pc_y), topN = input$ntophiload, annotation = values$myannotation)

    })

    output$ui_outliersamples <- renderUI({
      available_samples <- c("", colnames(values$mydst))

      selectInput("outlierselection", label = "Select which sample(s) to remove - suspected outliers", choices = available_samples, multiple = TRUE)
    })

    output$samples_outliersremoved <- renderPlot({

      shiny::validate(
        need(input$outlierselection != "",
             message = "Select at least one sample to plot the new PCA where the selection is removed")
      )

      currentrlt <- values$mydst
      allsamples <- colnames(currentrlt)

      outliersamples <- input$outlierselection
      currentrlt <- currentrlt[, setdiff(allsamples, outliersamples)]

      res <- pcaplot(currentrlt, intgroup = input$color_by, ntop = input$pca_nrgenes,
                     pcX = as.integer(input$pc_x), pcY = as.integer(input$pc_y),
                     text_labels = input$sample_labels,
                     point_size = input$pca_point_size, title = "Samples PCA",
                     ellipse = input$pca_ellipse, ellipse.prob = input$pca_cislider
      )
      res <- res + theme_bw()
      # exportPlots$samplesPca <- res
      exportPlots$samplesOutlier <- res
      res
    })

    output$pca3d <- renderScatterplotThree({
      pcaplot3d(
        values$mydst, intgroup = input$color_by, ntop = input$pca_nrgenes,
        pcX = as.integer(input$pc_x), pcY = as.integer(input$pc_y), pcZ = as.integer(input$pc_z))
    })

    # server genes view ---------------------------------------------------------------
    output$genes_biplot <- renderPlot({
      if (!is.null(input$color_by)) {
        expgroups <- as.data.frame(colData(values$mydst)[, input$color_by])
        expgroups <- interaction(expgroups)
        expgroups <- factor(expgroups, levels = unique(expgroups))

      } else {
        expgroups <- colnames(values$mydst)
      }
      colGroups <- colSel()[factor(expgroups)]

      res <- genespca(values$mydst,
                      ntop = input$pca_nrgenes,
                      choices = c(as.integer(input$pc_x), as.integer(input$pc_y)),
                      biplot = TRUE,
                      arrowColors = factor(colGroups, levels = unique(colGroups)),
                      groupNames = expgroups,
                      alpha=input$pca_point_alpha, coordEqual = FALSE, useRownamesAsLabels = FALSE, labels.size = input$pca_label_size,
                      point_size = input$pca_point_size, varname.size = input$pca_varname_size, scaleArrow = input$pca_scale_arrow, annotation = values$myannotation)
      exportPlots$genesPca <- res
      res
    })

    output$genes_biplot_zoom <- renderPlot({
      shiny::validate(
        need(
          !is.null(input$pcagenes_brush),
          "Zoom in by brushing in the main panel - this will also allow displaying the gene names"
        )
      )

      if (!is.null(input$color_by)) {
        expgroups <- as.data.frame(colData(values$mydst)[, input$color_by])
        expgroups <- interaction(expgroups)
        expgroups <- factor(expgroups, levels = unique(expgroups))
      } else {
        expgroups <- colnames(values$mydst)
      }
      colGroups <- colSel()[factor(expgroups)]

      res <- genespca(values$mydst,
                      ntop = input$pca_nrgenes,
                      choices = c(as.integer(input$pc_x), as.integer(input$pc_y)),
                      biplot = TRUE,
                      arrowColors = factor(colGroups, levels = unique(colGroups)),
                      groupNames = expgroups,
                      alpha = input$pca_point_alpha, coordEqual = FALSE,
                      var.axes = input$variable_labels, # workaround for a ggplot2 bug/missing thing: here details: https://github.com/hadley/ggplot2/issues/905
                      labels.size = input$pca_label_size, varname.size = input$pca_varname_size,
                      scaleArrow = input$pca_scale_arrow, point_size = input$pca_point_size, annotation = values$myannotation)

      res <- res +
        coord_cartesian(
          xlim = c(input$pcagenes_brush$xmin, input$pcagenes_brush$xmax),
          ylim = c(input$pcagenes_brush$ymin, input$pcagenes_brush$ymax))
      exportPlots$genesZoom <- res
      res
    })

    output$genes_profileexplorer <- renderPlot({
      shiny::validate(
        need(
          !is.null(input$pcagenes_brush),
          "Zoom in by brushing in the main panel"
        )
      )
      shiny::validate(
        need(
          length(input$color_by) > 0,
          "Select an experimental factor in the Group/color by element in the sidebar"
        )
      )
      geneprofiler(values$mydst,
                   genelist = curData_brush()$ids,
                   intgroup = input$color_by,
                   plotZ = input$zprofile)
    })

    output$genes_biplot_boxplot <- renderPlot({
      shiny::validate(
        need(
          length(input$color_by) > 0,
          "Select an experimental factor in the Group/color by element in the sidebar"
        )
      )
      shiny::validate(
        need(
          !is.null(input$pcagenes_zoom_click),
          "Click the plot above to generate the boxplot for the selected gene"
        )
      )
      selectedGene <- curData_zoomClick()$ids
      selectedGeneSymbol <- values$myannotation$gene_name[match(selectedGene, rownames(values$myannotation))]
      # plotCounts(dds_cleaner,)

      shiny::validate(
        need(nrow(curData_zoomClick()) > 0, message = "Click closer to a gene to get the boxplot")

      )

      genedata <- plotCounts(values$mydds, gene = selectedGene, intgroup = input$color_by, returnData = TRUE)

      onlyfactors <- genedata[, match(input$color_by, colnames(genedata))]
      genedata$plotby <- interaction(onlyfactors)

      genedata$sampleID <- rownames(genedata)

      if (input$plot_style == "boxplot") {
        plot_style <- "boxplot"
      } else if (input$plot_style == "violin plot") {
        plot_style <- "violin"
      } else {
        plot_style <- "auto"
      }
      
      res <- mosdef::gene_plot(de_container = values$mydds,
                               gene = selectedGene,
                               intgroup = input$color_by,
                               annotation_obj = values$myannotation,
                               normalized = TRUE,
                               plot_type = plot_style)
      
      if (input$ylimZero_genes) {
        res <- res + scale_y_log10(name = "Normalized counts - log10 scale", limits = c(0.4, NA))
      } else {
        res <- res + scale_y_log10(name = "Normalized counts - log10 scale")
      }
      
      res <- res +
        labs(title = paste0("Normalized counts for ", selectedGeneSymbol, " - ", selectedGene)) +
        scale_x_discrete(name = "") +
        scale_fill_discrete(name = "Experimental\nconditions")
      
      exportPlots$genesBoxplot <- res
      
      res
    })

    # for reading in the brushed/clicked points
    curData_brush <- reactive({
      df2 <- genespca(values$mydst,
                      ntop = input$pca_nrgenes,
                      choices = c(as.integer(input$pc_x), as.integer(input$pc_y)),
                      biplot = TRUE,
                      # arrowColors = colGroups,
                      alpha = input$pca_point_alpha,
                      returnData = TRUE, annotation = values$myannotation)
      df2$geneName <- values$myannotation$gene_name[match(rownames(df2), rownames(values$myannotation))]
      res <- brushedPoints(df2, input$pcagenes_brush, xvar = "xvar", yvar = "yvar")
      res
    })

    curData_click <- reactive({
      df2 <- genespca(values$mydst,
                      ntop = input$pca_nrgenes,
                      choices = c(as.integer(input$pc_x), as.integer(input$pc_y)),
                      biplot = TRUE,
                      # arrowColors = colGroups,
                      alpha = input$pca_point_alpha,
                      returnData = TRUE, annotation = values$myannotation)
      df2$geneName <- values$myannotation$gene_name[match(rownames(df2), rownames(values$myannotation))]
      res <- nearPoints(df2, input$pcagenes_click,
                        threshold = 20, maxpoints = 3,
                        addDist = TRUE)
      res
    })

    # data to be used for plotting the picked gene from the zoomed panel
    curData_zoomClick <- reactive({
      df2 <- genespca(values$mydst,
                      ntop = input$pca_nrgenes,
                      choices = c(as.integer(input$pc_x), as.integer(input$pc_y)),
                      biplot = TRUE,
                      # arrowColors = colGroups,
                      alpha = input$pca_point_alpha,
                      returnData = TRUE, annotation = values$myannotation)
      df2$geneName <- values$myannotation$gene_name[match(rownames(df2), rownames(values$myannotation))]
      res <- nearPoints(df2, input$pcagenes_zoom_click,
                        threshold = 20, maxpoints = 1,
                        addDist = TRUE)
      res
    })

    output$pca_brush_out <- DT::renderDataTable({
      datatable(curData_brush(), options = list(pageLength = 50))
    })

    output$pca_click_out <- DT::renderDataTable({
      datatable(curData_click(), options = list(pageLength = 50))
    })

    output$heatzoomly <- renderPlotly({
      shiny::validate(
        need(
          !is.null(input$pcagenes_brush),
          "Brush the main panel above to generate a heatmap"
        )
      )
      brushedObject <- curData_brush()
      shiny::validate(
        need(
          nrow(brushedObject) > 1,
          "Brush to include at least two genes"
        )
      )

      selectedGenes <- brushedObject$ids
      toplot <- assay(values$mydst)[selectedGenes, ]
      rownames(toplot) <- values$myannotation$gene_name[match(rownames(toplot), rownames(values$myannotation))]

      mycolss <- c("#313695", "#4575b4", "#74add1", "#abd9e9", "#e0f3f8", "#fee090", "#fdae61", "#f46d43", "#d73027", "#a50026") # to be consistent with red/blue usual coding

      heatmaply(toplot, Colv = as.logical(input$heatmap_colv), colors = mycolss)
    })

    output$heatzoom <- renderPlot({
      shiny::validate(
        need(
          !is.null(input$pcagenes_brush),
          "Brush the main panel above to generate a heatmap"
        )
      )

      brushedObject <- curData_brush()
      shiny::validate(
        need(
          nrow(brushedObject) > 1,
          "Brush to include at least two genes"
        )
      )
      selectedGenes <- brushedObject$ids
      toplot <- assay(values$mydst)[selectedGenes, ]
      rownames(toplot) <- values$myannotation$gene_name[match(rownames(toplot), rownames(values$myannotation))]
      # pheatmap(toplot,cluster_cols = as.logical(input$heatmap_colv))
      NMF::aheatmap(toplot, Colv = as.logical(input$heatmap_colv))
      ## aheatmap is actually consistent in displaying the clusters with most of other heatmap packages
      ## keep in mind: pheatmap does somehow a better job if scaling/centering
    })

    # server gene finder ---------------------------------------------------------------
    output$searchresult <- renderPrint({
      if (is.null(input$color_by)) return("Select a factor to plot your gene")
      if (input$genefinder == "")
        return("Type in the gene name/id you want to plot")

      foundGeneID <- input$genefinder %in% rownames(values$mydst)
      foundGeneName <- input$genefinder %in% values$myannotation$gene_name
      if (!foundGeneID){
        foundGeneID <- toupper(input$genefinder) %in% toupper(rownames(values$mydst))
        if (foundGeneID) {
          return(paste0("Maybe you mis-spelled the name of your gene. Did you mean ",
                        unique(rownames(values$myannotation)[which(toupper(input$genefinder) == toupper(rownames(values$myannotation)))]), "?"))
        } else {
          foundGeneNAME <- input$genefinder %in% values$myannotation$gene_name
          if (!foundGeneNAME) {
            foundGeneNAME <- toupper(input$genefinder) %in% toupper(values$myannotation$gene_name)
            if (foundGeneNAME) {
              return(paste0("Maybe you mis-spelled the name of your gene. Did you mean ",
                            unique(values$myannotation$gene_name[which(toupper(input$genefinder) == toupper(values$myannotation$gene_name))]), "?"))
            } else {
              return("Could not find the gene you typed!")
            }
          } else {
            fgn <- values$myannotation$gene_name[which(values$myannotation$gene_name == input$genefinder)]
            if (length(fgn) > 1) return(paste0("Found more than one gene with the selected gene name. Select one of the following: ", paste(selectedGene, collapse = ", ")))
            selectedGene <- rownames(values$myannotation)[which(values$myannotation$gene_name == input$genefinder)]

            fg <- rownames(values$myannotation)[match(fgn, values$myannotation$gene_name)]
            return(paste0("I found the gene! Plotting ", fg, " - ", values$myannotation$gene_name[match(fg, rownames(values$myannotation))], "..."))

          }}
      } else {
        fg <- rownames(values$myannotation)[match(input$genefinder, rownames(values$mydst))]
        return(paste0("I found the gene! Plotting ", fg, " - ", values$myannotation$gene_name[match(fg, rownames(values$myannotation))], "..."))

      }
    })

    output$genefinder_plot <- renderPlot({
      anno_id <- rownames(values$mydst)
      anno_gene <- values$myannotation$gene_name

      if (is.null(input$color_by) & input$genefinder != "")
        return(ggplot() + annotate("text", label = "Select a factor to plot your gene", 0, 0) + theme_bw())
      if (is.null(input$color_by) & input$genefinder == "")
        return(ggplot() + annotate("text", label = "Select a gene and a factor to plot gene", 0, 0) + theme_bw())
      if (input$genefinder == "")
        return(ggplot() + annotate("text", label = "Type in a gene name/id", 0, 0) + theme_bw())
      if (!input$genefinder %in% anno_gene & !input$genefinder %in% anno_id)
        return(ggplot() + annotate("text", label = "Gene not found...", 0, 0) + theme_bw())

      if (input$genefinder %in% anno_id) {
        selectedGene <- rownames(values$mydst)[match(input$genefinder, rownames(values$mydst))]
        selectedGeneSymbol <- values$myannotation$gene_name[match(selectedGene, rownames(values$myannotation))]
      }
      if (input$genefinder %in% anno_gene) {
        selectedGeneSymbol <- values$myannotation$gene_name[which(values$myannotation$gene_name == input$genefinder)]
        if (length(selectedGeneSymbol) > 1) return(ggplot() + annotate("text", label = paste0("Type in a gene name/id of the following:\n", paste(selectedGene, collapse = ", ")), 0, 0) + theme_bw())
        selectedGene <- rownames(values$myannotation)[which(values$myannotation$gene_name == input$genefinder)]
      }
      genedata <- plotCounts(values$mydds, gene = selectedGene, intgroup = input$color_by, returnData = TRUE)
      onlyfactors <- genedata[, match(input$color_by, colnames(genedata))]
      genedata$plotby <- interaction(onlyfactors)
      genedata$sampleID <- rownames(genedata)
      
      if (input$plot_style == "boxplot") {
        plot_style <- "boxplot"
      } else if (input$plot_style == "violin plot") {
        plot_style <- "violin"
      } else {
        plot_style <- "auto"
      }
      
      res <- mosdef::gene_plot(de_container = values$mydds,
                               gene = selectedGene,
                               intgroup = input$color_by,
                               annotation_obj = values$myannotation,
                               normalized = TRUE,
                               labels_display = input$addsamplelabels,
                               plot_type = plot_style)
      
      if (input$ylimZero) {
        res <- res + scale_y_log10(name = "Normalized counts - log10 scale", limits = c(0.4, NA))
      } else {
        res <- res + scale_y_log10(name = "Normalized counts - log10 scale")
      }
      
      res <- res +
        labs(title = paste0("Normalized counts for ", selectedGeneSymbol, " - ", selectedGene)) +
        scale_x_discrete(name = "") +
        scale_fill_discrete(name = "Experimental\nconditions")
      
      exportPlots$genefinder_countsplot <- res
      
      res
      
    })

    output$genefinder_table <- DT::renderDataTable({
      anno_id <- rownames(values$mydst)
      anno_gene <- values$myannotation$gene_name

      if (is.null(input$color_by) & input$genefinder != "")
        return(NULL)
      if (is.null(input$color_by) & input$genefinder == "")
        return(NULL)
      if (input$genefinder == "")
        return(NULL)
      if (!input$genefinder %in% anno_gene & !input$genefinder %in% anno_id)
        return(NULL)

      if (input$genefinder %in% anno_id) {
        selectedGene <- rownames(values$mydst)[match(input$genefinder, rownames(values$mydst))]
        selectedGeneSymbol <- values$myannotation$gene_name[match(selectedGene, rownames(values$myannotation))]
      }
      if (input$genefinder %in% anno_gene) {
        selectedGeneSymbol <- values$myannotation$gene_name[which(values$myannotation$gene_name == input$genefinder)]
        if (length(selectedGeneSymbol) > 1) return(ggplot() + annotate("text", label = paste0("Type in a gene name/id of the following:\n", paste(selectedGene, collapse = ", ")), 0, 0) + theme_bw())
        selectedGene <- rownames(values$myannotation)[which(values$myannotation$gene_name == input$genefinder)]
      }
      genedata <- plotCounts(values$mydds, gene = selectedGene, intgroup = input$color_by, returnData = TRUE)
      genedata
    })

    # server pca2go ---------------------------------------------------------------
    output$ui_computePCA2GO <- renderUI({
      if (is.null(pca2go))
        actionButton("computepca2go", "Compute the PCA2GO object", icon = icon("spinner"), class = "btn btn-primary")
    })

    annoSpecies_df <- data.frame(
      species = c("", "Anopheles", "Arabidopsis", "Bovine", "Worm",
                  "Canine", "Fly", "Zebrafish", "E coli strain K12",
                  "E coli strain Sakai", "Chicken", "Human", "Mouse",
                  "Rhesus", "Malaria", "Chimp", "Rat",
                  "Yeast", "Streptomyces coelicolor", "Pig", "Toxoplasma gondii",
                  "Xenopus"),
      pkg = c("", "org.Ag.eg.db", "org.At.tair.db", "org.Bt.eg.db", "org.Ce.eg.db",
              "org.Cf.eg.db", "org.Dm.eg.db", "org.Dr.eg.db", "org.EcK12.eg.db",
              "org.EcSakai.eg.db", "org.Gg.eg.db", "org.Hs.eg.db", "org.Mm.eg.db",
              "org.Mmu.eg.db", "org.Pf.plasmo.db", "org.Pt.eg.db", "org.Rn.eg.db",
              "org.Sc.sgd.db", "org.Sco.eg.db", "org.Ss.eg.db", "org.Tgondii.eg.db",
              "org.Xl.eg.db"),
      stringsAsFactors = FALSE)
    annoSpecies_df <- annoSpecies_df[order(annoSpecies_df$species), ]
    annoSpecies_df <- annoSpecies_df[annoSpecies_df$species %in% c("", "Human", "Mouse", "Rat", "Fly", "Chimp"), ]

    output$ui_selectspecies <- renderUI({
      if (is.null(values$mypca2go)) {
        selectInput("speciesSelect", label = "Select the species of your samples", choices = annoSpecies_df$species, selected = "")
      }
    })
    output$ui_inputtype <- renderUI({
      if (is.null(values$mypca2go)) {
        selectInput("idtype", label = "Select the input type of your identifiers",
                    choices = c("ENSEMBL", "SYMBOL", "REFSEQ", "ENTREZID"), selected = "ENSEMBL")
      }
    })

    output$speciespkg <- renderText({
      if (!is.null(pca2go))
        return("pca2go object provided")
      if (!is.null(values$mypca2go))
        return("pca2go object computed or provided")
      shiny::validate(
        need(input$speciesSelect != "",
             "Select a species - requires the corresponding annotation package"
        )
      )
      annopkg <- annoSpecies_df$pkg[annoSpecies_df$species == input$speciesSelect]
      shiny::validate(
        need(require(annopkg, character.only = TRUE),
             paste0("The package ", annopkg, " is not installed/available. Try installing it with BiocManager::install('", annopkg, "')"))
      )

      retmsg <- paste0(annopkg, " - package available and loaded")
      # if (!require(annopkg,character.only=TRUE)) {
      # stop("The package",annopkg, "is not installed/available. Try installing it with BiocManager::install() ?")
      # }
      retmsg <- paste0(retmsg, " - ", gsub(".eg.db", "", gsub("org.", "", annopkg)))
      retmsg
    })

    computedPCA2GO <- eventReactive(input$computepca2go, {
      annopkg <- annoSpecies_df$pkg[annoSpecies_df$species == input$speciesSelect]
      withProgress(
        message = "Computing the PCA2GO object...",
        detail = "This operation can take a while.",
        value = 0,
        {
          pcpc <- limmaquickpca2go(values$mydst, background_genes = rownames(values$mydds),
                                   inputType = input$idtype,
                                   organism = gsub(".eg.db", "", gsub("org.", "", annopkg)))
        })
      pcpc
    })

    observeEvent(input$computepca2go,
                 {
                   values$mypca2go <- computedPCA2GO()
                 })

    output$pca2go <- renderPlot({
      shiny::validate(
        need(
          !is.null(values$mypca2go),
          "Please provide a pca2go object to the app or alternatively click on the action button - could take some time to compute live!"
        )
      )
      res <-
        pcaplot(
          values$mydst, intgroup = input$color_by,
          ntop = attr(values$mypca2go, "n_genesforpca"),
          pcX = as.integer(input$pc_x), pcY = as.integer(input$pc_y),
          text_labels = input$sample_labels,
          point_size = input$pca_point_size,
          title = paste0(
            "PCA on the samples - ", attr(values$mypca2go, "n_genesforpca"), " genes used"
          ),
          ellipse = input$pca_ellipse, ellipse.prob = input$pca_cislider
        )
      res
    })

    output$dt_pchor_pos <- DT::renderDataTable({
      if (is.null(values$mypca2go)) return(datatable(NULL))
      goe <- values$mypca2go[[paste0("PC", input$pc_x)]][["posLoad"]]
      if (input$compact_pca2go & ("p.value_elim" %in% colnames(goe)))
        return(datatable(goe[, c("GO.ID", "Term", "Significant", "p.value_elim")], options = list(pageLength = 5)))
      datatable(goe)
    })

    output$dt_pchor_neg <- DT::renderDataTable({
      if (is.null(values$mypca2go)) return(datatable(NULL))
      goe <- values$mypca2go[[paste0("PC", input$pc_x)]][["negLoad"]]
      if (input$compact_pca2go & ("p.value_elim" %in% colnames(goe)))
        return(datatable(goe[, c("GO.ID", "Term", "Significant", "p.value_elim")], options = list(pageLength = 5)))
      datatable(goe)
    })

    output$dt_pcver_pos <- DT::renderDataTable({
      if (is.null(values$mypca2go)) return(datatable(NULL))
      goe <- values$mypca2go[[paste0("PC", input$pc_y)]][["posLoad"]]
      if (input$compact_pca2go & ("p.value_elim" %in% colnames(goe)))
        return(datatable(goe[, c("GO.ID", "Term", "Significant", "p.value_elim")], options = list(pageLength = 5)))
      datatable(goe)
    })

    output$dt_pcver_neg <- DT::renderDataTable({
      if (is.null(values$mypca2go)) return(datatable(NULL))
      goe <- values$mypca2go[[paste0("PC", input$pc_y)]][["negLoad"]]
      if (input$compact_pca2go & ("p.value_elim" %in% colnames(goe)))
        return(datatable(goe[, c("GO.ID", "Term", "Significant", "p.value_elim")], options = list(pageLength = 5)))
      datatable(goe)
    })

    output$enrichinfo <- renderPrint({
      cat("enrich info:\n")
      # str(goEnrichs)
      class(input$pc_x)
      head(values$mypca2go[[paste0("PC", input$pc_x)]][["posLoad"]])
      class(datatable(values$mypca2go[[paste0("PC", input$pc_x)]][["posLoad"]]))
    })

    # server multifactor exploration ----------------------------------------------------------
    output$intro_multifac <- renderText({
      if (!is.null(values$mydds))
        shiny::validate(
          need(ncol(colData(values$mydds)) > 1,
               message = "To use this section, you need a dataset where more than one experimental factor is available.")
        )
      return("Refer to the Instructions section if you need help on using this section")
    })

    output$covar1 <- renderUI({
      # if(is.null(values$mydst))
      # return(NULL)
      poss_covars <- names(colData(values$mydds))
      selectInput("covar1", label = "Select factor 1: ",
                  choices = c(NULL, poss_covars), selected = NULL, multiple = FALSE)
    })

    output$covar2 <- renderUI({
      # if(is.null(values$mydst))
      # return(NULL)
      poss_covars <- names(colData(values$mydds))
      selectInput("covar2", label = "Select factor 2: ",
                  choices = c(NULL, poss_covars), selected = NULL, multiple = FALSE)
    })

    output$c1levels <- renderUI({
      if (is.null(input$covar1))
        return(NULL)
      fac1lev <- levels(colData(values$mydst)[[input$covar1]])
      selectInput("covar1levels", label = "Factor 1 available levels: ",
                  choices = c(NULL, fac1lev), selected = NULL, multiple = TRUE) # actually 2
    })

    output$c2levels <- renderUI({
      if (is.null(input$covar2))
        return(NULL)
      fac2lev <- levels(colData(values$mydst)[[input$covar2]])
      selectInput("covar2levels", label = "Factor 2 available levels: ",
                  choices = c(NULL, fac2lev), selected = NULL, multiple = TRUE) # 2 or more are allowed!
    })

    output$colnames1 <- renderUI({
      if (is.null(values$mydst))
        return(NULL)
      if (is.null(input$covar1))
        return(NULL)
      if (is.null(input$covar2))
        return(NULL)

      fac1 <- input$covar1
      fac2 <- input$covar2

      fac1_touse <- input$covar1levels
      fac2_touse <- input$covar2levels

      preselected_fac1 <- colnames(values$mydst)[colData(values$mydst)[[fac1]] %in% fac1_touse]
      preselected_fac2 <- colnames(values$mydst)[colData(values$mydst)[[fac2]] %in% fac2_touse]
      presel <- intersect(preselected_fac1, preselected_fac2)
      mysamples <- colData(values$mydst)[presel, ] # check that the repl are balanced

      presel1 <- colnames(values$mydst)[(colData(values$mydst)[[fac1]] %in% fac1_touse[1]) & colData(values$mydst)[[fac2]] %in% fac2_touse]

      selectInput(
        "picksamples1", label = "Combine samples from Factor1-Level1 in the selected order: ",
        choices = c(NULL, presel1), selected = NULL, multiple = TRUE)
    })

    output$colnames2 <- renderUI({
      if (is.null(values$mydst))
        return(NULL)
      if (is.null(input$covar1))
        return(NULL)
      if (is.null(input$covar2))
        return(NULL)

      fac1 <- input$covar1
      fac2 <- input$covar2

      fac1_touse <- input$covar1levels
      fac2_touse <- input$covar2levels

      preselected_fac1 <- colnames(values$mydst)[colData(values$mydst)[[fac1]] %in% fac1_touse]
      preselected_fac2 <- colnames(values$mydst)[colData(values$mydst)[[fac2]] %in% fac2_touse]
      presel <- intersect(preselected_fac1, preselected_fac2)
      mysamples <- colData(values$mydst)[presel, ] # check that the repl are balanced

      presel2 <- colnames(values$mydst)[(colData(values$mydst)[[fac1]] %in% fac1_touse[2]) & colData(values$mydst)[[fac2]] %in% fac2_touse]
      selectInput("picksamples2", label = "Combine samples from Factor1-Level2 in the selected order: ",
                  choices = c(NULL, presel2), selected = NULL, multiple = TRUE)
    })

    composedMat <- eventReactive(input$composemat, {
      exprmat <- t(assay(values$mydst))
      exprmat <- exprmat[, rowSums(counts(values$mydds) > 5) > 2]

      withProgress(message = "Composing the matrix...",
                   value = 0,
                   {
                     pcmat <- cbind(exprmat[input$picksamples1, ],
                                    exprmat[input$picksamples2, ])
                   })
      pcmat
    })

    obj3 <- reactive({
      pcmat <- composedMat()
      aval <- 0.3
      fac2pal <- alpha(c("green", "red", "blue", "orange", "violet"), aval) # 5 are enough
      # colData(values$mydst)[input$covar2][rownames(pcmat),]
      max.type <- apply(pcmat[, 1:(ncol(pcmat)/2)], 2, which.max)

      fac2_col <- factor(colData(values$mydst)[input$covar2][rownames(pcmat), ],
                         levels = unique(as.character(colData(values$mydst)[input$covar2][rownames(pcmat), ])))
      tcol.justMax <- fac2pal[fac2_col][max.type]
      # tcol.justMax <- ifelse(max.type <= 4,"green",ifelse(max.type <= 8,"red",ifelse(max.type <= 12,"blue","orange")))

      max.type2 <- apply(pcmat[, ((ncol(pcmat) / 2) + 1):ncol(pcmat)], 2, which.max)
      # tcol2.justMax <- ifelse(max.type2 <= 4,alpha("green",aval),ifelse(max.type2 <= 8,alpha("red",aval),ifelse(max.type2 <= 12,alpha("blue",aval),alpha("orange",aval))))

      tcol2.justMax <- fac2pal[fac2_col][max.type2]

      # using the median across replicates
      celltypes <- gsub("_R.", "", rownames(pcmat))

      tcol <- tcol.justMax
      tcol2 <- tcol2.justMax
      # pcmat
      return(list(pcmat, tcol, tcol2))
    })

    output$pcamultifac <- renderPlot({
      pcmat <- obj3()[[1]]
      tcol <- obj3()[[2]]
      tcol2 <- obj3()[[3]]
      pres <- prcomp(t(pcmat), scale=FALSE)

      plot.index <- c(as.integer(input$pc_x_multifac), as.integer(input$pc_y_multifac))
      offset <- ncol(pcmat) / 2
      gene.no <- offset
      pcx <- pres$x
      # set.seed(11)
      # for (i in 1:ncol(pcx)) {
      #   pcx[,i] <- pcx[,i] + rnorm(nrow(pcx),sd=diff(range(pcx[,i]))/100)
      # }
      plot(pcx[(offset + 1):ncol(pcmat), plot.index[1]][1:gene.no],
           pcx[(offset + 1):ncol(pcmat), plot.index[2]][1:gene.no], xlim = range(pcx[, plot.index[1]]), ylim = range(pcx[, plot.index[2]]), pch = 20, col = tcol, cex = 0.3)#,type="n")
      #plot(0,type="n",xlim=range(pres$x[,plot.index]),ylim=range(pres$x[,plot.index]))
      lcol <- ifelse(tcol != tcol2, "black", "grey")
      for (i in 1:gene.no) {
        lines(pcx[c(i, offset + i), plot.index[1]], pcx[c(i, offset + i), plot.index[2]], col = lcol[i])
      }
      points(pcx[1:offset, plot.index[1]][1:gene.no], pcx[1:offset, plot.index[2]][1:gene.no], pch = 20, col = tcol, cex = 0.3)
      points(pcx[(offset + 1):ncol(pcmat), plot.index[1]][1:gene.no], pcx[(offset + 1):ncol(pcmat), plot.index[2]][1:gene.no], pch = 20, col = tcol2, cex = 0.3)
    })

    output$multifaczoom <- renderPlot({
      if (is.null(input$pcamultifac_brush)) return(NULL)
      pcmat <- obj3()[[1]]
      tcol <- obj3()[[2]]
      tcol2 <- obj3()[[3]]
      pres <- prcomp(t(pcmat), scale = FALSE)

      plot.index <- c(as.integer(input$pc_x_multifac), as.integer(input$pc_y_multifac))
      offset <- ncol(pcmat) / 2
      gene.no <- offset
      pcx <- pres$x

      plot(pcx[(offset + 1):ncol(pcmat), plot.index[1]][1:gene.no],
           pcx[(offset + 1):ncol(pcmat), plot.index[2]][1:gene.no],
           xlim = c(input$pcamultifac_brush$xmin, input$pcamultifac_brush$xmax),
           ylim = c(input$pcamultifac_brush$ymin, input$pcamultifac_brush$ymax),
           pch = 20, col = tcol, cex = 0.3)#,type="n")
      #plot(0,type="n",xlim=range(pres$x[,plot.index]),ylim=range(pres$x[,plot.index]))
      lcol <- ifelse(tcol != tcol2, "black", "grey")
      for (i in 1:gene.no) {
        lines(pcx[c(i, offset + i), plot.index[1]], pcx[c(i, offset + i), plot.index[2]], col = lcol[i])
      }
      points(pcx[1:offset, plot.index[1]][1:gene.no], pcx[1:offset, plot.index[2]][1:gene.no], pch = 20, col = tcol, cex = 0.3)
      points(pcx[(offset + 1):ncol(pcmat), plot.index[1]][1:gene.no], pcx[(offset + 1):ncol(pcmat),plot.index[2]][1:gene.no], pch = 20, col = tcol2, cex = 0.3)

    })

    curData_brush_multifac <- reactive({
      pcmat <- obj3()[[1]]
      tcol <- obj3()[[2]]
      tcol2 <- obj3()[[3]]

      pres <- prcomp(t(pcmat), scale = FALSE)

      plot.index <- c(as.integer(input$pc_x_multifac), as.integer(input$pc_y_multifac))
      offset <- ncol(pcmat) / 2
      gene.no <- offset
      pcx <- pres$x

      firstPCselected <- c(
        pcx[1:offset, plot.index[1]][1:gene.no],
        pcx[(offset + 1):ncol(pcmat), plot.index[1]][1:gene.no])

      secondPCselected <- c(
        pcx[1:offset, plot.index[2]][1:gene.no],
        pcx[(offset + 1):ncol(pcmat), plot.index[2]][1:gene.no])

      pcspcs <- data.frame(firstPC = firstPCselected, secondPC = secondPCselected, geneID = colnames(pcmat))
      rownames(pcspcs) <- c(paste0(colnames(pcmat)[1:gene.no], "_WT"),
                            paste0(colnames(pcmat)[(gene.no + 1) : (2 * gene.no)], "_G37"))

      if (!is.null(values$myannotation))
        pcspcs$geneName <- values$myannotation$gene_name[match(pcspcs$geneID, rownames(values$myannotation))]

      res <- brushedPoints(pcspcs, input$pcamultifac_brush, xvar = "firstPC", yvar = "secondPC")
      res
    })

    output$pcamultifac_out <- DT::renderDataTable({
      datatable(curData_brush_multifac())
    })

    output$downloadData_brush_multifac <- downloadHandler(
      filename = function() { paste(input$brushedPoints_filename_multifac, ".csv", sep = "") },
      content = function(file) {
        if (length(input$pcamultifac_out_rows_selected)){
          data <- curData_brush_multifac()[input$pcamultifac_out_rows_selected, ]
        } else {
          data <- curData_brush_multifac()
        }
        write.csv(data, file, quote = FALSE)
      }
    )

    # server report editor ---------------------------------------------------------
    ### yaml generation
    rmd_yaml <- reactive({
      paste0("---",
             "\ntitle: '", input$report_title,
             "'\nauthor: '", input$report_author,
             "'\ndate: '", Sys.Date(),
             "'\noutput:\n  html_document:\n    toc: ", input$report_toc, "\n    number_sections: ", input$report_ns, "\n    theme: ", input$report_theme, "\n---\n\n", collapse = "\n")
    })

    # rmd_full <- reactive({
    #   paste0(rmd_yaml(),"\n",
    #          readLines("reportTemplate.Rmd"))
    # })
    # output$loadedRmd <- renderPrint({
    #   # rmd_yaml() # or rmd_full()
    #   paste0(
    #     # rmd_yaml(),
    #     paste0(readLines("reportTemplate.Rmd"),collapse = "\n"))
    #   # head(paste0(rmd_yaml(),
    #   # readLines("reportTemplate.Rmd")),collapse="\n")
    # })

    ### loading report template
    # update aceEditor module
    observe({
      # loading rmd report from disk
      inFile <- system.file("extdata", "reportTemplate.Rmd", package = "pcaExplorer")
      isolate({
        if (!is.null(inFile) && !is.na(inFile)) {

          rmdfilecontent <- paste0(readLines(inFile), collapse = "\n")

          shinyAce::updateAceEditor(session, "acereport_rmd", value = rmdfilecontent)
        }
      })
    })

    ### ace editor options
    observe({
      autoComplete <- if (input$enableAutocomplete) {
        if (input$enableLiveCompletion) "live" else "enabled"
      } else {
        "disabled"
      }
      updateAceEditor(session, "acereport_rmd", autoComplete = autoComplete, theme = input$theme, mode = input$mode)
      # updateAceEditor(session, "plot", autoComplete = autoComplete)
    })

    #Enable/Disable R code completion
    rmdOb <- aceAutocomplete("acereport_rmd")
    observe({
      if (input$enableRCompletion) {
        rmdOb$resume()
      } else {
        rmdOb$suspend()
      }
    })

    ## currently not working as I want with rmarkdown::render, but can leave it like this - the yaml will be taken in the final version only
    output$knitDoc <- renderUI({
      input$updatepreview_button
      return(
        withProgress(
          message = "Updating the report in the app body",
          detail = "This can take some time",
          {
            # temporarily switch to the temp dir, in case you do not have write
            # permission to the current working directory
            owd <- setwd(tempdir())
            on.exit(setwd(owd))
            tmp_content <- paste0(rmd_yaml(), input$acereport_rmd, collapse = "\n")
            incProgress(0.5, detail = "Rendering report...")
            htmlpreview <- knit2html(text = tmp_content, template = FALSE, quiet = TRUE)
            incProgress(1)
            isolate(HTML(htmlpreview))
          })
      )
    })


    # server state saver ---------------------------------------------------------
    ### to environment
    observe({
      if (is.null(input$exit_and_save) || input$exit_and_save == 0) return()

      # quit R, unless you are running an interactive session
      if (interactive()) {
        # flush input and values to the environment in two distinct objects (to be reused later?)
        isolate({

          # pcaexplorer_env <<- new.env(parent = emptyenv())
          cur_inputs <- reactiveValuesToList(input)
          cur_values <- reactiveValuesToList(values)
          tstamp <- gsub(" ", "_", gsub("-", "", gsub(":", "-", as.character(Sys.time()))))

          # better practice rather than assigning to global env - notify users of this
          assign(paste0("pcaExplorer_inputs_", tstamp), cur_inputs, envir = pcaexplorer_env)
          assign(paste0("pcaExplorer_values_", tstamp), cur_values, envir = pcaexplorer_env)
          stopApp("pcaExplorer closed, state successfully saved to global R environment.")
        })
      } else {
        stopApp("pcaExplorer closed")
        q("no")
      }
    })

    ### to binary data
    saveState <- function(filename) {
      isolate({
        LiveInputs <- reactiveValuesToList(input)
        # values[names(LiveInputs)] <- LiveInputs
        r_data <- reactiveValuesToList(values)
        save(LiveInputs, r_data, file = filename)
      })
    }

    output$state_save_sc <- downloadHandler(
      filename = function() {
        paste0("pcaExplorerState_", gsub(" ", "_", gsub("-", "", gsub(":", "-", as.character(Sys.time())))), ".RData")
      },
      content = function(file) {
        saveState(file)
      }
    )

    # server download handlers ---------------------------------------------------------
    output$downloadData_brush <- downloadHandler(
      filename = function() { paste(input$brushedPoints_filename, ".csv", sep = "") },
      content = function(file) {
        if (length(input$pca_brush_out_rows_selected)){
          data <- curData_brush()[input$pca_brush_out_rows_selected, ]
        } else {
          data <- curData_brush()
        }
        write.csv(data, file, quote = FALSE)
      }
    )

    output$downloadData_click <- downloadHandler(
      filename = function() { paste(input$clickedPoints_filename, ".csv", sep = "") },
      content = function(file) {
        write.csv(curData_click(), file, quote = FALSE)
      }
    )

    output$download_samplessamplesheat <- downloadHandler(filename = function() {
      input$filename_samplessamplesheat
    },
    content = function(file){
      pdf(file)

      if (!is.null(input$color_by)) {
        expgroups <- as.data.frame(colData(values$mydst)[, input$color_by])
        # expgroups <- interaction(expgroups)
        rownames(expgroups) <- colnames(values$mydst)
        colnames(expgroups) <- input$color_by

        pheatmap(as.matrix(dist(t(assay(values$mydst)))), annotation_col = expgroups)
      } else {
        pheatmap(as.matrix(dist(t(assay(values$mydst)))))
      }

      dev.off()
    })

    output$download_readsbarplot <- downloadHandler(
      filename = function() { input$filename_readsbarplot },
      content = function(file) {
        ggsave(file, exportPlots$reads_barplot, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_samplesPca <- downloadHandler(
      filename = function() { input$filename_samplesPca },
      content = function(file) {
        ggsave(file, exportPlots$samplesPca, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_samplesScree <- downloadHandler(
      filename = function() { input$filename_samplesScree },
      content = function(file) {
        ggsave(file, exportPlots$samplesScree, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_samplesPcazoom <- downloadHandler(
      filename = function() { input$filename_samplesPcazoom },
      content = function(file) {
        ggsave(file, exportPlots$samplesZoom, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_samplesPca_hiload <- downloadHandler(filename = function() {
      input$filename_samplesPca_hiload
    },
    content = function(file) {
      pdf(file)
      rv <- rowVars(assay(values$mydst))
      select <- order(rv, decreasing = TRUE)[seq_len(min(input$pca_nrgenes, length(rv)))]
      pca <- prcomp(t(assay(values$mydst)[select, ]))

      par(mfrow = c(2, 1))
      hi_loadings(pca, whichpc = as.integer(input$pc_x), topN = input$ntophiload, annotation = values$myannotation)
      hi_loadings(pca, whichpc = as.integer(input$pc_y), topN = input$ntophiload, annotation = values$myannotation)
      dev.off()
    })

    output$download_samplesPca_sampleout <- downloadHandler(
      filename = function() { input$filename_samplesPca_sampleout },
      content = function(file) {
        ggsave(file, exportPlots$samplesOutlier, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_genesPca <- downloadHandler(
      filename = function() { input$filename_genesPca },
      content = function(file) {
        ggsave(file, exportPlots$genesPca, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_genesZoom <- downloadHandler(
      filename = function() { input$filename_genesZoom },
      content = function(file) {
        ggsave(file, exportPlots$genesZoom, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_genesPca_profile <- downloadHandler(
      filename = function() {
        input$filename_genesPca_profile
      },
      content = function(file) {
        pdf(file)
        geneprofiler(values$mydst,
                     genelist = curData_brush()$ids,
                     intgroup = input$color_by,
                     plotZ = input$zprofile)
        dev.off()
      })

    output$download_genesPca_countsplot <- downloadHandler(
      filename = function() { input$filename_genesPca_countsplot },
      content = function(file) {
        ggsave(file, exportPlots$genesBoxplot, width = input$export_width, height = input$export_height, units = "cm")
      })

    output$download_genesHeatmap <- downloadHandler(
      filename = function() {
        input$filename_genesHeatmap
      },
      content = function(file) {
        pdf(file)
        brushedObject <- curData_brush()
        selectedGenes <- brushedObject$ids
        toplot <- assay(values$mydst)[selectedGenes, ]
        rownames(toplot) <- values$myannotation$gene_name[match(rownames(toplot), rownames(values$myannotation))]
        aheatmap(toplot, Colv = as.logical(input$heatmap_colv))
        dev.off()
      })

    output$download_genefinder_countsplot <- downloadHandler(
      filename = function() { input$filename_genefinder_countsplot },
      content = function(file) {
        ggsave(file, exportPlots$genefinder_countsplot, width = input$export_width, height = input$export_height, units = "cm")
      })


    output$saveRmd <- downloadHandler(
      filename = function() {
        if (input$rmd_dl_format == "rmd") {
          "report.Rmd"
        } else {
          "report.html"
        }
      },
      content = function(file) {
        # knit2html(text = input$rmd, fragment.only = TRUE, quiet = TRUE))
        tmp_content <-
          paste0(rmd_yaml(),
                 input$acereport_rmd, collapse = "\n")
        # input$acereport_rmd
        if (input$rmd_dl_format == "rmd") {
          cat(tmp_content, file = file, sep = "\n")
        } else {
          # write it somewhere too keeping the source
          # tmpfile <- tempfile()
          # file.create(tmpfile)
          # fileConn<- file(tempfile())
          # writeLines(tmp_content, fileConn)
          # close(fileConn)
          if (input$rmd_dl_format == "html") {

            # temporarily switch to the temp dir, in case you do not have write
            # permission to the current working directory
            owd <- setwd(tempdir())
            on.exit(setwd(owd))

            cat(tmp_content, file = "tempreport.Rmd", sep = "\n")
            rmarkdown::render(input = "tempreport.Rmd",
                              output_file = file,
                              # fragment.only = TRUE,
                              quiet = TRUE)
          }
        }
      }
    )
  }) # end of pcaExplorer(dds,dst,countmatrix,coldata,pca2go,annotation)
  #nocov end
  shinyApp(ui = pcaexplorer_ui, server = pcaexplorer_server)
}

footer <- function() {
  tags$div(
    class = "footer",
    style = "text-align:center",
    tags$div(
      class = "foot-inner",
      list(
        hr(),
        "pcaExplorer is a project developed by Federico Marini in the Bioinformatics division of the ",
        tags$a(href = "http://www.unimedizin-mainz.de/imbei", "IMBEI"),
        ". ", br(),
        "Development of the pcaExplorer package is on ",
        tags$a(href = "https://github.com/federicomarini/pcaExplorer", "GitHub")
      )
    )
  )
}

test_that("Shiny app is generated", {
  expect_is(pcaExplorer(), "shiny.appobj")
  
  expect_is(pcaExplorer(dds, rlt), "shiny.appobj")
  
  expect_is(pcaExplorer(countmatrix = cm, coldata = cd), "shiny.appobj")
  
  expect_is(pcaExplorer(dds = dds), "shiny.appobj")
})

#' Plot distribution of expression values
#'
#' @param rld A [DESeq2::DESeqTransform()] object.
#' @param plot_type Character, choose one of `boxplot`, `violin` or
#' `density`. Defaults to `density`
#'
#' @return A plot with the distribution of the expression values
#' @export
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' distro_expr(rlt)
distro_expr <- function(rld, plot_type="density") {
  allrld <- tidyr::gather(as.data.frame(assay(rld)))
  names(allrld) <- c("Sample", "rlogExpression")

  if (plot_type == "boxplot") {
    p <- ggplot(allrld, aes_string(x = "Sample", y = "rlogExpression")) + geom_boxplot(aes_string(col = "Sample", fill = "Sample"), alpha = 0.5)
  }

  if (plot_type == "violin") {
    p <- ggplot(allrld, aes_string(x = "Sample", y = "rlogExpression")) + geom_violin(aes_string(col = "Sample", fill = "Sample"), alpha = 0.5)
  }

  if (plot_type == "density") {
    p <- ggplot(allrld, aes_string(x = "rlogExpression")) + geom_density(aes_string(color = "Sample"), alpha = 0.1)
  }
  p <- p + theme_bw()
  return(p)
}

test_that("Gene profiler does its job properly", {
  geneprofiler(rlt, paste0("gene", sample(1:1000, 20)))
  
  expect_error(
    expect_message(
      geneprofiler(rlt, "gene_fake")
    )
  )
})

test_that("Distribution of expression", {
  p <- distro_expr(rlt)
  expect_true(is(p, "gg"))
})

test_that("Correlation scatter plot matrix works", {
  pair_corr(counts(dds)[1:100, ])
  expect_error(pair_corr(dds))
})

#' Principal components analysis on the genes
#'
#' Computes and plots the principal components of the genes, eventually displaying
#' the samples as in a typical biplot visualization.
#'
#' The implementation of this function is based on the beautiful `ggbiplot`
#' package developed by Vince Vu, available at https://github.com/vqv/ggbiplot.
#' The adaptation and additional parameters are tailored to display typical genomics data
#' such as the transformed counts of RNA-seq experiments
#'
#' @param x A [DESeq2::DESeqTransform()] object, with data in `assay(x)`,
#' produced for example by either [DESeq2::rlog()] or
#' [DESeq2::varianceStabilizingTransformation()]
#' @param ntop Number of top genes to use for principal components,
#' selected by highest row variance
#' @param choices Vector of two numeric values, to select on which principal components to plot
#' @param arrowColors Vector of character, either as long as the number of the samples, or one single value
#' @param groupNames Factor containing the groupings for the input data. Is efficiently chosen
#' as the (interaction of more) factors in the colData for the object provided
#' @param biplot Logical, whether to additionally draw the samples labels as in a biplot representation
#' @param scale Covariance biplot (scale = 1), form biplot (scale = 0). When scale = 1,
#' the inner product between the variables approximates the covariance and the
#' distance between the points approximates the Mahalanobis distance.
#' @param pc.biplot Logical, for compatibility with biplot.princomp()
#' @param obs.scale Scale factor to apply to observations
#' @param var.scale Scale factor to apply to variables
#' @param groups Optional factor variable indicating the groups that the observations
#' belong to. If provided the points will be colored according to groups
#' @param ellipse Logical, draw a normal data ellipse for each group
#' @param ellipse.prob Size of the ellipse in Normal probability
#' @param labels optional Vector of labels for the observations
#' @param labels.size Size of the text used for the labels
#' @param alpha Alpha transparency value for the points (0 = transparent, 1 = opaque)
#' @param var.axes Logical, draw arrows for the variables?
#' @param circle Logical, draw a correlation circle? (only applies when prcomp
#' was called with scale = TRUE and when var.scale = 1)
#' @param circle.prob Size of the correlation circle in Normal probability
#' @param varname.size Size of the text for variable names
#' @param varname.adjust  Adjustment factor the placement of the variable names,
#' '>= 1' means farther from the arrow
#' @param varname.abbrev  Logical, whether or not to abbreviate the variable names
#' @param returnData Logical, if TRUE returns a data.frame for further use, containing the
#' selected principal components for custom plotting
#' @param coordEqual Logical, default FALSE, for allowing brushing. If TRUE, plot using
#' equal scale cartesian coordinates
#' @param scaleArrow Multiplicative factor, usually >=1, only for visualization purposes,
#' to allow for distinguishing where the variables are plotted
#' @param useRownamesAsLabels Logical, if TRUE uses the row names as labels for plotting
#' @param point_size Size of the points to be plotted for the observations (genes)
#' @param annotation A `data.frame` object, with row.names as gene identifiers (e.g. ENSEMBL ids)
#' and a column, `gene_name`, containing e.g. HGNC-based gene symbols
#'
#' @return An object created by `ggplot`, which can be assigned and further customized.
#'
#' @examples
#'
#' library(DESeq2)
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- rlogTransformation(dds)
#' groups <- colData(dds)$condition
#' groups <- factor(groups, levels = unique(groups))
#' cols <- scales::hue_pal()(2)[groups]
#' genespca(rlt, ntop=100, arrowColors = cols, groupNames = groups)
#'
#' groups_multi <- interaction(as.data.frame(colData(rlt)[, c("condition", "tissue")]))
#' groups_multi <- factor(groups_multi, levels = unique(groups_multi))
#' cols_multi <- scales::hue_pal()(length(levels(groups_multi)))[factor(groups_multi)]
#' genespca(rlt, ntop = 100, arrowColors = cols_multi, groupNames = groups_multi)
#'
#' @export
genespca <- function(x,
                     ntop,
                     choices = c(1, 2),
                     arrowColors = "steelblue",
                     groupNames="group",
                     biplot = TRUE,
                     scale = 1, pc.biplot = TRUE,
                     obs.scale = 1 - scale, var.scale = scale, groups = NULL,
                     ellipse = FALSE, ellipse.prob = 0.68, labels = NULL, labels.size = 3,
                     alpha = 1, var.axes = TRUE, circle = FALSE, circle.prob = 0.69,
                     varname.size = 4, varname.adjust = 1.5, varname.abbrev = FALSE,
                     returnData = FALSE, coordEqual = FALSE, scaleArrow = 1,
                     useRownamesAsLabels = TRUE, point_size = 2, annotation = NULL) {

  stopifnot(length(choices) == 2)
  if (length(arrowColors) != 1 & length(arrowColors) != ncol(x))
    stop("Please provide either one color or a vector as long as the number of samples")

  rv <- rowVars(assay(x))
  select <- order(rv, decreasing = TRUE)[seq_len(min(ntop, length(rv)))]
  pca <- prcomp((assay(x)[select, ]))

  percentVar <- pca$sdev^2 / sum(pca$sdev^2)

  if (!biplot) {
    nobs.factor <- sqrt(nrow(pca$x) - 1)
    devs <- pca$sdev
    pcast <- pca
    pcast$x <- sweep(pca$x, 2, 1 / (devs * nobs.factor), FUN = "*") * nobs.factor
    d <- data.frame(PC1 = pcast$x[, choices[1]],
                    PC2 = pcast$x[, choices[2]],
                    names = rownames((assay(x)[select, ])))

    if (returnData) {
      attr(d, "percentVar") <- percentVar
      return(d)
    }

    ggplot(data = d, aes_string(x = "PC1", y = "PC2")) +
      geom_point(size = 3) +
      xlab(paste0("PC", choices[1], ": ", round(percentVar[choices[1]] * 100), "% variance")) +
      ylab(paste0("PC", choices[2], ": ", round(percentVar[choices[2]] * 100), "% variance")) +
      # geom_text(aes(label=names),hjust=0.25, vjust=-0.5, show.legend = F) +
      ggtitle("title") + theme_bw()
  } else {
    if (inherits(pca, "prcomp")) {
      nobs.factor <- sqrt(nrow(pca$x) - 1)
      d <- pca$sdev
      u <- sweep(pca$x, 2, 1 / (d * nobs.factor), FUN = "*")
      v <- pca$rotation
    }

    choices <- pmin(choices, ncol(u))
    df.u <- as.data.frame(sweep(u[, choices], 2, d[choices]^obs.scale,
                                FUN = "*"))
    v <- sweep(v, 2, d^var.scale, FUN = "*")
    df.v <- as.data.frame(v[, choices])
    names(df.u) <- c("xvar", "yvar")
    names(df.v) <- names(df.u)
    if (pc.biplot) {
      df.u <- df.u * nobs.factor
    }

    r <- sqrt(qchisq(circle.prob, df = 2)) * prod(colMeans(df.u^2)) ^ (1/4)
    v.scale <- rowSums(v^2)
    df.v <- r * df.v / sqrt(max(v.scale))
    if (obs.scale == 0) {
      u.axis.labs <- paste("standardized PC", choices, sep = "")
    } else {
      u.axis.labs <- paste("PC", choices, sep = "")
    }
    u.axis.labs <- paste(u.axis.labs, sprintf("(%0.1f%% explained var.)",
                                              100 * pca$sdev[choices]^2 / sum(pca$sdev^2)))
    if (!is.null(labels)) {
      df.u$labels <- labels
    }
    if (!is.null(groups)) {
      df.u$groups <- groups
    }

    # additionally...
    df.u$ids <- rownames(df.u)
    if(!is.null(annotation)) {
      df.u$geneNames <- annotation$gene_name[match(df.u$ids, rownames(annotation))]
    } else {
      df.u$geneNames <- df.u$ids
    }
    if (varname.abbrev) {
      df.v$varname <- abbreviate(rownames(v))
    } else {
      df.v$varname <- rownames(v)
    }
    df.v$angle <- with(df.v, (180/pi) * atan(yvar/xvar))
    df.v$hjust <- with(df.v, (1 - varname.adjust * sign(xvar)) / 2)

    if (returnData) {
      return(df.u)
    }



    g <- ggplot(data = df.u, aes_string(x = "xvar", y = "yvar")) + xlab(u.axis.labs[1]) +
      ylab(u.axis.labs[2]) # + coord_equal() # REMOVED OTHERWISE BRUSH DOES NOT WORK PROPERLY
    if (coordEqual) g <- g + coord_equal()

    if (!is.null(df.u$labels)) {
      if (!is.null(df.u$groups)) {
        g <- g + geom_text(aes(label = labels, color = groups),
                           size = labels.size)
      } else {
        g <- g + geom_text(aes(label = labels), size = labels.size)
      }
    } else {
      if (!is.null(df.u$groups)) {
        g <- g + geom_point(aes(color = groups), size = point_size, alpha = alpha)
      } else {
        g <- g + geom_point(size = point_size, alpha = alpha)
      }
    }

    if (useRownamesAsLabels) {
      g <- g + geom_text(aes_string(label = "geneNames"), size = labels.size, hjust = 0.25, vjust = -0.75)
    }

    if (!is.null(df.u$groups) && ellipse) {
      theta <- c(seq(-pi, pi, length = 50), seq(pi, -pi, length = 50))
      circle <- cbind(cos(theta), sin(theta))
      ell <- ddply(df.u, "groups", function(x) {
        if (nrow(x) <= 2) {
          return(NULL)
        }
        sigma <- var(cbind(x$xvar, x$yvar))
        mu <- c(mean(x$xvar), mean(x$yvar))
        ed <- sqrt(qchisq(ellipse.prob, df = 2))
        data.frame(sweep(circle %*% chol(sigma) * ed, 2,
                         mu, FUN = "+"), groups = x$groups[1])
      })
      names(ell)[1:2] <- c("xvar", "yvar")
      g <- g + geom_path(data = ell, aes(color = groups, group = groups))
    }
    # moved down to have the arrows drawn on top of the points and not vice versa
    if (var.axes) {
      if (circle) {
        theta <- c(seq(-pi, pi, length = 50), seq(pi, -pi,
                                                  length = 50))
        circle <- data.frame(xvar = r * cos(theta), yvar = r *
                               sin(theta))
        g <- g + geom_path(data = circle, color = "steelblue",
                           size = 1/2, alpha = 1/3)
      }
      df.v$scaleArrow <- scaleArrow # quick fix for mapping scaling of the arrows
      arrowColors <-  factor(arrowColors, levels = unique(arrowColors))
      df.v$arrowColors <- factor(arrowColors, levels = unique(arrowColors))
      df.v$groupNames <- factor(groupNames, levels = unique(groupNames))
      df.v$sca_x <- df.v$xvar * scaleArrow
      df.v$sca_y <- df.v$yvar * scaleArrow
      df.v$sta_x <- 0
      df.v$sta_y <- 0
      g <- g + geom_segment(data = df.v, aes_string(x = "sta_x", y = "sta_y", xend = "sca_x", yend = "sca_y", color = "arrowColors"),
                            arrow = arrow(length = unit(1/2, "picas"))) +
        scale_color_manual(values = levels(arrowColors), name = "Group", labels = levels(groupNames))
    }

    if (var.axes) {
      g <- g + geom_text(data = df.v, aes_string(label = "varname",
                                                 x = "sca_x", y = "sca_y", # angle = angle,
                                                 hjust = "hjust"),
                         color = arrowColors, size = varname.size)
    }
    g <- g + theme_bw()
    return(g)
  }
}

test_that("Checks on the pca on the genes", {
  groups <- colData(dds_multifac)$condition
  cols <- scales::hue_pal()(2)[groups]
  p <- genespca(rlt_multifac, ntop = 100, arrowColors = cols, groupNames = groups)
  
  expect_true(is(p, "gg"))
  
  dat <- genespca(rlt_multifac, ntop = 100, arrowColors = cols, groupNames = groups, returnData = TRUE)
  
  p2 <- genespca(rlt_multifac, ntop = 100)
  p3 <- genespca(rlt_multifac, ntop = 100, arrowColors = "green")
  
  expect_error(genespca(rlt_multifac, ntop = 100, arrowColors = c("green", "red")))
  
  groups_multi <- interaction(as.data.frame(colData(rlt_multifac)[, c("condition", "tissue")]))
  cols_multi <- scales::hue_pal()(length(levels(groups_multi)))[factor(groups_multi)]
  p4 <- genespca(rlt_multifac, ntop = 100, arrowColors = cols_multi, groupNames = groups_multi)
  
  expect_true(is(p4, "gg"))
})

#' @importFrom shiny addResourcePath

.onLoad <- function(libname, pkgname) {
  # Create link to logo
  # shiny::addResourcePath("pcaExplorer", system.file("www", package="pcaExplorer"))
  
  shiny::addResourcePath("sbs", system.file("www", package = "shinyBS"))
}

#' Extract functional terms enriched in the DE genes, based on topGO
#'
#' A wrapper for extracting functional GO terms enriched in the DE genes, based on
#' the algorithm and the implementation in the topGO package
#' 
#' Allowed values assumed by the `topGO_method2` parameter are one of the
#' following: `elim`, `weight`, `weight01`, `lea`, 
#' `parentchild`. For more details on this, please refer to the original 
#' documentation of the `topGO` package itself
#'
#' @param DEgenes A vector of (differentially expressed) genes
#' @param BGgenes A vector of background genes, e.g. all (expressed) genes in the assays
#' @param ontology Which Gene Ontology domain to analyze: `BP` (Biological Process), `MF` (Molecular Function), or `CC` (Cellular Component)
#' @param annot Which function to use for annotating genes to GO terms. Defaults to `annFUN.org`
#' @param mapping Which `org.XX.eg.db` to use for annotation - select according to the species
#' @param geneID Which format the genes are provided. Defaults to `symbol`, could also be
#' `entrez` or `ENSEMBL`
#' @param topTablerows How many rows to report before any filtering
#' @param fullNamesInRows Logical, whether to display or not the full names for the GO terms
#' @param addGeneToTerms Logical, whether to add a column with all genes annotated to each GO term
#' @param plotGraph Logical, if TRUE additionally plots a graph on the identified GO terms
#' @param plotNodes Number of nodes to plot
#' @param writeOutput Logical, if TRUE additionally writes out the result to a file
#' @param outputFile Name of the file the result should be written into
#' @param topGO_method2 Character, specifying which of the methods implemented by `topGO` should be used, in addition to the `classic` algorithm. Defaults to `elim`
#' @param do_padj Logical, whether to perform the adjustment on the p-values from the specific
#' topGO method, based on the FDR correction. Defaults to FALSE, since the assumption of 
#' independent hypotheses is somewhat violated by the intrinsic DAG-structure of the Gene
#' Ontology Terms
#'
#' @import topGO
#'
#' @return A table containing the computed GO Terms and related enrichment scores
#'
#' @examples
#' library("airway")
#' library("DESeq2")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeqDataSet(airway, design= ~ cell + dex)
#' # Example, performing extraction of enriched functional categories in
#' # detected significantly expressed genes
#' \dontrun{
#' dds_airway <- DESeq(dds_airway)
#' res_airway <- results(dds_airway)
#' library("AnnotationDbi")
#' library("org.Hs.eg.db")
#' res_airway$symbol <- mapIds(org.Hs.eg.db,
#'                             keys = row.names(res_airway),
#'                             column = "SYMBOL",
#'                             keytype = "ENSEMBL",
#'                             multiVals = "first")
#' res_airway$entrez <- mapIds(org.Hs.eg.db,
#'                             keys = row.names(res_airway),
#'                             column = "ENTREZID",
#'                             keytype = "ENSEMBL",
#'                             multiVals = "first")
#' resOrdered <- as.data.frame(res_airway[order(res_airway$padj),])
#' de_df <- resOrdered[resOrdered$padj < .05 & !is.na(resOrdered$padj),]
#' de_symbols <- de_df$symbol
#' bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
#' bg_symbols <- mapIds(org.Hs.eg.db,
#'                      keys = bg_ids,
#'                      column = "SYMBOL",
#'                      keytype = "ENSEMBL",
#'                      multiVals = "first")
#' library(topGO)
#' topgoDE_airway <- topGOtable(de_symbols, bg_symbols,
#'                              ontology = "BP",
#'                              mapping = "org.Hs.eg.db",
#'                              geneID = "symbol")
#' }
#' 
#' @importFrom mosdef run_topGO
#'
#' @export
topGOtable <- function(DEgenes,                  # Differentially expressed genes
                       BGgenes,                 # background genes
                       ontology = "BP",            # could use also "MF"
                       annot = annFUN.org,       # parameters for creating topGO object
                       mapping = "org.Mm.eg.db",
                       geneID = "symbol",       # could also beID = "entrez"
                       topTablerows = 200,
                       fullNamesInRows = TRUE,
                       addGeneToTerms = TRUE,
                       plotGraph = FALSE, 
                       plotNodes = 10,
                       writeOutput = FALSE, 
                       outputFile = "",
                       topGO_method2 = "elim",
                       do_padj = FALSE) {
  
  .Deprecated(old = "topGOtable", new = "mosdef::run_topGO", 
              msg = paste0(
                "Please use `mosdef::run_topGO()` in replacement of the `topGOtable()` function, ",
                "originally located in the pcaExplorer package. \nCheck the manual page for ",
                "`?mosdef::run_topGO()` to see the details on how to use it, e.g. ",
                "refer to the new parameter definition and naming"))
  
  res_enrich <- mosdef::run_topGO(
    de_genes = DEgenes,
    bg_genes = BGgenes,
    annot = annot,
    ontology = ontology,
    mapping = mapping,
    gene_id = geneID,
    full_names_in_rows = fullNamesInRows,
    add_gene_to_terms = addGeneToTerms,
    topGO_method2 = topGO_method2,
    do_padj = do_padj,
    verbose = TRUE
  )
  
  return(res_enrich)
}

#' Functional interpretation of the principal components
#'
#' Extracts the genes with the highest loadings for each principal component, and
#' performs functional enrichment analysis on them using routines and algorithms from
#' the `topGO` package
#'
#' @param se A [DESeq2::DESeqTransform()] object, with data in `assay(se)`,
#' produced for example by either [DESeq2::rlog()] or
#' [DESeq2::varianceStabilizingTransformation()]
#' @param pca_ngenes Number of genes to use for the PCA
#' @param annotation A `data.frame` object, with row.names as gene identifiers (e.g. ENSEMBL ids)
#' and a column, `gene_name`, containing e.g. HGNC-based gene symbols
#' @param inputType Input format type of the gene identifiers. Will be used by the routines of `topGO`
#' @param organism Character abbreviation for the species, using `org.XX.eg.db` for annotation
#' @param ensToGeneSymbol Logical, whether to expect ENSEMBL gene identifiers, to convert to gene symbols
#' with the `annotation` provided
#' @param loadings_ngenes Number of genes to extract the loadings (in each direction)
#' @param background_genes Which genes to consider as background.
#' @param scale Logical, defaults to FALSE, scale values for the PCA
#' @param return_ranked_gene_loadings Logical, defaults to FALSE. If TRUE, simply returns
#' a list containing the top ranked genes with hi loadings in each PC and in each direction
#' @param annopkg String containing the name of the organism annotation package. Can be used to 
#' override the `organism` parameter, e.g. in case of alternative identifiers used
#' in the annotation package (Arabidopsis with TAIR)
#' @param ... Further parameters to be passed to the topGO routine
#'
#' @return A nested list object containing for each principal component the terms enriched
#' in each direction. This object is to be thought in combination with the displaying feature
#' of the main [pcaExplorer()] function
#'
#' @examples
#' library("airway")
#' library("DESeq2")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeqDataSet(airway, design= ~ cell + dex)
#' \dontrun{
#' rld_airway <- rlogTransformation(dds_airway)
#' # constructing the annotation object
#' anno_df <- data.frame(gene_id = rownames(dds_airway),
#'                       stringsAsFactors = FALSE)
#' library("AnnotationDbi")
#' library("org.Hs.eg.db")
#' anno_df$gene_name <- mapIds(org.Hs.eg.db,
#'                             keys = anno_df$gene_id,
#'                             column = "SYMBOL",
#'                             keytype = "ENSEMBL",
#'                             multiVals = "first")
#' rownames(anno_df) <- anno_df$gene_id
#' bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
#' library(topGO)
#' pca2go_airway <- pca2go(rld_airway,
#'                         annotation = anno_df,
#'                         organism = "Hs",
#'                         ensToGeneSymbol = TRUE,
#'                         background_genes = bg_ids)
#' }
#'
#' @export
pca2go <- function(se,
                   pca_ngenes = 10000,
                   annotation = NULL,
                   inputType = "geneSymbol",
                   organism = "Mm",
                   ensToGeneSymbol = FALSE,
                   loadings_ngenes = 500,
                   background_genes = NULL,
                   scale = FALSE,
                   return_ranked_gene_loadings = FALSE,
                   annopkg = NULL,
                   ... # further parameters to be passed to the topgo routine
                   ) {

  # to force e.g. in case other identifiers are used, e.g. in Arabidopsis with TAIR
  if (is.null(annopkg))
    annopkg <- paste0("org.", organism, ".eg.db")
  
  if (!require(annopkg, character.only = TRUE)) {
    stop("The package", annopkg, "is not installed/available. Try installing it with BiocManager::install() ?")
  }
  exprsData <- assay(se)

  if (is.null(background_genes)) {
    if (is(se, "DESeqDataSet")) {
      BGids <- rownames(se)[rowSums(counts(se)) > 0]
    } else if (is(se, "DESeqTransform")) {
      BGids <- rownames(se)[rowSums(assay(se)) != 0]
    } else {
      BGids <- rownames(se)
    }
  } else {
    BGids <- background_genes
  }

  exprsData <- assay(se)[order(rowVars(assay(se)), decreasing = TRUE), ]
  exprsData <- exprsData[1:pca_ngenes, ]

  ## convert ensembl to gene symbol ids
  if (ensToGeneSymbol & !(is.null(annotation))) {
    rownames(exprsData) <- annotation$gene_name[match(rownames(exprsData), rownames(annotation))]
    BGids <- annotation$gene_name[match(BGids, rownames(annotation))]
  }

  rv <- rowVars(exprsData)
  dropped <- sum(rv == 0)
  if (dropped > 0)
    message("Dropped ", dropped, " genes with 0 variance")

  exprsData <- exprsData[rv > 0, ]

  message("After subsetting/filtering for invariant genes, working on a ", nrow(exprsData), "x", ncol(exprsData), " expression matrix\n")

  p <- prcomp(t(exprsData), scale = scale, center = TRUE)

  message("Ranking genes by the loadings ...")
  probesPC1pos <- rankedGeneLoadings(p, pc = 1, decreasing = TRUE)[1:loadings_ngenes]
  probesPC1neg <- rankedGeneLoadings(p, pc = 1, decreasing = FALSE)[1:loadings_ngenes]
  probesPC2pos <- rankedGeneLoadings(p, pc = 2, decreasing = TRUE)[1:loadings_ngenes]
  probesPC2neg <- rankedGeneLoadings(p, pc = 2, decreasing = FALSE)[1:loadings_ngenes]
  probesPC3pos <- rankedGeneLoadings(p, pc = 3, decreasing = TRUE)[1:loadings_ngenes]
  probesPC3neg <- rankedGeneLoadings(p, pc = 3, decreasing = FALSE)[1:loadings_ngenes]
  probesPC4pos <- rankedGeneLoadings(p, pc = 4, decreasing = TRUE)[1:loadings_ngenes]
  probesPC4neg <- rankedGeneLoadings(p, pc = 4, decreasing = FALSE)[1:loadings_ngenes]
  
  if (return_ranked_gene_loadings)
    return(
      list(PC1 = list(posLoad = probesPC1pos, negLoad = probesPC1neg),
           PC2 = list(posLoad = probesPC2pos, negLoad = probesPC2neg),
           PC3 = list(posLoad = probesPC3pos, negLoad = probesPC3neg),
           PC4 = list(posLoad = probesPC4pos, negLoad = probesPC4neg)
      )
    )
  
  message("Ranking genes by the loadings ... done!")
  message("Extracting functional categories enriched in the gene subsets ...")
  topGOpc1pos <- mosdef::run_topGO(de_genes = probesPC1pos, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc1neg <- mosdef::run_topGO(de_genes = probesPC1neg, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc2pos <- mosdef::run_topGO(de_genes = probesPC2pos, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc2neg <- mosdef::run_topGO(de_genes = probesPC2neg, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc3pos <- mosdef::run_topGO(de_genes = probesPC3pos, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc3neg <- mosdef::run_topGO(de_genes = probesPC3neg, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc4pos <- mosdef::run_topGO(de_genes = probesPC4pos, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)
  topGOpc4neg <- mosdef::run_topGO(de_genes = probesPC4neg, 
                                   bg_genes = BGids, annot = annFUN.org, mapping = annopkg, ...)

  goEnrichs <- list(PC1 = list(posLoad = topGOpc1pos, negLoad = topGOpc1neg),
                    PC2 = list(posLoad = topGOpc2pos, negLoad = topGOpc2neg),
                    PC3 = list(posLoad = topGOpc3pos, negLoad = topGOpc3neg),
                    PC4 = list(posLoad = topGOpc4pos, negLoad = topGOpc4neg)
  )
  message("Extracting functional categories enriched in the gene subsets ... done!")
  attr(goEnrichs, "n_genesforpca") <- pca_ngenes
  return(goEnrichs)
}


rankedGeneLoadings <- function(x, pc = 1, decreasing = TRUE) {
  # works directly on the prcomp object
  return(rownames(x$rotation)[order(x$rotation[, pc], decreasing = decreasing)])
}




#' Functional interpretation of the principal components, based on simple
#' overrepresentation analysis
#'
#' Extracts the genes with the highest loadings for each principal component, and
#' performs functional enrichment analysis on them using the simple and quick routine
#' provided by the `limma` package
#'
#' @param se A [DESeq2::DESeqTransform()] object, with data in `assay(se)`,
#' produced for example by either [DESeq2::rlog()] or
#' [DESeq2::varianceStabilizingTransformation()]
#' @param pca_ngenes Number of genes to use for the PCA
#' @param inputType Input format type of the gene identifiers. Deafults to `ENSEMBL`, that then will
#' be converted to ENTREZ ids. Can assume values such as `ENTREZID`,`GENENAME` or `SYMBOL`,
#' like it is normally used with the `select` function of `AnnotationDbi`
#' @param organism Character abbreviation for the species, using `org.XX.eg.db` for annotation
#' @param loadings_ngenes Number of genes to extract the loadings (in each direction)
#' @param background_genes Which genes to consider as background.
#' @param scale Logical, defaults to FALSE, scale values for the PCA
#' @param ... Further parameters to be passed to the goana routine
#'
#' @return A nested list object containing for each principal component the terms enriched
#' in each direction. This object is to be thought in combination with the displaying feature
#' of the main [pcaExplorer()] function
#'
#' @examples
#' library("airway")
#' library("DESeq2")
#' library("limma")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeqDataSet(airway, design = ~ cell + dex)
#' \dontrun{
#' rld_airway <- rlogTransformation(dds_airway)
#' goquick_airway <- limmaquickpca2go(rld_airway,
#'                                    pca_ngenes = 10000,
#'                                    inputType = "ENSEMBL",
#'                                    organism = "Hs")
#' }
#'
#' @export
limmaquickpca2go <- function(se,
                             pca_ngenes = 10000,
                             inputType = "ENSEMBL",
                             organism = "Mm",
                             loadings_ngenes = 500,
                             background_genes = NULL,
                             scale = FALSE,
                             ... # further parameters to be passed to the topgo routine
                             ) {
  annopkg <- paste0("org.", organism, ".eg.db")
  if (!require(annopkg, character.only = TRUE)) {
    stop("The package", annopkg, "is not installed/available. Try installing it with BiocManager::install() ?")
  }
  exprsData <- assay(se)

  if (is.null(background_genes)) {
    if (is(se, "DESeqDataSet")) {
      BGids <- rownames(se)[rowSums(counts(se)) > 0]
    } else if (is(se, "DESeqTransform")) {
      BGids <- rownames(se)[rowSums(assay(se)) != 0]
    } else {
      BGids <- rownames(se)
    }
  } else {
    BGids <- background_genes
  }

  exprsData <- assay(se)[order(rowVars(assay(se)), decreasing = TRUE), ]
  exprsData <- exprsData[1:pca_ngenes, ]

  rv <- rowVars(exprsData)
  dropped <- sum(rv == 0)
  if (dropped > 0)
    message("Dropped ", dropped, " genes with 0 variance")

  exprsData <- exprsData[rv > 0, ]

  message("After subsetting/filtering for invariant genes, working on a ", nrow(exprsData), "x", ncol(exprsData), " expression matrix\n")

  p <- prcomp(t(exprsData), scale = scale, center = TRUE)

  message("Ranking genes by the loadings ...")
  probesPC1pos <- rankedGeneLoadings(p, pc = 1, decreasing = TRUE)[1:loadings_ngenes]
  probesPC1neg <- rankedGeneLoadings(p, pc = 1, decreasing = FALSE)[1:loadings_ngenes]
  probesPC2pos <- rankedGeneLoadings(p, pc = 2, decreasing = TRUE)[1:loadings_ngenes]
  probesPC2neg <- rankedGeneLoadings(p, pc = 2, decreasing = FALSE)[1:loadings_ngenes]
  probesPC3pos <- rankedGeneLoadings(p, pc = 3, decreasing = TRUE)[1:loadings_ngenes]
  probesPC3neg <- rankedGeneLoadings(p, pc = 3, decreasing = FALSE)[1:loadings_ngenes]
  probesPC4pos <- rankedGeneLoadings(p, pc = 4, decreasing = TRUE)[1:loadings_ngenes]
  probesPC4neg <- rankedGeneLoadings(p, pc = 4, decreasing = FALSE)[1:loadings_ngenes]

  ## convert ensembl to entrez ids
  probesPC1pos_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC1pos, column = "ENTREZID", keytype = inputType)
  probesPC1neg_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC1neg, column = "ENTREZID", keytype = inputType)
  probesPC2pos_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC2pos, column = "ENTREZID", keytype = inputType)
  probesPC2neg_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC2neg, column = "ENTREZID", keytype = inputType)
  probesPC3pos_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC3pos, column = "ENTREZID", keytype = inputType)
  probesPC3neg_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC3neg, column = "ENTREZID", keytype = inputType)
  probesPC4pos_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC4pos, column = "ENTREZID", keytype = inputType)
  probesPC4neg_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = probesPC4neg, column = "ENTREZID", keytype = inputType)
  bg_ENTREZ <- AnnotationDbi::mapIds(eval(parse(text = annopkg)), keys = BGids, column = "ENTREZID", keytype = inputType)
  message("Ranking genes by the loadings ... done!")

  message("Extracting functional categories enriched in the gene subsets ...")
  quickGOpc1pos <- limma::topGO(limma::goana(probesPC1pos_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("1")
  quickGOpc1neg <- limma::topGO(limma::goana(probesPC1neg_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("2")
  quickGOpc2pos <- limma::topGO(limma::goana(probesPC2pos_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("3")
  quickGOpc2neg <- limma::topGO(limma::goana(probesPC2neg_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("4")
  quickGOpc3pos <- limma::topGO(limma::goana(probesPC3pos_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("5")
  quickGOpc3neg <- limma::topGO(limma::goana(probesPC3neg_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("6")
  quickGOpc4pos <- limma::topGO(limma::goana(probesPC4pos_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("7")
  quickGOpc4neg <- limma::topGO(limma::goana(probesPC4neg_ENTREZ, bg_ENTREZ, species = organism, ...), ontology = "BP", number = 200); message("8")

  quickGOpc1pos <- quickGOpc1pos[order(quickGOpc1pos$P.DE), ]
  quickGOpc1neg <- quickGOpc1neg[order(quickGOpc1neg$P.DE), ]
  quickGOpc2pos <- quickGOpc2pos[order(quickGOpc2pos$P.DE), ]
  quickGOpc2neg <- quickGOpc2neg[order(quickGOpc2neg$P.DE), ]
  quickGOpc3pos <- quickGOpc3pos[order(quickGOpc3pos$P.DE), ]
  quickGOpc3neg <- quickGOpc3neg[order(quickGOpc3neg$P.DE), ]
  quickGOpc4pos <- quickGOpc4pos[order(quickGOpc4pos$P.DE), ]
  quickGOpc4neg <- quickGOpc4neg[order(quickGOpc4neg$P.DE), ]

  goEnrichs <- list(PC1 = list(posLoad = quickGOpc1pos, negLoad = quickGOpc1neg),
                    PC2 = list(posLoad = quickGOpc2pos, negLoad = quickGOpc2neg),
                    PC3 = list(posLoad = quickGOpc3pos, negLoad = quickGOpc3neg),
                    PC4 = list(posLoad = quickGOpc4pos, negLoad = quickGOpc4neg)
  )
  message("Extracting functional categories enriched in the gene subsets ... done!")
  attr(goEnrichs, "n_genesforpca") <- pca_ngenes
  return(goEnrichs)
}

test_that("Checks on the functional enrichment of subset of genes/genes with hi loadings",{
  resOrdered <- as.data.frame(res_airway[order(res_airway$padj), ])
  de_df <- resOrdered[resOrdered$padj < .05 & !is.na(resOrdered$padj), ]
  de_symbols <- de_df$symbol
  bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
  bg_symbols <- mapIds(org.Hs.eg.db,
                       keys = bg_ids,
                       column = "SYMBOL",
                       keytype = "ENSEMBL",
                       multiVals = "first")
  library(topGO)
  
  expect_is(de_symbols, "character")
  expect_is(bg_symbols, "character")
  
  # topgoDE_airway <- topGOtable(de_symbols, bg_symbols,
  #                              ontology = "BP",
  #                              mapping = "org.Hs.eg.db",
  #                              geneID = "symbol")
  #
  # expect_is(topgoDE_airway,"data.frame")
  ngenes_pca <- 500
  
  goquick_airway <- limmaquickpca2go(rld_airway,
                                     pca_ngenes = ngenes_pca,
                                     inputType = "ENSEMBL",
                                     organism = "Hs")
  
  expect_type(goquick_airway, "list")
  expect_equal(length(goquick_airway), 4)
  sapply(goquick_airway, names)
  expect_equal(attr(goquick_airway, "n_genesforpca"), ngenes_pca)
  
  expect_error(
    expect_warning(
      limmaquickpca2go(rld_airway,
                                pca_ngenes = ngenes_pca,
                                inputType = "ENSEMBL",
                                organism = "foo")
    )
  ) # additionally throws a warning
})

## -----------------------------------------------------------------------------
knitr::opts_chunk$set(crop = NULL)

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install("pcaExplorer")
# library("pcaExplorer")

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install("airway")

## ----eval=FALSE---------------------------------------------------------------
# library("pcaExplorer")
# pcaExplorer()

## ----ss00, echo=FALSE, fig.cap="Overview of the Data Upload panel. After clicking on the 'Load the demo airway data' button, all widgets are automatically populated, and each data component (count matrix, experimental data, dds object, annotation) can be previewed in a modal window by clicking on its respective button."----
knitr::include_graphics("unr_00_demo_loaded.png")

## ----ss01, echo=FALSE, fig.cap="Screenshot of the sample to sample scatter plot matrix. The user can select the correlation method to use, the option to plot values on log2 scales, and the possibility to use a subset of genes (to obtain a quicker overview if many samples are provided)."----
knitr::include_graphics("unr_01_splom.png")

## ----ss02, echo=FALSE, fig.cap="Screenshot of the sample to sample heatmap. Selected is the Manhattan distance, but Euclidean and correlation-based distance are also provided as options. In this case, the user has also selected the dex and cell factors in the 'Group/color by' widget in the sidebar menu, and these covariates decorate the heatmap to facilitate identification of patterns."----
knitr::include_graphics("unr_02_sts_heatmap.png")

## ----ss03, echo=FALSE, fig.cap="Screenshot of the Basic Summary of the counts in the Data Overview panel. General information are provided, together with an overview on detected genes according to different filtering criteria."----
knitr::include_graphics("unr_03_summary_counts.png")

## ----ss04a, echo=FALSE, fig.cap="The Samples View panel. Displayed are a PCA plot (left) and the corresponding scree plot (right), with the samples colored and labeled by cell type - separating on the second principal component."----
knitr::include_graphics("unr_04a_samplespca.png")

## ----ss04b, echo=FALSE, fig.cap="PCA plot for the samples, colored by dexamethasone treatment. The dex factor is the main driver of the variability in the data, and samples separate nicely on the first principal component."----
knitr::include_graphics("unr_04b_samples_dex.png")

## ----ss05, echo=FALSE, fig.cap="Genes with highest loadings on the first and second principal components. The user can select how many top and bottom genes will be displayed, and the gene names are printed below each gene's contribution on each PC."----
knitr::include_graphics("unr_05_loadings.png")

## ----ss06a, echo=FALSE, fig.cap="Plot of the gene expression levels of DUSP1. Points are split according to dex treatment, and both graphics and table are displayed."----
knitr::include_graphics("unr_06a_genefinder_dusp1.png")

## ----ss06b, echo=FALSE, fig.cap="Plot of the gene expression levels of PER1. Points are split according to dex treatment."----
knitr::include_graphics("unr_06b_genefinder_per1.png")

## ----ss06c, echo=FALSE, fig.cap="Plot of the gene expression levels of DDX3Y. Points are split according to cell type, as this gene was highly variable across this experimental factor - indeed, in one cell type it is barely detected."----
knitr::include_graphics("unr_06c_genefinder_ddx3y.png")

## ----ss07, echo=FALSE, fig.cap="The Genes View panel. Upper panel: the genes biplot, and its zoomed plot, with gene names displayed. Lower panel: the profile explorer of the selected subset of genes (corresponding to the zoomed window), and the boxplot for the gene selected by clicking close to a location in the zoomed window."----
knitr::include_graphics("unr_07_genespca.png")

## ----ss08, echo=FALSE, fig.cap="The PCA2GO panel. Four tables (2 per dimension, here only 3 are displayed) decorate the PCA plot in the middle, and display the top enriched functional categories in each subset of gene with high loadings."----
knitr::include_graphics("unr_08_pca2go_topgo.png")

## ----ss90, echo=FALSE, fig.cap="The pcaExplorer task menu. Buttons for saving the session to binary data or to a dedicated environment are displayed.",out.width="80%"----
knitr::include_graphics("unr_90_exitsave.png")

## ----ss99, echo=FALSE, fig.cap="The Report Editor tab. The collapsible elements control general markdown and editor options, which are regarded when the report is compiled. Its content is specified in the Ace editor, integrated in the Shiny app."----
knitr::include_graphics("unr_99_editreport.png")

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

#' Deprecated functions in pcaExplorer
#'
#' Functions that are on their way to the function afterlife.
#' Their successors are also listed.
#' 
#' The successors of these functions are likely coming after the rework that
#' led to the creation of the `mosdef` package. See more into its 
#' documentation for more details.
#' 
#' @param ... Ignored arguments.
#' 
#' @return All functions throw a warning, with a deprecation message pointing 
#' towards its descendent (if available).
#' 
#' @name deprecated
#' 
#' @section Transitioning to the mosdef framework:
#' 
#' - [topGOtable()] is now being replaced by the more flexible 
#' [mosdef::run_topGO()] function
#' 
#' @author Federico Marini
#' 
#' @examples
#' # try(topGOtable())
#' 
NULL


## #' @export
## #' @rdname defunct
## trendVar <- function(...) {
##   .Defunct("fitTrendVar")
## }

suppressPackageStartupMessages({
  library("DESeq2")
  library("SummarizedExperiment")
  library("airway")
  library("AnnotationDbi")
  library("org.Hs.eg.db")
})

# prepping the test datasets only once -----------------------------------------
dds <- makeExampleDESeqDataSet(n = 1000, m = 8)
rlt <- rlogTransformation(dds)
cm <- counts(dds)
cd <- colData(dds)


dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt_multifac <- rlogTransformation(dds_multifac)


data("airway", package = "airway")
dds_airway <- DESeqDataSet(airway, design = ~ cell + dex)
dds_airway <- DESeq(dds_airway)
res_airway <- results(dds_airway)

rld_airway <- rlogTransformation(dds_airway)

res_airway$symbol <- mapIds(org.Hs.eg.db,
                            keys = row.names(res_airway),
                            column = "SYMBOL",
                            keytype = "ENSEMBL",
                            multiVals = "first")
res_airway$entrez <- mapIds(org.Hs.eg.db,
                            keys = row.names(res_airway),
                            column = "ENTREZID",
                            keytype = "ENSEMBL",
                            multiVals = "first")

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()

## ----setup, echo=FALSE, warning=FALSE-----------------------------------------
library("knitr")
set.seed(42)
opts_chunk$set(comment = "#>",
               fig.align = "center",
               warning = FALSE)
stopifnot(requireNamespace("htmltools"))
htmltools::tagList(rmarkdown::html_dependency_font_awesome())

## ----out.width="50%", echo=FALSE----------------------------------------------
knitr::include_graphics(system.file("www", "pcaExplorer.png", package = "pcaExplorer"))

## ----installation, eval=FALSE-------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("pcaExplorer")

## ----installfull, eval=FALSE--------------------------------------------------
# BiocManager::install("pcaExplorer", dependencies = TRUE)

## ----installation-github, eval=FALSE------------------------------------------
# library("devtools")
# install_github("federicomarini/pcaExplorer")

## ----loadlibrary, message=FALSE-----------------------------------------------
library("pcaExplorer")

## -----------------------------------------------------------------------------
citation("pcaExplorer")

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install("org.At.tair.db")
# library("org.At.tair.db")
# # skipping the steps where you normally would generate your dds_at object...
# dds_at
# vst_at <- DESeq2::vst(dds_at)
# anno_at <- get_annotation_orgdb(dds_at,"org.At.tair.db", idtype = "TAIR")
# # subset the background to include only the expressed genes
# bg_ids <- rownames(dds_at)[rowSums(counts(dds_at)) > 0]
# library(topGO)
# pca2go_at <- pca2go(vst_at,
#                     annotation = anno_at,
#                     annopkg = "org.At.tair.db",
#                     ensToGeneSymbol = TRUE,
#                     background_genes = bg_ids)
# # and finally, with all the objects prepared...
# pcaExplorer(dds = dds_at, dst = vst_at, annotation = anno_at, pca2go = pca2go_at)

## ----installairway, eval=FALSE------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("airway")

## ----loadairway, message=FALSE------------------------------------------------
library("airway")
library("DESeq2")

data("airway", package = "airway")

dds_airway <- DESeqDataSet(airway,design= ~ cell + dex)
dds_airway
rld_airway <- rlogTransformation(dds_airway)
rld_airway

## ----launchairway, eval=FALSE-------------------------------------------------
# pcaExplorer(dds = dds_airway,
#             dst = rld_airway)

## ----annoairway, message = FALSE----------------------------------------------
library(org.Hs.eg.db)
genenames_airway <- mapIds(org.Hs.eg.db,keys = rownames(dds_airway),column = "SYMBOL",keytype="ENSEMBL")
annotation_airway <- data.frame(gene_name = genenames_airway,
                                row.names = rownames(dds_airway),
                                stringsAsFactors = FALSE)
head(annotation_airway)                                

## ----annofuncs, eval=FALSE----------------------------------------------------
# anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
#                                       orgdb_species = "org.Hs.eg.db",
#                                       idtype = "ENSEMBL")
# 
# anno_df_biomart <- get_annotation(dds = dds_airway,
#                                   biomart_dataset = "hsapiens_gene_ensembl",
#                                   idtype = "ensembl_gene_id")

## ----echo=FALSE---------------------------------------------------------------
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")

## -----------------------------------------------------------------------------
head(anno_df_orgdb)

## ----launchairwayanno, eval=FALSE---------------------------------------------
# pcaExplorer(dds = dds_airway,
#             dst = rld_airway,
#             annotation = annotation_airway) # or anno_df_orgdb, or anno_df_biomart

## ----ddsmultifac--------------------------------------------------------------
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 1)

## ----prepsimul----------------------------------------------------------------
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 1,betaSD_tissue = 3)
dds_multifac
rld_multifac <- rlogTransformation(dds_multifac)
rld_multifac
## checking how the samples cluster on the PCA plot
pcaplot(rld_multifac,intgroup = c("condition","tissue"))

## ----launchsimul, eval=FALSE--------------------------------------------------
# pcaExplorer(dds = dds_multifac,
#             dst = rld_multifac)

## ----func-pcaplot-------------------------------------------------------------
pcaplot(rld_airway,intgroup = c("cell","dex"),ntop = 1000,
        pcX = 1, pcY = 2, title = "airway dataset PCA on samples - PC1 vs PC2")

# on a different set of principal components...
pcaplot(rld_airway,intgroup = c("dex"),ntop = 1000,
        pcX = 1, pcY = 4, title = "airway dataset PCA on samples - PC1 vs PC4",
        ellipse = TRUE)

## ----func-pcaplot3d, eval=FALSE-----------------------------------------------
# pcaplot3d(rld_airway,intgroup = c("cell","dex"),ntop = 1000,
#         pcX = 1, pcY = 2, pcZ = 3)
# # will open up in the viewer

## ----func-pcascree------------------------------------------------------------
pcaobj_airway <- prcomp(t(assay(rld_airway)))
pcascree(pcaobj_airway,type="pev",
         title="Proportion of explained proportion of variance - airway dataset")

## ----func-correlatepcs--------------------------------------------------------
res_pcairway <- correlatePCs(pcaobj_airway,colData(dds_airway))

res_pcairway

plotPCcorrs(res_pcairway)

## ----func-hiloadings----------------------------------------------------------
# extract the table of the genes with high loadings
hi_loadings(pcaobj_airway,topN = 10,exprTable=counts(dds_airway))
# or alternatively plot the values
hi_loadings(pcaobj_airway,topN = 10,annotation = annotation_airway)

## ----func-genespca------------------------------------------------------------
groups_airway <- colData(dds_airway)$dex
cols_airway <- scales::hue_pal()(2)[groups_airway]
# with many genes, do not plot the labels of the genes
genespca(rld_airway,ntop=5000,
         choices = c(1,2),
         arrowColors=cols_airway,groupNames=groups_airway,
         alpha = 0.2,
         useRownamesAsLabels=FALSE,
         varname.size = 5
        )
# with a smaller number of genes, plot gene names included in the annotation
genespca(rld_airway,ntop=100,
         choices = c(1,2),
         arrowColors=cols_airway,groupNames=groups_airway,
         alpha = 0.7,
         varname.size = 5,
         annotation = annotation_airway
        )

## ----func-topGOtable, eval=FALSE----------------------------------------------
# # example not run due to quite long runtime
# dds_airway <- DESeq(dds_airway)
# res_airway <- results(dds_airway)
# res_airway$symbol <- mapIds(org.Hs.eg.db,
#                             keys=row.names(res_airway),
#                             column="SYMBOL",
#                             keytype="ENSEMBL",
#                             multiVals="first")
# res_airway$entrez <- mapIds(org.Hs.eg.db,
#                             keys=row.names(res_airway),
#                             column="ENTREZID",
#                             keytype="ENSEMBL",
#                             multiVals="first")
# resOrdered <- as.data.frame(res_airway[order(res_airway$padj),])
# head(resOrdered)
# # extract DE genes
# de_df <- resOrdered[resOrdered$padj < .05 & !is.na(resOrdered$padj),]
# de_symbols <- de_df$symbol
# # extract background genes
# bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
# bg_symbols <- mapIds(org.Hs.eg.db,
#                      keys=bg_ids,
#                      column="SYMBOL",
#                      keytype="ENSEMBL",
#                      multiVals="first")
# # run the function
# topgoDE_airway <- topGOtable(de_symbols, bg_symbols,
#                              ontology = "BP",
#                              mapping = "org.Hs.eg.db",
#                              geneID = "symbol")

## ----func-pca2go, eval=FALSE--------------------------------------------------
# pca2go_airway <- pca2go(rld_airway,
#                         annotation = annotation_airway,
#                         organism = "Hs",
#                         ensToGeneSymbol = TRUE,
#                         background_genes = bg_ids)
# # for a smooth interactive exploration, use DT::datatable
# datatable(pca2go_airway$PC1$posLoad)
# # display it in the normal R session...
# head(pca2go_airway$PC1$posLoad)
# # ... or use it for running the app and display in the dedicated tab
# pcaExplorer(dds_airway,rld_airway,
#             pca2go = pca2go_airway,
#             annotation = annotation_airway)

## ----func, message = FALSE, eval = FALSE--------------------------------------
# goquick_airway <- limmaquickpca2go(rld_airway,
#                                    pca_ngenes = 10000,
#                                    inputType = "ENSEMBL",
#                                    organism = "Hs")
# # display it in the normal R session...
# head(goquick_airway$PC1$posLoad)
# # ... or use it for running the app and display in the dedicated tab
# pcaExplorer(dds_airway,rld_airway,
#             pca2go = goquick_airway,
#             annotation = annotation_airway)

## ----func-makedataset---------------------------------------------------------

dds_simu <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 0.5)
dds_simu
dds2_simu <- makeExampleDESeqDataSet_multifac(betaSD_condition = 0.5,betaSD_tissue = 2)
dds2_simu

rld_simu <- rlogTransformation(dds_simu)
rld2_simu <- rlogTransformation(dds2_simu)
pcaplot(rld_simu,intgroup = c("condition","tissue")) + 
  ggplot2::ggtitle("Simulated data - Big condition effect, small tissue effect")
pcaplot(rld2_simu,intgroup = c("condition","tissue")) + 
  ggplot2::ggtitle("Simulated data - Small condition effect, bigger tissue effect")

## ----eval=FALSE---------------------------------------------------------------
# distro_expr(rld_airway,plot_type = "density")
# distro_expr(rld_airway,plot_type = "violin")

## -----------------------------------------------------------------------------
distro_expr(rld_airway,plot_type = "boxplot")

## -----------------------------------------------------------------------------
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 1)
dst <- DESeq2::rlogTransformation(dds)
set.seed(42)
geneprofiler(dst,paste0("gene",sample(1:1000,20)), plotZ = FALSE)

## ----eval=FALSE---------------------------------------------------------------
# anno_df_biomart <- get_annotation(dds = dds_airway,
#                                   biomart_dataset = "hsapiens_gene_ensembl",
#                                   idtype = "ensembl_gene_id")

## -----------------------------------------------------------------------------
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")

head(anno_df_orgdb)

## -----------------------------------------------------------------------------
# use a subset of the counts to reduce plotting time, it can be time consuming with many samples
pair_corr(counts(dds_airway)[1:100,])

## -----------------------------------------------------------------------------
sessionInfo()

#' Pairwise scatter and correlation plot of counts
#'
#' @param df A data frame, containing the (raw/normalized/transformed) counts
#' @param log Logical, whether to convert the input values to log2 (with addition
#' of a pseudocount). Defaults to FALSE.
#' @param method Character string, one of `pearson` (default), `kendall`, or
#' `spearman` as in `cor`
#' @param use_subset Logical value. If TRUE, only 1000 values per sample will be used
#' to speed up the plotting operations.
#'
#' @return A plot with pairwise scatter plots and correlation coefficients
#' @export
#'
#' @examples
#' library("airway")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
#'                                              colData = colData(airway),
#'                                              design = ~dex+cell)
#' pair_corr(counts(dds_airway)[1:100, ]) # use just a subset for the example
pair_corr <- function(df, log = FALSE, method = "pearson", use_subset = TRUE) {
  if (log) {
    df <- log2(1 + df)
  }
  
  if (use_subset) {
    set.seed(42)
    df <- df[sample(1:nrow(df), min(nrow(df), 1000)), ]
  }
  
  # get min and max count values for axis range.
  rangeMin <- min(df)
  rangeMax <- max(df)

  colorFunction <- colorRamp(c("black", "red"))
  # colorFunction() expects values from 0 to 1.
  zMatrix <- colorFunction(seq(0, 1, by = .01))
  # zColors goes from 1 to 100.
  zColors <- sort(rgb(zMatrix[, 1], zMatrix[, 2], zMatrix[, 3], maxColorValue = 255))
  labelSize <- 1
  title <- "Pairwise Correlations"
  # Modified from R pairs() documentation
  panel.cor <- function(x, y, digits = 2, prefix = "", cex.cor, ...) {
    usr <- par("usr"); on.exit(par(usr = usr))
    par(usr = c(0, 1, 0, 1))
    r <- abs(cor(x, y, method = method))
    txt <- format(c(r, 0.123456789), digits = digits)[1]
    txt <- paste(prefix, txt, sep = "")

    # color text based on r value and change size of text also based on r value (larger text for larger r value).
    cex.cor <- labelSize / strwidth(txt)
    # color text based on r value (red is r=1).
    text(0.5, 0.5, txt, cex = cex.cor * r * 0.7, col = zColors[r * 100])
  }
  # par(mar = c(0,0,0,0))

  pairs(df, pch = 20, col = alpha("black", 0.4),
        cex.labels = labelSize,
        main = title,
        upper.panel = panel.cor,
        xlim = c(rangeMin, rangeMax),
        ylim = c(rangeMin, rangeMax))
}

#' Extract genes with highest loadings
#'
#' @param pcaobj A `prcomp` object
#' @param whichpc An integer number, corresponding to the principal component of
#' interest
#' @param topN Integer, number of genes with top and bottom loadings
#' @param exprTable A `matrix` object, e.g. the counts of a [DESeq2::DESeqDataSet()].
#' If not NULL, returns the counts matrix for the selected genes
#' @param annotation A `data.frame` object, with row.names as gene identifiers (e.g. ENSEMBL ids)
#' and a column, `gene_name`, containing e.g. HGNC-based gene symbols
#' @param title The title of the plot
#'
#' @return A ggplot2 object, or a `matrix`, if `exprTable` is not null
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' pcaobj <- prcomp(t(SummarizedExperiment::assay(rlt)))
#' hi_loadings(pcaobj, topN = 20)
#' hi_loadings(pcaobj, topN = 10, exprTable = dds)
#' hi_loadings(pcaobj, topN = 10, exprTable = counts(dds))
#'
#' @export
hi_loadings <- function(pcaobj, whichpc = 1, topN = 10, exprTable = NULL,
                        annotation = NULL, title="Top/bottom loadings") {
  if (whichpc < 0)
    stop("Use a positive integer value for the principal component to select")
  if (whichpc > nrow(pcaobj$x))
    stop("You can not explore a principal component that is not in the data")

  geneloadings_sorted <- sort(pcaobj$rotation[, whichpc])
  geneloadings_extreme <- c(tail(geneloadings_sorted, topN), head(geneloadings_sorted, topN))

  if (!is.null(exprTable)) {
    tab <- exprTable[names(geneloadings_extreme), ]
    if (!is.null(annotation))
      rownames(tab) <- annotation$gene_name[match(rownames(tab), rownames(annotation))]
    return(tab)
  }

  if (!is.null(annotation))
    names(geneloadings_extreme) <- annotation$gene_name[match(names(geneloadings_extreme), rownames(annotation))]

  barplot(geneloadings_extreme, las = 2, col = c(rep("steelblue", topN), rep("coral", topN)),
          main = paste0(title, "PC", whichpc))
  # mydf <- data.frame(loadings=geneloadings_extreme,
  #                    geneID=names(geneloadings_extreme),
  #                    mycol = c(rep("steelblue",topN),rep("coral",topN)))
  # mydf$geneID <- factor(mydf$geneID, levels = mydf$geneID)
  # p <- ggplot(mydf,aes_string(x="geneID",y="loadings")) + geom_col(aes_string(fill = "mycol")) + theme_bw() +
  #   theme(axis.text.x=element_text(angle = 90, vjust = 0.5)) + guides(fill = FALSE) +
  #   ggtitle(paste0(title, " - PC", whichpc))
  # p
}

test_that("Check that genes with hi loadings are extracted", {
  pcaobj <- prcomp(t(SummarizedExperiment::assay(rlt)))
  anno <- data.frame(gene_id = rownames(dds), 
                     gene_name = toupper(rownames(dds)), 
                     stringsAsFactors = FALSE, 
                     row.names = rownames(dds))
  
  hi_loadings(pcaobj, 1)
  
  expect_is(hi_loadings(pcaobj, 1, exprTable = counts(dds)), "matrix")
  expect_true(
    all(rownames(hi_loadings(pcaobj, 1, exprTable = counts(dds), annotation = NULL)) %in% rownames(dds))
  )
  expect_true(
    all(rownames(hi_loadings(pcaobj, 1, exprTable = counts(dds), annotation = anno)) %in% anno$gene_name)
  )
})

#' Make a simulated DESeqDataSet for two or more experimental factors
#'
#' Constructs a simulated dataset of Negative Binomial data from different conditions.
#' The fold changes between the conditions can be adjusted with the `betaSD_condition`
#' and the `betaSD_tissue` arguments.
#'
#' This function is designed and inspired following the proposal of
#' [DESeq2::makeExampleDESeqDataSet()] from the `DESeq2` package. Credits are given
#' to Mike Love for the nice initial implementation
#'
#' @param n number of rows (genes)
#' @param m number of columns (samples)
#' @param betaSD_condition the standard deviation for condition betas, i.e. beta ~ N(0,betaSD)
#' @param betaSD_tissue the standard deviation for tissue betas, i.e. beta ~ N(0,betaSD)
#' @param interceptMean the mean of the intercept betas (log2 scale)
#' @param interceptSD the standard deviation of the intercept betas (log2 scale)
#' @param dispMeanRel a function specifying the relationship of the dispersions on
#' `2^trueIntercept`
#' @param sizeFactors multiplicative factors for each sample
#'
#' @return a [DESeq2::DESeqDataSet()] with true dispersion,
#' intercept for two factors (condition and tissue) and beta values in the
#'  metadata columns.  Note that the true betas are provided on the log2 scale.
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' dds
#' dds2 <- makeExampleDESeqDataSet_multifac(betaSD_condition = 1, betaSD_tissue = 4)
#' dds2
#'
#' @export
makeExampleDESeqDataSet_multifac <- function(n = 1000,
                                             m = 12,
                                             betaSD_condition = 1,
                                             betaSD_tissue = 3,
                                             interceptMean = 4,
                                             interceptSD = 2,
                                             dispMeanRel = function(x) 4/x + 0.1,
                                             sizeFactors = rep(1, m)) {
  beta <- cbind(rnorm(n, interceptMean, interceptSD),
                rnorm(n, 0, betaSD_condition),
                rnorm(n, 0, betaSD_tissue)) # added a tissue covariate

  dispersion <- dispMeanRel(2^(beta[, 1]))
  colData <- S4Vectors::DataFrame(
    condition = factor(rep(c("A", "B"),
                           times = c(ceiling(m/2), floor(m/2)))),
    tissue = factor(rep(
      rep(c("t1", "t2"), times = c(ceiling(m/4), floor(m/4))), 2))
  )
  x <- if (m > 1) {
    model.matrix(~colData$condition + colData$tissue)
  }  else {
    cbind(rep(1, m), rep(0, m))
  }
  mu <- t(2^(x %*% t(beta)) * sizeFactors)
  countData <- matrix(rnbinom(m * n, mu = mu, size = 1/dispersion),
                      ncol = m)
  mode(countData) <- "integer"
  colnames(countData) <- paste("sample", 1:m, sep = "")
  rowRanges <- GRanges("1", IRanges(start = (1:n - 1) * 100 +
                                      1, width = 100))
  names(rowRanges) <- paste0("gene", 1:n)
  design <- if (m > 1) {
    as.formula("~ condition", env = .GlobalEnv)
  } else {
    as.formula("~ 1", env = .GlobalEnv)
  }
  object <- DESeqDataSetFromMatrix(countData = countData, colData = colData,
                                   design = design, rowRanges = rowRanges)
  trueVals <- DataFrame(trueIntercept = beta[, 1],
                        trueBeta_condition = beta[, 2],
                        trueBeta_tissue = beta[, 3],
                        trueDisp = dispersion)
  mcols(trueVals) <- DataFrame(type = rep("input", ncol(trueVals)),
                               description = c("simulated intercept values",
                                               "simulated beta values for the condition",
                                               "simulated beta values for the tissue",
                                               "simulated dispersion values"))
  mcols(object) <- cbind(mcols(object), trueVals)
  return(object)
}

test_that("Check that example dds is generated correctly", {
  dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
  
  expect_equal(names(colData(dds)), c("condition", "tissue"))
})

#' Principal components (cor)relation with experimental covariates
#'
#' Computes the significance of (cor)relations between PCA scores and the sample
#' experimental covariates, using Kruskal-Wallis test for categorial variables
#' and the `cor.test` based on Spearman's correlation for continuous
#' variables
#'
#' @param pcaobj A `prcomp` object
#' @param coldata A `data.frame` object containing the experimental
#' covariates
#' @param pcs A numeric vector, containing the corresponding PC number
#'
#' @return A `data.frame` object with computed p values for each covariate
#' and for each principal component
#'
#' @examples
#' library(DESeq2)
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' pcaobj <- prcomp(t(assay(rlt)))
#' correlatePCs(pcaobj, colData(dds))
#'
#' @export
correlatePCs <- function(pcaobj, coldata, pcs = 1:4) {
  # split the analysis for continuous and categorial
  coldataTypes <- vapply(coldata, class, character(1))
  # extract the scores from the pc object
  x <- pcaobj$x

  # do it until 1:4 PCs
  res <- matrix(NA, nrow = length(pcs), ncol = ncol(coldata))

  colnames(res) <- colnames(coldata)
  rownames(res) <- paste0("PC_", pcs)

  for (i in 1:ncol(res)) {
    # for each covariate...
    for (j in pcs) {
      if (coldataTypes[i] %in% c("factor", "character")) {
        if (length(levels(coldata[, i])) > 1) {
          res[j, i] <- kruskal.test(x[, j], coldata[, i])$p.value
        }
      } else {
        res[j, i] <- cor.test(x[, j], coldata[, i], method = "spearman")$p.value
      }
    }
  }
  res
}


#' Plot significance of (cor)relations of covariates VS principal components
#'
#' Plots the significance of the (cor)relation of each covariate vs a principal component
#'
#' @param pccorrs A `data.frame` object generated by [correlatePCs]
#' @param pc An integer number, corresponding to the principal component of
#' interest
#' @param logp Logical, defaults to `TRUE`, displays the -`log10` of
#' the pvalue instead of the p value itself
#'
#' @return A base plot object
#'
#' @examples
#' library(DESeq2)
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- rlogTransformation(dds)
#' pcaobj <- prcomp(t(assay(rlt)))
#' res <- correlatePCs(pcaobj, colData(dds))
#' plotPCcorrs(res)
#'
#' @export
plotPCcorrs <- function(pccorrs, pc = 1, logp = TRUE) {
  selectedPC <- paste0("PC_", pc)
  pvals <- pccorrs[selectedPC, ]

  if (logp) pvals <- -log10(pvals)

  barplot(pvals, las = 2, col = "steelblue",
          main = paste0("Significance of the relations between PC ", pc, " vs covariates"),
          ylab = ifelse(logp, "-log10(pval)", "pval"))
}

test_that("Correlation of the PCs", {
  pcaobj <- prcomp(t(assay(rlt_multifac)))
  res <- correlatePCs(pcaobj, colData(dds_multifac))
  
  expect_equal(dim(res), c(4, 2))
  expect_equal(colnames(res), colnames(colData(dds_multifac)))
  
  plotPCcorrs(res)
  
  plotPCcorrs(res, logp = FALSE, pc = 2)
})

#' pcaExplorer: analyzing time-lapse microscopy imaging, from detection to tracking
#'
#' pcaExplorer provides functionality for interactive visualization of RNA-seq datasets
#' based on Principal Components Analysis. The methods provided allow for quick information
#' extraction and effective data exploration. A Shiny application encapsulates the whole analysis.
#'
#' pcaExplorer provides functionality for interactive visualization of RNA-seq datasets
#' based on Principal Components Analysis. The methods provided allow for quick information
#' extraction and effective data exploration. A Shiny application encapsulates the whole analysis.
#'
#' @import DESeq2
#' @import SummarizedExperiment
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom S4Vectors DataFrame
#' @importFrom genefilter rowVars
#' @importFrom heatmaply heatmaply
#' @importFrom plotly renderPlotly plotlyOutput
#' @importFrom scales brewer_pal hue_pal
#' @importFrom NMF aheatmap
#' @import plyr
#' @importFrom limma goana topGO
#' @importFrom AnnotationDbi select Term mapIds
#' @importMethodsFrom GOstats hyperGTest summary
#' @import GO.db
#' @import shiny
#' @import shinydashboard
#' @importFrom shinyBS bsTooltip bsCollapse bsCollapsePanel
#' @import ggplot2
#' @importFrom ggrepel geom_label_repel
#' @importFrom DT datatable
#' @importFrom shinyAce aceAutocomplete aceEditor getAceModes getAceThemes
#' updateAceEditor
#' @import threejs
#' @import biomaRt
#' @importFrom pheatmap pheatmap
#' @importFrom base64enc dataURI
#' @importFrom tidyr gather
#' @import knitr
#' @import rmarkdown
#' @importFrom grDevices dev.off pdf rainbow colorRamp rgb
#' @import methods
#'
#' @author
#' Federico Marini \email{marinif@@uni-mainz.de}, 2016
#'
#' Maintainer: Federico Marini \email{marinif@@uni-mainz.de}
#' @name pcaExplorer-pkg
#' @docType package
"_PACKAGE"

.onAttach <- function(libname, pkgname) {
  pkgVersion <- packageDescription("pcaExplorer", fields = "Version")
  msg <- paste0("Welcome to pcaExplorer v", pkgVersion, "\n\n")
  citation <- paste0("If you use pcaExplorer in your work, please cite:\n\n",
                     "pcaExplorer: an R/Bioconductor package for interacting with RNA-seq principal components\n",
                     "Federico Marini, Harald Binder\n",
                     "BMC Bioinformatics, 2019 - https://doi.org/10.1186/s12859-019-2879-1\n")
  packageStartupMessage(paste0(msg, citation))
}

#' Get an annotation data frame from biomaRt
#'
#' @param dds A [DESeq2::DESeqDataSet()] object
#' @param biomart_dataset A biomaRt dataset to use. To see the list, type
#' `mart = useMart('ensembl')`, followed by `listDatasets(mart)`.
#' @param idtype Character, the ID type of the genes as in the row names of
#' `dds`, to be used for the call to [biomaRt::getBM()]
#'
#' @return A data frame for ready use in `pcaExplorer`, retrieved from biomaRt.
#' @export
#'
#' @examples
#' library("airway")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
#'                                              colData = colData(airway),
#'                                              design = ~dex+cell)
#' \dontrun{
#' get_annotation(dds_airway, "hsapiens_gene_ensembl", "ensembl_gene_id")
#' }
get_annotation <- function(dds, biomart_dataset, idtype) {
  if (is.null(biomart_dataset))
    stop("Select a species to generate the corresponding annotation.
To obtain a list, type mart = useMart('ensembl'), followed by listDatasets(mart).")

  mart <- useMart(biomart = "ENSEMBL_MART_ENSEMBL",
                  host = "www.ensembl.org",
                  dataset = biomart_dataset)
  anns <- getBM(attributes = c(idtype, "external_gene_name", "description"),
                filters = idtype,
                values = rownames(dds),
                mart = mart)

  # keep and match with the ones that are actually there
  anns2 <- anns[match(rownames(dds), anns[, 1]), ]
  rownames(anns2) <- rownames(dds)
  # rename the columns rsp. add row names to be consistent with other function
  colnames(anns2) <- c("gene_id", "gene_name", "description")

  return(anns2)
}


#' Get an annotation data frame from org db packages
#'
#' @param dds A [DESeq2::DESeqDataSet()] object
#' @param orgdb_species Character string, named as the `org.XX.eg.db`
#' package which should be available in Bioconductor
#' @param idtype Character, the ID type of the genes as in the row names of
#' `dds`, to be used for the call to [AnnotationDbi::mapIds()]
#' @param key_for_genenames Character, corresponding to the column name for the 
#' key in the orgDb package containing the official gene name (often called 
#' gene symbol). 
#' This parameter defaults to "SYMBOL", but can be adjusted in case the key is not
#' found in the annotation package (e.g. for `org.Sc.sgd.db`).
#'
#' @return A data frame for ready use in `pcaExplorer`, retrieved from the
#' org db packages
#' @export
#'
#' @examples
#' library("airway")
#' data("airway", package = "airway")
#' airway
#' dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
#'                                              colData = colData(airway),
#'                                              design = ~dex+cell)
#' anno_df <- get_annotation_orgdb(dds_airway, "org.Hs.eg.db", "ENSEMBL")
#' head(anno_df)
get_annotation_orgdb <- function(dds, orgdb_species, idtype, key_for_genenames = "SYMBOL") {
  if (is.null(orgdb_species))
    stop("Select a species to generate the corresponding annotation")

  orgdbpkgs <- data.frame(
    pkg = c("org.Ag.eg.db", "org.At.tair.db", "org.Bt.eg.db", "org.Ce.eg.db", "org.Cf.eg.db", "org.Dm.eg.db", "org.Dr.eg.db", "org.EcK12.eg.db",
            "org.EcSakai.eg.db", "org.Gg.eg.db", "org.Hs.eg.db", "org.Hs.ipi.db", "org.Mm.eg.db", "org.Mmu.eg.db", "org.Pf.plasmo.db",
            "org.Pt.eg.db", "org.Rn.eg.db", "org.Sc.sgd.db", "org.Sco.eg.db", "org.Ss.eg.db", "org.Tgondii.eg.db", "org.Xl.eg.db"),
    descr = c("Anopheles", "Arabidopsis", "Bovine", "Worm", "Canine", "Fly", "Zebrafish", "E coli strain K12", "E coli strain Sakai", "Chicken",
              "Human", "org.Hs.ipi.db", "Mouse", "Rhesus", "Malaria", "Chimp", "Rat", "Yeast", "Streptomyces coelicolor", "Pig", "Toxoplasma gondii",
              "Xenopus"),
    stringsAsFactors = FALSE
  )

  if (!(orgdb_species %in% orgdbpkgs$pkg)) {
    message("The orgDB package is most likely not existent in Bioconductor")
    message("It should be one of", orgdbpkgs$pkg)
  }

  if (!require(orgdb_species, character.only = TRUE))
    stop("The package ", orgdb_species, " is not installed/available. Try installing it with BiocManager::install('", orgdb_species, "')")

  if (!(idtype %in% keytypes(eval(parse(text = orgdb_species))))) {
    stop("The key you provided is not listed as key for the annotation package. Please try one of ",
         paste(keytypes(eval(parse(text = orgdb_species))), collapse = ","))
  }

  if (!(key_for_genenames %in% keytypes(eval(parse(text = orgdb_species))))) {
    stop("The key specified for containing gene names is not included in the annotation package. Please try one of ",
         paste(keytypes(eval(parse(text = orgdb_species))), collapse = ","))
  }
  
  
  pkg <- eval(parse(text = orgdb_species))

  if (idtype == "SYMBOL")
    warning("You probably do not need to convert symbol to symbol") # the performance would somehow be affected

  anns_vec <- mapIds(pkg, keys = rownames(dds), column = key_for_genenames,
                     keytype = idtype)

  anns <- data.frame(
    gene_id = rownames(dds),
    gene_name = anns_vec,
    stringsAsFactors = FALSE,
    row.names = rownames(dds)
  )
  return(anns)
}

test_that("Annotation data frame retrieval", {
  anno_df <- get_annotation_orgdb(dds_airway, "org.Hs.eg.db", "ENSEMBL")
  
  expect_s3_class(anno_df, "data.frame")
  expect_true(all(dim(anno_df) == c(63677, 2)))
})

#' Extract and plot the expression profile of genes
#'
#' @param se A [DESeq2::DESeqDataSet()] object, or a
#' [DESeq2::DESeqTransform()] object.
#' @param genelist An array of characters, including the names of the genes of
#' interest of which the profile is to be plotted
#' @param intgroup A factor, needs to be in the `colnames` of `colData(se)`
#' @param plotZ Logical, whether to plot the scaled expression values. Defaults to
#' `FALSE`
#'
#' @return A plot of the expression profile for the genes
#' @export
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' geneprofiler(rlt, paste0("gene", sample(1:1000, 20)))
#' geneprofiler(rlt, paste0("gene", sample(1:1000, 20)), plotZ = TRUE)
geneprofiler <- function(se, genelist = NULL, intgroup = "condition", plotZ = FALSE) {
  if (is.null(genelist))
    stop("Provide at least one gene to the genelist parameter")
  # check that at least one gene is found
  genelist <- unique(genelist)
  message("You provided ", length(genelist), " unique identifiers")
  inthedata <- genelist %in% rownames(se)
  if (sum(inthedata) == 0)
    stop("None of the provided genes were found in the experiment data")
  message(sum(inthedata), " out of ", length(genelist), " provided genes were found in the data")

  mydata <- as.data.frame(t(assay(se)[genelist, ]))

  # resort the order of the rows according to the groups that are selected
  mygroups <- interaction(as.data.frame(colData(se)[intgroup]))
  mydata <- mydata[order(mygroups), ]

  if (plotZ) {
    # remove 0 variance genes
    rv <- rowVars(t(mydata))
    mydata <- mydata[, rv > 0]

    mydata <- scale(mydata, center = TRUE, scale=TRUE)
    # was...
    # mydata <- NMF:::scale_mat(mydata,"col")
  }
  mylabels <- colnames(se)[order(mygroups)]
  mycols <- scales::hue_pal()(length(levels(mygroups)))[sort(mygroups)]

  par(mar=c(7.1, 4.1, 2.1, 2.1))
  plot(mydata[, 1], type = "l", xaxt = "n", las = 2, ylim = range(mydata), xlab = "", ylab = ifelse(plotZ, "scaled expression value", "expression value"))
  Map(function(x, y, z)
    axis(1, at = x, col.axis = y, labels = z, lwd = 0, las = 2),
    1:nrow(mydata),
    mycols,
    mylabels
  )
  axis(1, at = 1:nrow(mydata), labels = FALSE)

  for (i in 2:(ncol(mydata) - 1)){
      lines(mydata[, i], type = "l", xaxt = "n", las = 2, col = i)
  }
  ## TODO: if desired, plot only the avg pro group -> maybe as boxplot?
}

#' Sample PCA plot for transformed data
#'
#' Plots the results of PCA on a 2-dimensional space
#'
#' @param x A [DESeq2::DESeqTransform()] object, with data in `assay(x)`,
#' produced for example by either [DESeq2::rlog()] or
#' [DESeq2::varianceStabilizingTransformation()]/[DESeq2::vst()]
#' @param intgroup Interesting groups: a character vector of
#' names in `colData(x)` to use for grouping. Defaults to NULL, which would then 
#' select the first column of the `colData` slot
#' @param ntop Number of top genes to use for principal components,
#' selected by highest row variance
#' @param returnData logical, if TRUE returns a data.frame for further use, containing the
#' selected principal components and intgroup covariates for custom plotting
#' @param title The plot title
#' @param pcX The principal component to display on the x axis
#' @param pcY The principal component to display on the y axis
#' @param text_labels Logical, whether to display the labels with the sample identifiers
#' @param point_size Integer, the size of the points for the samples
#' @param ellipse Logical, whether to display the confidence ellipse for the selected groups
#' @param ellipse.prob Numeric, a value in the interval [0;1)
#'
#' @return An object created by `ggplot`, which can be assigned and further customized.
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' pcaplot(rlt, ntop = 200)
#'
#' @export
pcaplot <- function(x, 
                    intgroup = NULL, 
                    ntop = 500, 
                    returnData = FALSE,
                    title = NULL,
                    pcX = 1, 
                    pcY = 2, 
                    text_labels = TRUE, 
                    point_size = 3,
                    ellipse = TRUE, 
                    ellipse.prob = 0.95) # customized principal components
{
  rv <- rowVars(assay(x))
  select <- order(rv, decreasing = TRUE)[seq_len(min(ntop, length(rv)))]
  pca <- prcomp(t(assay(x)[select, ]))

  percentVar <- pca$sdev^2/sum(pca$sdev^2)
  
  if (is.null(intgroup)) {
    # gently fall back to the first colData element if it is there
    if (length(names(colData(x))) > 0) {
      intgroup <- names(colData(x))[1]
      message("Defaulting to '", intgroup, "' as the `intgroup` parameter...")
    } else {
      stop("No colData has been provided, therefore `intgroup` cannot be selected properly")
    }
  }

  if (!all(intgroup %in% names(colData(x)))) {
    stop("the argument 'intgroup' should specify columns of colData(x)")
  }
  intgroup.df <- as.data.frame(colData(x)[, intgroup, drop = FALSE])
  group <- factor(apply(intgroup.df, 1, paste, collapse = " : "))
  d <- data.frame(PC1 = pca$x[, pcX], PC2 = pca$x[, pcY], group = group,
                  intgroup.df, names = colnames(x))
  colnames(d)[1] <- paste0("PC", pcX)
  colnames(d)[2] <- paste0("PC", pcY)

  if (returnData) {
    attr(d, "percentVar") <- percentVar[c(pcX, pcY)]
    return(d)
  }

  # clever way of positioning the labels - worked good, then no need with ggrepel
  d$hjust <- ifelse((sign(d[, paste0("PC", pcX)]) == 1), 0.9, 0.1)# (1 + varname.adjust * sign(PC1))/2)

  g <- ggplot(data = d, aes_string(x = paste0("PC", pcX), y = paste0("PC", pcY), color = "group")) +
    geom_point(size = point_size) +
    xlab(paste0("PC", pcX, ": ", round(percentVar[pcX] * 100, digits = 2), "% variance")) +
    ylab(paste0("PC", pcY ,": ", round(percentVar[pcY] * 100, digits = 2), "% variance"))

  ## plot confidence ellipse
  # credit to vince vu, author of ggbiplot
  if (ellipse) {
    theta <- c(seq(-pi, pi, length = 50), seq(pi, -pi, length = 50))
    circle <- cbind(cos(theta), sin(theta))

    ell <- ddply(d, "group", function(x) {
      if (nrow(x) <= 2) {
        return(NULL)
      }
      sigma <- var(cbind(x[[paste0("PC", pcX)]], x[[paste0("PC", pcY)]]))
      mu <- c(mean(x[[paste0("PC", pcX)]]), mean(x[[paste0("PC", pcY)]]))
      ed <- sqrt(qchisq(ellipse.prob, df = 2))
      data.frame(sweep(circle %*% chol(sigma) * ed, 2, mu, FUN = '+'),
                 groups = x$group[1])
    })
    # names(ell)[1:2] <- c('xvar', 'yvar')
    if (nrow(ell) > 0) {
      g <- g + geom_path(data = ell, aes_string(x = "X1", y = "X2", color = "groups", group = "groups"))
    }
  }

  if (text_labels)
    g <- g + geom_label_repel(mapping = aes_string(label = "names", 
                                                   fill = "group"),
                              color = "white", 
                              segment.color = "grey80",
                              show.legend = TRUE)

  plot_title <- paste0("PCA plot - top ", length(select), " variable genes")
  if (!is.null(title)) {
    g <- g + ggtitle(title)
  } else {
    g <- g + ggtitle(plot_title)
  }
  g <- g + theme_bw()
  # as in http://www.huber.embl.de/msmb/Chap-Graphics.html
  # "well-made PCA plots usually have a width that’s larger than the height"
  g <- g + coord_fixed()
  g
}


#' Scree plot of the PCA on the samples
#'
#' Produces a scree plot for investigating the proportion of explained variance, or
#' alternatively the cumulative value
#'
#' @param obj A `prcomp` object
#' @param type Display absolute proportions or cumulative proportion. Possible values:
#' "pev" or "cev"
#' @param pc_nr How many principal components to display max
#' @param title Title of the plot
#'
#' @return An object created by `ggplot`, which can be assigned and further customized.
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' pcaobj <- prcomp(t(SummarizedExperiment::assay(rlt)))
#' pcascree(pcaobj, type = "pev")
#' pcascree(pcaobj, type = "cev", title = "Cumulative explained proportion of variance - Test dataset")
#'
#' @export
pcascree <- function(obj, type = c("pev", "cev"),pc_nr=NULL,title=NULL)
{
  type <- match.arg(type)
  d <- obj$sdev^2
  yvar <- switch(type, pev = d/sum(d), cev = cumsum(d)/sum(d))
  yvar.lab <- switch(type, pev = "proportion of explained variance",
                     cev = "cumulative proportion of explained variance")
  # df <- data.frame(PC = 1:length(d), yvar = yvar)

  if (!is.null(pc_nr)) {
    colsize <- pc_nr
    yvar <- yvar[1:pc_nr]
  } else {
    colsize <- length(d)
    yvar <- yvar[1:length(d)]
  }

  pc_df <- data.frame(PC_count = 1:colsize, var = yvar)

  if(type=="pev"){
    p <- ggplot(pc_df, aes_string(x = "PC_count", y = "var")) + geom_bar(stat = "identity")
    p <- p + scale_x_continuous(breaks = 1:length(d))
    p <- p + ylab(yvar.lab) + xlab("principal components")
    # p
  } else {
    p <- ggplot(pc_df, aes_string(x = "PC_count", y = "var")) + geom_point() +
      geom_path() + scale_x_continuous(breaks = 1:length(d))
    p <- p + ylab(yvar.lab) + xlab("principal components") + ylim(0,max(pc_df$var))
    # p
  }
  if(!is.null(title)) p <- p + ggtitle(title)
  p <- p + theme_bw()
  p
}


#' Sample PCA plot for transformed data
#'
#' Plots the results of PCA on a 3-dimensional space, interactively
#'
#' @param x A [DESeq2::DESeqTransform()] object, with data in `assay(x)`,
#' produced for example by either [DESeq2::rlog()] or
#' [DESeq2::varianceStabilizingTransformation()]
#' @param intgroup Interesting groups: a character vector of
#' names in `colData(x)` to use for grouping
#' @param ntop Number of top genes to use for principal components,
#' selected by highest row variance
#' @param returnData logical, if TRUE returns a data.frame for further use, containing the
#' selected principal components and intgroup covariates for custom plotting
#' @param title The plot title
#' @param pcX The principal component to display on the x axis
#' @param pcY The principal component to display on the y axis
#' @param pcZ The principal component to display on the z axis
#' @param text_labels Logical, whether to display the labels with the sample identifiers
#' @param point_size Integer, the size of the points for the samples
#'
#' @return A html-based visualization of the 3d PCA plot
#' @export
#'
#' @examples
#' dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
#' rlt <- DESeq2::rlogTransformation(dds)
#' pcaplot3d(rlt, ntop = 200)
pcaplot3d <- function (x, intgroup = "condition", ntop = 500, returnData = FALSE,title=NULL,
                     pcX = 1, pcY = 2, pcZ = 3, text_labels=TRUE,point_size=3)
{
  rv <- rowVars(assay(x))
  select <- order(rv, decreasing = TRUE)[seq_len(min(ntop,length(rv)))]
  pca <- prcomp(t(assay(x)[select, ]))

  percentVar <- pca$sdev^2/sum(pca$sdev^2)

  if (!all(intgroup %in% names(colData(x)))) {
    stop("the argument 'intgroup' should specify columns of colData(x)")
  }
  intgroup.df <- as.data.frame(colData(x)[, intgroup, drop = FALSE])
  group <- factor(apply(intgroup.df, 1, paste, collapse = " : "))
  d <- data.frame(PC1 = pca$x[, pcX], PC2 = pca$x[, pcY], PC3 = pca$x[,pcZ],
                  group = group,
                  intgroup.df, names = colnames(x))
  colnames(d)[1] <- paste0("PC", pcX, ": ", round(percentVar[pcX] * 100,digits = 2), "% variance")
  colnames(d)[2] <- paste0("PC", pcY, ": ", round(percentVar[pcY] * 100,digits = 2), "% variance")
  colnames(d)[3] <- paste0("PC", pcZ, ": ", round(percentVar[pcZ] * 100,digits = 2), "% variance")

  if (returnData) {
    attr(d, "percentVar") <- percentVar[1:3]
    return(d)
  }

  nrgroups <- length(levels(d$group))
  cols <- hue_pal()(nrgroups)[d$group]

  scatterplot3js(as.matrix(d[, 1:3]),
                 color = cols,
                 # renderer = "canvas",
                 size = 1.3,
                 labels = rownames(d), label.margin ="50px 50px 50px 50px")
}

test_that("Checks on the pca on the samples", {
  pcaobj <- prcomp(t(assay(rlt_multifac)))
  
  colData(dds_multifac)
  
  pcaplot(rlt_multifac)
  dat <- pcaplot(rlt_multifac, returnData = TRUE)
  
  p <- pcaplot(rlt_multifac, intgroup = c("condition", "tissue"))
  expect_true(is(p, "gg"))
  
  expect_message({
    p_def <- pcaplot(rlt_multifac)
    expect_true(is(p_def, "gg"))
  }, "Defaulting to 'condition'")
  
  expect_error({
    rlt_nocoldata <- rlt_multifac
    colData(rlt_nocoldata)$condition <- NULL
    colData(rlt_nocoldata)$tissue <- NULL
    colData(rlt_nocoldata)$sizeFactor <- NULL
    
    pcaplot(rlt_nocoldata)
  },
  "No colData has been provided")
  
  dat <- pcaplot(rlt_multifac, intgroup = c("condition", "tissue"), returnData = TRUE)
  
  expect_error(pcaplot(rlt_multifac, intgroup = "foo"))
  
  p2 <- pcascree(pcaobj)
  expect_true(is(p2, "gg"))
  p3 <- pcascree(pcaobj, type = "cev")
  expect_true(is(p3, "gg"))
  expect_error(pcascree(pcaobj, type = "foo"))
})

# About this report

This content has been loaded from the template report `.Rmd` file. Please edit it at your best convenience!

If you are viewing this report in the Preview, you might require the installation of the PhantomJS to render correctly some HTML widgets. 
This can be done by using the `r BiocStyle::CRANpkg("webshot")` package and calling `webshot::install_phantomjs()`.
Alternatively, the more recent `r BiocStyle::CRANpkg("webshot2")` package uses the headless Chrome browser (via the `r BiocStyle::CRANpkg("chromote")` package, requiring Google Chrome or other Chromium-based browser).

```{r setup, include=FALSE, eval = TRUE, echo = FALSE}
opts_chunk$set(
  echo=input$report_echo,
  error=TRUE
)
```

# Overview on the data

The data provided was used to construct the following objects

```{r}
values$mydds

values$mydst

values$transformation_type

head(values$myannotation)
```

The following design were used:

```{r}
DT::datatable(as.data.frame(colData(values$mydds)))
```

An overview of the table for the features is shown here, by displaying the `r input$countstable_unit`

```{r}
if(input$countstable_unit=="raw_counts")
  currentMat <- counts(values$mydds,normalized=FALSE)
if(input$countstable_unit=="normalized_counts")
  currentMat <- counts(values$mydds,normalized=TRUE)
if(input$countstable_unit=="rlog_counts")
  currentMat <- assay(values$mydst)
if(input$countstable_unit=="log10_counts")
  currentMat <- log10(1 + counts(values$mydds,normalized=TRUE))
```

```{r, warning=FALSE}
DT::datatable(currentMat)
```

This is how the samples cluster if we use euclidean distance on the rlog transformed values

```{r}
if (!is.null(input$color_by)){
  expgroups <- as.data.frame(colData(values$mydst)[,input$color_by])
  # expgroups <- interaction(expgroups)
  rownames(expgroups) <- colnames(values$mydst)
  colnames(expgroups) <- input$color_by

  pheatmap(as.matrix(dist(t(assay(values$mydst)))),annotation_col = expgroups)
} else {
  pheatmap(as.matrix(dist(t(assay(values$mydst)))))
}

```

This is an overview of the number of available reads in each sample (normally these are only uniquely aligned reads)

```{r}
rr <- colSums(counts(values$mydds))/1e6
if(is.null(names(rr)))
  names(rr) <- paste0("sample_",1:length(rr))
rrdf <- data.frame(Reads=rr,Sample=names(rr),stringsAsFactors = FALSE)
if (!is.null(input$color_by)) {
  selGroups <- as.data.frame(colData(values$mydds)[input$color_by])
  rrdf$Group <- interaction(selGroups)
  p <- ggplot(rrdf,aes_string("Sample",weight="Reads")) + geom_bar(aes_string(fill="Group")) + theme_bw()
  p
} else {
  p <- ggplot(rrdf,aes_string("Sample",weight="Reads")) + geom_bar() + theme_bw()
  p
}

print(colSums(counts(values$mydds)))
summary(colSums(counts(values$mydds))/1e6)      
```

This is a quick info on the number of detected genes

```{r}
t1 <- rowSums(counts(values$mydds))
t2 <- rowMeans(counts(values$mydds,normalized=TRUE))

thresh_rowsums <- input$threshold_rowsums
thresh_rowmeans <- input$threshold_rowmeans
abs_t1 <- sum(t1 > thresh_rowsums)
rel_t1 <- 100 * mean(t1 > thresh_rowsums)
abs_t2 <- sum(t2 > thresh_rowmeans)
rel_t2 <- 100 * mean(t2 > thresh_rowmeans)

cat("Number of detected genes:\n")
# TODO: parametrize the thresholds
cat(abs_t1,"genes have at least a sample with more than",thresh_rowsums,"counts\n")
cat(paste0(round(rel_t1,3),"%"), "of the",nrow(values$mydds),"genes have at least a sample with more than",thresh_rowsums,"counts\n")
cat(abs_t2,"genes have more than",thresh_rowmeans,"counts (normalized) on average\n")
cat(paste0(round(rel_t2,3),"%"), "of the",nrow(values$mydds),"genes have more than",thresh_rowsums,"counts (normalized) on average\n")
cat("Counts are ranging from", min(counts(values$mydds)),"to",max(counts(values$mydds)))
```

# PCA on the samples

This plot shows how the samples are related to each other by plotting PC `r input$pc_x` vs PC `r input$pc_y`, using the top `r input$pca_nrgenes` most variable genes

```{r}
res <- pcaplot(values$mydst,intgroup = input$color_by,ntop = input$pca_nrgenes,
               pcX = as.integer(input$pc_x),pcY = as.integer(input$pc_y),
               text_labels = input$sample_labels,
               point_size = input$pca_point_size, title="Samples PCA - zoom in",
               ellipse = input$pca_ellipse, ellipse.prob = input$pca_cislider
)
res <- res + theme_bw()
res
```

The scree plot helps determining the number of underlying principal components

```{r}
rv <- rowVars(assay(values$mydst))
select <- order(rv, decreasing = TRUE)[seq_len(min(input$pca_nrgenes,length(rv)))]
pca <- prcomp(t(assay(values$mydst)[select, ]))

res <- pcascree(pca,type = input$scree_type, pc_nr = input$scree_pcnr, title="Scree plot for the samples PCA")
res <- res + theme_bw()
res
```

The genes with the highest loadings in the selected principal components are the following

```{r}
rv <- rowVars(assay(values$mydst))
select <- order(rv, decreasing = TRUE)[seq_len(min(input$pca_nrgenes,length(rv)))]
pca <- prcomp(t(assay(values$mydst)[select, ]))

par(mfrow=c(2,1))
hi_loadings(pca,whichpc = as.integer(input$pc_x),topN = input$ntophiload,annotation = values$myannotation)
hi_loadings(pca,whichpc = as.integer(input$pc_y),topN = input$ntophiload,annotation = values$myannotation)
```

# PCA on the genes

This plot illustrates how the top `r input$pca_nrgenes` variant genes are distributed in PC `r input$pc_x` vs PC `r input$pc_y`

```{r}
if(!is.null(input$color_by)) {
  expgroups <- as.data.frame(colData(values$mydst)[,input$color_by])
  expgroups <- interaction(expgroups)
  expgroups <- factor(expgroups,levels=unique(expgroups))
  
} else {
  expgroups <- colnames(values$mydst)
}
colGroups <- colSel()[factor(expgroups)]

res <- genespca(values$mydst,
                ntop = input$pca_nrgenes,
                choices = c(as.integer(input$pc_x),as.integer(input$pc_y)),
                biplot = TRUE,
                arrowColors = factor(colGroups,levels=unique(colGroups)),
                groupNames = expgroups,
                alpha=input$pca_point_alpha,coordEqual=FALSE,useRownamesAsLabels=FALSE,labels.size=input$pca_label_size,
                point_size=input$pca_point_size,varname.size=input$pca_varname_size, scaleArrow = input$pca_scale_arrow,
                annotation=values$myannotation)
res
```


For the selected genes, this is the overall profile across all samples

```{r}
if(!is.null(input$pcagenes_brush) & length(input$color_by)>0)
  geneprofiler(values$mydst,
               genelist = curData_brush()$ids,
               intgroup = input$color_by,
               plotZ = input$zprofile)
```

And here is an interactive heatmap for that subset

```{r}

if(!is.null(input$pcagenes_brush))
{
  brushedObject <- curData_brush()
  if(nrow(brushedObject) > 1){
    selectedGenes <- brushedObject$ids
    toplot <- assay(values$mydst)[selectedGenes,]
    rownames(toplot) <- values$myannotation$gene_name[match(rownames(toplot),rownames(values$myannotation))]
    
    mycolss <- c("#313695","#4575b4","#74add1","#abd9e9","#e0f3f8","#fee090","#fdae61","#f46d43","#d73027","#a50026") # to be consistent with red/blue usual coding
    
    heatmaply(toplot,Colv = as.logical(input$heatmap_colv),colors = mycolss)
  }
}

```

# Shortlisted genes

This gene was selected in the interactive session.

```{r}
anno_id <- rownames(values$mydst)
anno_gene <- values$myannotation$gene_name

# if(is.null(input$color_by) & input$genefinder!="")
#   return(ggplot() + annotate("text",label="Select a factor to plot your gene",0,0) + theme_bw())
# if(is.null(input$color_by) & input$genefinder=="")
#   return(ggplot() + annotate("text",label="Select a gene and a factor to plot gene",0,0) + theme_bw())
# if(input$genefinder=="")
#   return(ggplot() + annotate("text",label="Type in a gene name/id",0,0) + theme_bw())
# if(!input$genefinder %in% anno_gene & !input$genefinder %in% anno_id)
#   return(ggplot() + annotate("text",label="Gene not found...",0,0) + theme_bw())
if(input$genefinder!="") {
  
  if (input$genefinder %in% anno_id) {
    selectedGene <- rownames(values$mydst)[match(input$genefinder,rownames(values$mydst))]
    selectedGeneSymbol <- values$myannotation$gene_name[match(selectedGene,rownames(values$myannotation))]
  }
  if (input$genefinder %in% anno_gene) {
    selectedGeneSymbol <- values$myannotation$gene_name[which(values$myannotation$gene_name==input$genefinder)]
    if (length(selectedGeneSymbol) > 1) return(ggplot() + annotate("text",label=paste0("Type in a gene name/id of the following:\n",paste(selectedGene,collapse=", ")),0,0) + theme_bw())
    selectedGene <- rownames(values$myannotation)[which(values$myannotation$gene_name==input$genefinder)]
  }
  genedata <- plotCounts(values$mydds,gene=selectedGene,intgroup = input$color_by,returnData = TRUE)
  onlyfactors <- genedata[,match(input$color_by,colnames(genedata))]
  genedata$plotby <- interaction(onlyfactors)
  
  if (input$plot_style == "boxplot") {
    plot_style <- "boxplot"
  } else if (input$plot_style == "violin plot") {
    plot_style <- "violin"
  } else {
    plot_style <- "auto"
  }
  
  res <- mosdef::gene_plot(de_container = values$mydds,
                           gene = selectedGene,
                           intgroup = input$color_by,
                           annotation_obj = values$myannotation,
                           normalized = TRUE,
                           labels_display = input$addsamplelabels,
                           plot_type = plot_style)
  
  if (input$ylimZero) {
    res <- res + scale_y_log10(name = "Normalized counts - log10 scale", limits = c(0.4, NA))
  } else {
    res <- res + scale_y_log10(name = "Normalized counts - log10 scale")
  }
  
  res <- res +
    labs(title = paste0("Normalized counts for ", selectedGeneSymbol, " - ", selectedGene)) +
    scale_x_discrete(name = "") +
    scale_fill_discrete(name = "Experimental\nconditions")
  
  exportPlots$genefinder_countsplot <- res
  
  res
}
```

Repeat the same chunk of code and change the identifier of the gene to obtain the similar plot for the other candidates.

# Functional interpretation of the principal components

These tables report the functional categories enriched in the genes with the top and bottom loadings in the selected principal components.

```{r}
if(!is.null(values$mypca2go))
{
  goe <- values$mypca2go[[paste0("PC",input$pc_x)]][["posLoad"]]
  kable(goe, caption=paste0("Functional categories enriched in ","PC",input$pc_x, "- positive loadings"))
}

if(!is.null(values$mypca2go))
{
  goe <- values$mypca2go[[paste0("PC",input$pc_x)]][["negLoad"]]
  kable(goe, caption=paste0("Functional categories enriched in ","PC",input$pc_x, "- negative loadings"))
}

if(!is.null(values$mypca2go))
{
  goe <- values$mypca2go[[paste0("PC",input$pc_y)]][["posLoad"]]
  kable(goe, caption=paste0("Functional categories enriched in ","PC",input$pc_y, "- positive loadings"))
}

if(!is.null(values$mypca2go))
{
  goe <- values$mypca2go[[paste0("PC",input$pc_y)]][["negLoad"]]
  kable(goe, caption=paste0("Functional categories enriched in ","PC",input$pc_y, "- negative loadings"))
}
```

# Multifactor exploration of the dataset

```{r}

if(input$composemat > 0){
  pcmat <- obj3()[[1]]
  tcol <- obj3()[[2]]
  tcol2 <- obj3()[[3]]
  pres <- prcomp(t(pcmat),scale=FALSE)
  
  plot.index <- c(as.integer(input$pc_x_multifac),as.integer(input$pc_y_multifac))
  offset <- ncol(pcmat)/2
  gene.no <- offset
  pcx <- pres$x
  # set.seed(11)
  # for (i in 1:ncol(pcx)) {
  #   pcx[,i] <- pcx[,i] + rnorm(nrow(pcx),sd=diff(range(pcx[,i]))/100)
  # }
  plot(pcx[(offset+1):ncol(pcmat),plot.index[1]][1:gene.no],pcx[(offset+1):ncol(pcmat),plot.index[2]][1:gene.no],xlim=range(pcx[,plot.index[1]]),ylim=range(pcx[,plot.index[2]]),pch=20,col=tcol,cex=0.3)#,type="n")
  #plot(0,type="n",xlim=range(pres$x[,plot.index]),ylim=range(pres$x[,plot.index]))
  lcol <- ifelse(tcol != tcol2,"black","grey")
  for (i in 1:gene.no) {
    lines(pcx[c(i,offset+i),plot.index[1]],pcx[c(i,offset+i),plot.index[2]],col=lcol[i])
  }
  points(pcx[1:offset,plot.index[1]][1:gene.no],pcx[1:offset,plot.index[2]][1:gene.no],pch=20,col=tcol,cex=0.3)
  points(pcx[(offset+1):ncol(pcmat),plot.index[1]][1:gene.no],pcx[(offset+1):ncol(pcmat),plot.index[2]][1:gene.no],pch=20,col=tcol2,cex=0.3)}
```

# About pcaExplorer

`pcaExplorer` is a Bioconductor package containing a Shiny application for
analyzing expression data in different conditions and experimental factors. 

`pcaExplorer` guides the user in exploring the Principal Components of the data, 
providing tools and functionality to detect outlier samples, genes that show 
particular patterns, and additionally provides a functional interpretation of 
the principal components for further quality assessment and hypothesis generation
on the input data. 

Thanks to its interactive/reactive design, it is designed to become a practical
companion to any RNA-seq dataset analysis, making exploratory data analysis 
accessible also to the bench biologist, while providing additional insight also
for the experienced data analyst.

`pcaExplorer` was developed in the Bioinformatics Division led by Harald Binder 
at the IMBEI (Institut für Medizinische Biometrie, Epidemiologie und Informatik) 
in the University Medical Center of the Johannes Gutenberg University Mainz.

## Developers

`pcaExplorer` is currently maintained by Federico Marini at the IMBEI (www.imbei.uni-mainz.de).
You can contact him by clicking on the button below.

<a href="mailto:mailto:marinif@uni-mainz.de?subject=[pcaExplorer_feedback]" class="btn btn-primary">Federico Marini</a>

## Code

`pcaExplorer` is a part of the Bioconductor project (www.bioconductor.org).
All code for `pcaExplorer`, especially for the development version, is available
on <a href="https://github.com/federicomarini/pcaExplorer" target="_blank">GitHub</a>.

# Citation info

If you use `pcaExplorer` for your analysis, please cite it as here below:

```{r}
citation("pcaExplorer")
```

# Session Information

```{r}
sessionInfo()
```

```{r, echo = FALSE}
library(shiny)
footertemplate <- function(){
  tags$div(
    class = "footer",
    style = "text-align:center",
    tags$div(
      class = "foot-inner",
      list(
        hr(),
        "This report was generated with", tags$a(href="http://bioconductor.org/packages/pcaExplorer/", "pcaExplorer"), br(),
        "pcaExplorer is a project developed by Federico Marini in the Bioinformatics division of the ",
        tags$a(href="http://www.unimedizin-mainz.de/imbei","IMBEI"),br(),
        "Development of the pcaExplorer package is on ",
        tags$a(href="https://github.com/federicomarini/pcaExplorer", "GitHub")
      )
    )
  )
}
```

```{r, echo = FALSE}
footertemplate()
```

*This information is also contained in the `pcaExplorer` package vignette. For more
information on the functions of the `pcaExplorer` package, please refer to the
vignette and/or the documentation.*

## Getting started

`pcaExplorer` is an R package distributed as part of the [Bioconductor](http://bioconductor.org)
project. To install the package, start R and enter:

```r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("pcaExplorer")
```

If you prefer, you can install and use the development version, which can be 
retrieved via Github (https://github.com/federicomarini/pcaExplorer). To do so, use

```r
library("devtools")
install_github("federicomarini/pcaExplorer")
```

Once `pcaExplorer` is installed, it can be loaded by the following command.

```r
library("pcaExplorer")
```

## Introduction

`pcaExplorer` is a Bioconductor package containing a Shiny application for
analyzing expression data in different conditions and experimental factors. 

It is a general-purpose interactive companion tool for RNA-seq analysis, which 
guides the user in exploring the Principal Components of the data under inspection.

`pcaExplorer` provides tools and functionality to detect outlier samples, genes
that show particular patterns, and additionally provides a functional interpretation of 
the principal components for further quality assessment and hypothesis generation
on the input data. 

Moreover, a novel visualization approach is presented to simultaneously assess 
the effect of more than one experimental factor on the expression levels.

Thanks to its interactive/reactive design, it is designed to become a practical
companion to any RNA-seq dataset analysis, making exploratory data analysis 
accessible also to the bench biologist, while providing additional insight also
for the experienced data analyst.

Starting from development version 1.1.3, `pcaExplorer` supports reproducible 
research with state saving and automated report generation. 

## Citation info

If you use `pcaExplorer` for your analysis, please cite it as here below:

```r
citation("pcaExplorer")
```

```
## 
## To cite package 'pcaExplorer' in publications use:
## 
##   Federico Marini (2016). pcaExplorer: Interactive Visualization
##   of RNA-seq Data Using a Principal Components Approach. R package
##   version 1.1.3. https://github.com/federicomarini/pcaExplorer
## 
## A BibTeX entry for LaTeX users is
## 
##   @Manual{,
##     title = {pcaExplorer: Interactive Visualization of RNA-seq Data Using a Principal Components Approach},
##     author = {Federico Marini},
##     year = {2016},
##     note = {R package version 1.1.3},
##     url = {https://github.com/federicomarini/pcaExplorer},
##   }
```

## Launching the application

After loading the package, the `pcaExplorer` app can be launched in different modes:

- `pcaExplorer(dds = dds, rlt = rlt)`, where `dds` is a `DESeqDataSet` object and `rlt` is a `DESeqTransform`
object, which were created during an existing session for the analysis of an RNA-seq
dataset with the `DESeq2` package

- `pcaExplorer(dds = dds)`, where `dds` is a `DESeqDataSet` object. The `rlt` object is automatically 
computed upon launch.

- `pcaExplorer(countmatrix = countmatrix, coldata = coldata)`, where `countmatrix` is a count matrix, generated
after assigning reads to features such as genes via tools such as `HTSeq-count` or `featureCounts`, and `coldata`
is a data frame containing the experimental covariates of the experiments, such as condition, tissue, cell line,
run batch and so on.

- `pcaExplorer()`, and then subsequently uploading the count matrix and the covariates data frame through the 
user interface. These files need to be formatted as tab separated files, which is a common format for storing
such count values.

Additional parameters and objects that can be provided to the main `pcaExplorer` function are:

- `pca2go`, which is an object created by the `pca2go` function, which scans the genes with high loadings in 
each principal component and each direction, and looks for functions (such as GO Biological Processes) that 
are enriched above the background. The offline `pca2go` function is based on the routines and algorithms of 
the `topGO` package, but as an alternative, this object can be computed live during the execution of the app
exploiting the `goana` function, provided by the `limma` package. Although this likely provides more general
(and probably less informative) functions, it is a good compromise for obtaining a further data interpretation.

- `annotation`, a data frame object, with `row.names` as gene identifiers (e.g. ENSEMBL ids) identical to the 
row names of the count matrix or `dds` object, and an extra column `gene_name`, containing e.g. HGNC-based 
gene symbols. This can be used for making information extraction easier, as ENSEMBL ids (a usual choice when
assigning reads to features) do not provide an immediate readout for which gene they refer to. This can be
either passed as a parameter when launching the app, or also uploaded as a tab separated text file. The package
provides two functions, `get_annotation` and `get_annotation_orgdb`, as a convenient wrapper to obtain the updated
annotation information, respectively from `biomaRt` or via the `org.XX.eg.db` packages.

## The controls sidebar

Most of the input controls are located in the sidebar, some are as well in the individual tabs of the app.
By changing one or more of the input parameters, the user can get a fine control on what is displayed.

### App settings

Here are the parameters that set input values for most of the tabs. By hovering over with the mouse,
the user can receive additional information on how to set the parameter, powered by the `shinyBS` package.

- **x-axis PC** - Select the principal component to display on the x axis
- **y-axis PC** - Select the principal component to display on the y axis
- **Group/color by** - Select the group of samples to stratify the analysis. Can also assume multiple values.
- **Nr of (most variable) genes** - Number of genes to select for computing the principal components. The top n genes are
selected ranked by their variance inter-samples
- **Alpha** - Color transparency for the plots. Can assume values from 0 (transparent) to 1 (opaque)
- **Labels size** - Size of the labels for the samples in the principal components plots
- **Points size** - Size of the points to be plotted in the principal components plots
- **Variable name size** - Size of the labels for the genes PCA - correspond to the samples names
- **Scaling factor** - Scale value for resizing the arrow corresponding to the variables in the PCA for the genes. It
should be used for mere visualization purposes
- **Color palette** - Select the color palette to be used in the principal components plots. The number of colors 
is selected automatically according to the number of samples and to the levels of the factors of interest
and their interactions
- **Plot style for gene counts** - Plot either boxplots or violin plots, with jittered points superimposed 

### Plot export settings        

Width and height for the figures to export are input here in cm.

Additional controls available in the single tabs are also assisted by tooltips that show on hovering the mouse.
Normally they are tightly related to the plot/output they are placed nearby.

## The task menu

The task menu, accessible by clicking on the cog icon in the upper right part of the application, provides two 
functionalities:

- `Exit pcaExplorer & save` will close the application and store the content of the `input` and `values` reactive 
objects in two list objects made available in the global environment, called `pcaExplorer_inputs_YYYYMMDD_HHMMSS` and 
`pcaExplorer_values_YYYYMMDD_HHMMSS`
- `Save State as .RData` will similarly store `LiveInputs` and `r_data` in a binary file named
`pcaExplorerState_YYYYMMDD_HHMMSS.Rdata`, without closing the application 

## The app panels

The `pcaExplorer` app is structured in different panels, each focused on a different aspect of the 
data exploration. 

Most of the panels work extensively with click-based and brush-based interactions, to gain additional
depth in the explorations, for example by zooming, subsetting, selecting. This is possible thanks to the 
recent developments in the `shiny` package/framework.

The available panels are the described in the following subsections.

### Data Upload

These **file input** controls are available when no `dds` or `countmatrix` + `coldata` are provided. Additionally,
it is possible to upload the `annotation` data frame.

When the objects are already passed as parameters, a brief overview/summary for them is displayed.

### Instructions

This is where you most likely are reading this text (otherwise in the package vignette). 

### Counts Table

Interactive tables for the raw, normalized or (r)log-transformed counts are shown in this tab.
The user can also generate a sample-to-sample correlation scatter plot with the selected data.

### Data Overview

This panel displays information on the objects in use, either passed as parameters or 
generated from the count matrix provided. Displayed information comprise the design metadata,
a sample to sample distance heatmap, the number of million of reads per sample and some
basic summary for the counts.

### Samples View

This panel displays the PCA projections of sample expression profiles onto any pair of components,
a scree plot, a zoomed PCA plot, a plot of the genes with top and bottom loadings. Additionally, this section 
presents a PCA plot where it is possible to remove samples deemed to be outliers in the analysis, which is 
very useful to check the effect of excluding them. If needed, an interactive 3D visualization of the principal 
components is also available.

### Genes View

This panel displays the PCA projections of genes abundances onto any pair of components, with samples
as biplot variables, to identify interesting groups of genes. Zooming is also possible, and clicking on single
genes, a boxplot is returned, grouped by the factors of interest. A static and an interactive heatmap are 
provided, including the subset of selected genes, also displayed as (standardized) expression profiles across the 
samples. These are also reported in `datatable` objects, accessible in the bottom part of the tab.

### GeneFinder

The user can search and display the expression values of a gene of interest, either by ID or gene
name, as provided in the `annotation`. A handy panel for quick screening of shortlisted genes, again grouped by
the factors of interest. The graphic can be readily exported as it is, and this can be iterated on a shortlisted
set of genes. For each of them, the underlying data is displayed in an interactive table, also exportable with a 
click.

### PCA2GO

This panel shows the functional annotation of the principal components, with GO functions enriched in the 
genes with high loadings on the selected principal components. It allows for the live computing of the object,
that can otherwise provided as a parameter when launching the app. The panel displays a PCA plot for the 
samples, surrounded on each side by the tables with the functions enriched in each component and direction.

### Multifactor Exploration

This panel allows for the multifactor exploration of datasets with 2 or more experimental factors. The user has to select 
first the two factors and the levels for each. Then, it is possible to combine samples from Factor1-Level1 in the selected
order by clicking on each sample name, one for each level available in the selected Factor2. In order to build the matrix, 
an equal number of samples for each level of Factor 1 is required, to keep the design somehow balanced.
A typical case for choosing factors 1 and 2 is for example when different conditions and tissues are present.

Once constructed, a plot is returned that tries to represent simultaneously the effect of the two factors on the data.
Each gene is represented by a dot-line-dot structure, with the color that is indicating the tissue (factor 2) where the gene 
is mostly expressed. Each gene has two dots, one for each condition level (factor 1), and the position of the points is dictated
by the scores of the principal components calculated on the matrix object. The line connecting the dots is darker when the 
tissue where the gene is mostly expressed varies throughout the conditions. 

This representation is under active development, and it is promising for identifying interesting sets or clusters of genes
according to their behavior on the Principal Components subspaces. Zooming and exporting of the underlying genes is also
allowed by brushing on the main plot.

### Report Editor

The report editor is the backbone for generating and editing the interactive report on the basis of the 
uploaded data and the current state of the application. General `Markdown options` and `Editor options`
are available, and the text editor, based on the `shinyAce` package, contains a comprehensive template 
report, that can be edited to the best convenience of the user.

The editor supports R code autocompletion, making it easy to add new code chunks for additional sections.
A preview is available in the tab itself, and the report can be generated, saved and subsequently shared 
with simple mouse clicks.

### About

Contains general information on `pcaExplorer`, including the developer's contact, the link to
the development version in Github, as well as the output of `sessionInfo`, to use for reproducibility sake - 
or bug reporting. Information for citing `pcaExplorer` is also reported.

## Running `pcaExplorer` on published datasets

We can run `pcaExplorer` for demonstration purpose on published datasets that are available as SummarizedExperiment
in an experiment Bioconductor packages.

We will use the `airway` dataset, which can be installed with this command

```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("airway")
```

This package provides a RangedSummarizedExperiment object of read counts in genes for an RNA-Seq experiment 
on four human airway smooth muscle cell lines treated with dexamethasone. More details such as gene models and 
count quantifications can be found in the `airway` package vignette. 

To run `pcaExplorer` on this dataset, the following commands are required

```
library("airway"")

data("airway", package = "airway")

dds_airway <- DESeqDataSet(airway,design=~dex+cell)
dds_airway
rld_airway <- rlogTransformation(dds_airway)
rld_airway
pcaExplorer(dds = dds_airway,
            rlt = rld_airway)
```
The `annotation` for this dataset can be built by exploiting the `org.Hs.eg.db` package

```
library("org.Hs.eg.db")
genenames_airway <- mapIds(org.Hs.eg.db,keys = rownames(dds_airway),column = "SYMBOL",keytype="ENSEMBL")
annotation_airway <- data.frame(gene_name = genenames_airway,
                                row.names = rownames(dds_airway),
                                stringsAsFactors = FALSE)
head(annotation_airway)                                
```

or alternatively, by using the `get_annotation` or `get_annotation_orgdb` wrappers.

```
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")

anno_df_biomart <- get_annotation(dds = dds_airway,
                                  biomart_dataset = "hsapiens_gene_ensembl",
                                  idtype = "ensembl_gene_id")
```

Then again, the app can be launched with 

```
pcaExplorer(dds = dds_airway,
            rlt = rld_airway,
            annotation = annotation_airway)
```

If desired, alternatives can be used. See the well written annotation workflow available at the Bioconductor site (https://bioconductor.org/help/workflows/annotation/annotation/).

## Running `pcaExplorer` on synthetic datasets

For testing and demonstration purposes, a function is also available to generate synthetic datasets whose counts
are generated based on two or more experimental factors.

This can be called with the command

```
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 1)
```

See all the available parameters by typing `?makeExampleDESeqDataSet_multifac`. Credits are given to the initial
implementation by Mike Love in the `DESeq2` package.

The following steps run the app with the synthetic dataset

```
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 1,betaSD_tissue = 3)
dds_multifac
rld_multifac <- rlogTransformation(dds_multifac)
rld_multifac
## checking how the samples cluster on the PCA plot
pcaplot(rld_multifac,intgroup = c("condition","tissue"))
```

Launch the app for exploring this dataset with 

```
pcaExplorer(dds = dds_multifac,
            rlt = rld_multifac)
```

When such a dataset is provided, the panel for multifactorial exploration is also usable at its best.

## Functions exported by the package for standalone usage

The functions exported by the `pcaExplorer` package can be also used in a standalone scenario,
provided the required objects are in the working environment. They are listed here for an overview,
but please refer to the documentation for additional details.

- `pcaplot` plots the sample PCA for `DESeqTransform` objects, such as rlog-transformed data. This is 
the workhorse of the Samples View tab
- `pcaplot3d` - same as for `pcaplot`, but it uses the `threejs` package for the 3d interactive view.
- `pcascree` produces a scree plot of the PC computed on the samples. A `prcomp` object needs to be 
passed as main argument
- `correlatePCs` and `plotPCcorrs` respectively compute and plot significance of the (cor)relation 
of each covariate versus a principal component. The input for `correlatePCs` is a `prcomp` object
- `hi_loadings` extracts and optionally plots the genes with the highest loadings
- `genespca` computes and plots the principal components of the genes, eventually displaying 
the samples as in a typical biplot visualization. This is the function in action for the Genes View tab
- `topGOtable` is a convenient wrapper for extracting functional GO terms enriched in a subset of genes 
(such as the differentially expressed genes), based on the algorithm and the implementation in the topGO package
- `pca2go` provides a functional interpretation of the principal components, by extracting the genes
with the highest loadings for each PC, and then runs internally `topGOtable` on them for efficient functional
enrichment analysis. Needs a `DESeqTransform` object as main parameter
- `limmaquickpca2go` is an alternative to `pca2go`, used in the live running app, thanks to its fast 
implementation based on the `limma::goana` function.
- `makeExampleDESeqDataSet_multifac` constructs a simulated `DESeqDataSet` of Negative Binomial dataset
from different conditions. The fold changes between the conditions can be adjusted with the `betaSD_condition`
`betaSD_tissue` arguments
- `distro_expr` plots the distribution of expression values, either with density lines, boxplots or 
violin plots
- `geneprofiler` plots the profile expression of a subset of genes, optionally as standardized values
- `get_annotation` and `get_annotation_orgdb` retrieve the latest annotations for the `dds` object, to be
used in the call to the `pcaExplorer` function. They use respectively the `biomaRt` package
and the `org.XX.eg.db` packages
- `pair_corr` plots the pairwise scatter plots and computes the correlation coefficient on the 
expression matrix provided.

For more information on the functions of the `pcaExplorer` package, please refer to the
vignette and/or the documentation.

## Further development

Additional functionality for the `pcaExplorer` will be added in the future, as it is tightly related to a topic
under current development research. 

Improvements, suggestions, bugs, issues and feedback of any type can be sent to marinif@uni-mainz.de.

---
title: >
  pcaExplorer User Guide
author: 
- name: Federico Marini
  affiliation: 
  - &id1 Institute of Medical Biostatistics, Epidemiology and Informatics (IMBEI), Mainz
  - Center for Thrombosis and Hemostasis (CTH), Mainz
  email: marinif@uni-mainz.de
- name: Harald Binder
  affiliation: *id1
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('pcaExplorer')`"
abstract: >
  `r Biocpkg("pcaExplorer")` provides functionality for interactive visualization 
  of RNA-seq datasets based on Principal Components Analysis. Such methods allow 
  for quick information extraction and effective data exploration. A Shiny 
  application encapsulates the whole analysis, and is developed to become a practical
  companion for any RNA-seq dataset. This app supports reproducible research with 
  state saving and automated report generation. 
output: 
  BiocStyle::html_document:
    toc_float: true
    fig_caption: TRUE
vignette: >
  %\VignetteIndexEntry{pcaExplorer User Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
  %\VignettePackage{pcaExplorer}
  %\VignetteKeywords{Visualization, RNASeq, DimensionReduction, PrincipalComponent, QualityControl, GUI, ReportWriting}
---

<br>
**Package**: `r Rpackage("pcaExplorer")`<br/>
**Authors**: `r packageDescription("pcaExplorer")[["Author"]]`<br/>
**Version**: `r packageDescription("pcaExplorer")$Version`<br/>
**Compiled date**: `r Sys.Date()`<br/>
**Last edited**: 2019-02-26<br/>
**License**: `r packageDescription("pcaExplorer")[["License"]]`<br/>

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```

```{r setup, echo=FALSE, warning=FALSE}
library("knitr")
set.seed(42)
opts_chunk$set(comment = "#>",
               fig.align = "center",
               warning = FALSE)
stopifnot(requireNamespace("htmltools"))
htmltools::tagList(rmarkdown::html_dependency_font_awesome())
```

```{r, out.width="50%", echo=FALSE}
knitr::include_graphics(system.file("www", "pcaExplorer.png", package = "pcaExplorer"))
```

# Getting started

`r Biocpkg("pcaExplorer")` is an R package distributed as part of the [Bioconductor](http://bioconductor.org) project.
To install the package, start R and enter:

```{r installation, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("pcaExplorer")
```

To install `r Biocpkg("pcaExplorer")` with all its dependencies (i.e. also the ones listed in the `Suggests:` field of the `DESCRIPTION` file, which include the dataset from the `r Biocpkg("airway")` package used as a demo), use this command instead:

```{r installfull, eval=FALSE}
BiocManager::install("pcaExplorer", dependencies = TRUE)
```

If you prefer, you can install and use the development version, which can be retrieved via Github (https://github.com/federicomarini/pcaExplorer). 
To do so, use:

```{r installation-github, eval=FALSE}
library("devtools")
install_github("federicomarini/pcaExplorer")
```

Once `r Rpackage("pcaExplorer")` is installed, it can be loaded by the following command.

```{r loadlibrary, message=FALSE}
library("pcaExplorer")
```

# Introduction

`r Biocpkg("pcaExplorer")` is a Bioconductor package containing a Shiny application for analyzing expression data in different conditions and experimental factors. 

It is a general-purpose interactive companion tool for RNA-seq analysis, which guides the user in exploring the Principal Components of the data under inspection.

`r Biocpkg("pcaExplorer")` provides tools and functionality to detect outlier samples, genes that show particular patterns, and additionally provides a functional interpretation of the principal components for further quality assessment and hypothesis generation on the input data. 

Moreover, a novel visualization approach is presented to simultaneously assess the effect of more than one experimental factor on the expression levels.

Thanks to its interactive/reactive design, it is designed to become a practical companion to any RNA-seq dataset analysis, making exploratory data analysis accessible also to the bench biologist, while providing additional insight also for the experienced data analyst.

Starting from development version 1.1.3, `r Biocpkg("pcaExplorer")` supports reproducible research with state saving and automated report generation.
Each generated plot and table can be exported by simple mouse clicks on the dedicated buttons.

## Citation info

If you use `r Biocpkg("pcaExplorer")` for your analysis, please cite it as here below:

```{r}
citation("pcaExplorer")
```

# Launching the application

After loading the package, the `r Biocpkg("pcaExplorer")` app can be launched in different modes:

- `pcaExplorer(dds = dds, dst = dst)`, where `dds` is a `DESeqDataSet` object and `dst` is a `DESeqTransform` object, which were created during an existing session for the analysis of an RNA-seq dataset with the `r Biocpkg("DESeq2")` package.

- `pcaExplorer(dds = dds)`, where `dds` is a `DESeqDataSet` object. The `dst` object can be  automatically computed upon launch, choosing between rlog transformation, variance stabilizing transformations, or shifted logarithm transformation (with pseudocount = 1).

- `pcaExplorer(countmatrix = countmatrix, coldata = coldata)`, where `countmatrix` is a count matrix, generated after assigning reads to features such as genes via tools such as `HTSeq-count` or `featureCounts`, and `coldata` is a data frame containing the experimental covariates of the experiments, such as condition, tissue, cell line, run batch and so on.
  If the data is provided in this way, the user can click on the "Generate the dds and dst objects" button to complete the setup and enable the subsequent steps in the other panels.

- `pcaExplorer()`, and then subsequently uploading the count matrix and the covariates data frame through the user interface. These files need to be formatted as tab, semicolon, or comma separated text files, all of which are common formats for storing such count values.

Additional parameters and objects that can be provided to the main `r Biocpkg("pcaExplorer")` function are:

- `pca2go`, which is an object created by the `pca2go` function, which scans the genes with high loadings in each principal component and each direction, and looks for functions (such as GO Biological Processes) that are enriched above the background. 
  The offline `pca2go` function is based on the routines and algorithms of the `r Biocpkg("topGO")` package, but as an alternative, this object can be computed live during the execution of the app with `limmaquickpca2go` (which relies on the `goana` function provided by the `r Biocpkg("limma")` package). 
  Although this likely provides more general (and probably less informative) functions, it is a good compromise for quickly obtaining a further data interpretation.

- `annotation`, a data frame object, with `row.names` as gene identifiers (e.g. ENSEMBL ids) identical to the row names of the count matrix or `dds` object, and an extra column `gene_name`, containing e.g. HGNC-based gene symbols. 
  This can be used for making information extraction easier, as ENSEMBL ids (a usual choice when assigning reads to features) do not provide an immediate readout for which gene they refer to.
  This can be either passed as a parameter when launching the app, or also uploaded as a text file (either tab, comma, or semicolon-separated). 
  The package provides two functions, `get_annotation` and `get_annotation_orgdb`, as a convenient wrapper to obtain the updated annotation information, respectively from `biomaRt` or via the `org.XX.eg.db` packages.
  
## How to provide your input data in `r Biocpkg("pcaExplorer")`

`r Biocpkg("pcaExplorer")` supports a number of file formats when uploading the data via the file input widgets. 
Starting from version 2.9.5, we added functionality to select the separator character for each of the uploadable files. 
An information box is also shown by clicking on the question mark icon in the Data upload panel, with detailed information (text, as well as screenshots of valid input files) on the format specification. 

In general, `r Biocpkg("pcaExplorer")` requires by default tab separated files:

- the `countmatrix`: contains the expression matrix, with one gene per row and one sample per column; the first column should contain the gene identifiers, and the header (first row) specifies the sample names.
- the `coldata`: one sample per row, and one experimental covariate per column. 
  Row names should be specified in the first column, and have to match the column names of the `countmatrix`. 
  Column names will contain the specific experimental covariates.
- the `annotation` (optional): one gene per row, and one identifier type per column. 
  Gene identifiers in the first column are identical to the row names of the `countmatrix` or `dds` objects. 
  At least an extra column `gene_name`, containing e.g. HGNC-based gene symbols, needs to be provided.
  
## Up and running with `r Biocpkg("pcaExplorer")`

We recommend users to switch to the `r Biocpkg("pcaExplorer", vignette="upandrunning.html", label="dedicated vignette")`, entitled "Up and running with `r Biocpkg('pcaExplorer')`".

This document describes a use case for `r Biocpkg("pcaExplorer")`, based on the dataset in the `r Biocpkg("airway")` package.


# The controls sidebar

Most of the input controls are located in the sidebar, some are as well in the individual tabs of the app.
By changing one or more of the input parameters, the user can get a fine control on what is displayed.

## App settings

Here are the parameters that set input values for most of the tabs. 
By hovering over with the mouse, the user can receive additional information on how to set the parameter, with tooltips powered by the `r CRANpkg("shinyBS")` package.

- **x-axis PC** - Select the principal component to display on the x axis
- **y-axis PC** - Select the principal component to display on the y axis
- **Group/color by** - Select the group of samples to stratify the analysis. Can also assume multiple values.
- **Nr of (most variable) genes** - Number of genes to select for computing the principal components. The top n genes are selected ranked by their variance inter-samples
- **Alpha** - Color transparency for the plots. Can assume values from 0 (transparent) to 1 (opaque)
- **Labels size** - Size of the labels for the samples in the principal components plots.
  This parameter also controls the size of the gene labels, which are displayed in the Genes View once the user has brushed an area in the main plot.
- **Points size** - Size of the points to be plotted in the principal components plots
- **Variable name size** - Size of the labels for the genes PCA - correspond to the samples names
- **Scaling factor** - Scale value for resizing the arrow corresponding to the variables in the PCA for the genes. It should be used for mere visualization purposes
- **Color palette** - Select the color palette to be used in the principal components plots. The number of colors is selected automatically according to the number of samples and to the levels of the factors of interest and their interactions
- **Plot style for gene counts** - Plot either boxplots or violin plots, with jittered points superimposed 

## Plot export settings        

**Width** and **height** for the figures to export are input here in cm.

Additional controls available in the single tabs are also assisted by tooltips that show on hovering the mouse.
Normally they are tightly related to the plot/output they are placed nearby.

# The task menu

The task menu, accessible by clicking on the cog icon in the upper right part of the application, provides two functionalities:

- `Exit pcaExplorer & save` will close the application and store the content of the `input` and `values` reactive objects in two list objects made available in the global environment, called `pcaExplorer_inputs_YYYYMMDD_HHMMSS` and `pcaExplorer_values_YYYYMMDD_HHMMSS`
- `Save State as .RData` will similarly store `LiveInputs` and `r_data` in a binary file named `pcaExplorerState_YYYYMMDD_HHMMSS.Rdata`, without closing the application 

# The app panels

The `r Biocpkg("pcaExplorer")` app is structured in different panels, each focused on a different aspect of the  data exploration. 

Most of the panels work extensively with click-based and brush-based interactions, to gain additional depth in the explorations, for example by zooming, subsetting, selecting. 
This is possible thanks to the recent developments in the `r CRANpkg("shiny")` package/framework.

The available panels are described in the following subsections.

## Data Upload

These **file input** controls are available when no `dds` or `countmatrix` + `coldata` are provided. 
Additionally, it is possible to upload the `annotation` data frame. 
If the objects are already passed as parameters, or after they have been successfully uploaded, a brief overview/summary for them can be displayed, by clicking on each respective action button.

<p align="center">
<img src="newsnap_01_upload.png" style="width:1000px;"/>
</p>

This panel is where you can perform the preprocessing steps on the data you uploaded/provided: 

- compose the `dds` object (if you provided `countmatrix` and `coldata`)
- normalize the expression values (using the robust method proposed by Anders and Huber in the original DESeq manuscript)
- compute the variance stabilizing transformed expression values (stored in the `dst` object).

As a note regarding the normalization procedure: the normalization method (implemented in `estimateSizeFactors`) relies on the hypothesis that most of the genes are not differentially expressed across experimental groups, and this holds true for the majority of scenarios. 
The `DESeqDataSet` object, which pcaExplorer takes as main data container, can still accommodate sample (and gene) specific normalization factors. 
Should this assumption be violated, users can pre-compute these factors and store them in the input `dds` object. 

## Instructions

This is where you might be reading a version of the "Up and running with `r Biocpkg('pcaExplorer')`" vignette.
Additionally, you can easily reach the fully rendered vignettes, either installed locally, or directly from the Bioconductor package page. 

<p align="center">
<img src="newsnap_02_instructions.png" style="width:1000px;"/>
</p>

## Counts Table

Interactive tables for the raw, normalized or transformed (rlog, variance stabilized, or shifted log) counts are shown in this tab.
The user can also generate a sample-to-sample correlation scatter plot with the selected data.

<p align="center">
<img src="newsnap_03_countstable.png" style="width:1000px;"/>
</p>

## Data Overview

This panel displays information on the objects in use, either passed as parameters or generated from the count matrix provided. 
Displayed information comprise the design metadata, a sample to sample distance heatmap, the number of million of reads per sample and some basic summary for the counts.

<p align="center">
<img src="newsnap_04_overview.png" style="width:1000px;"/>
</p>

## Samples View

This panel displays the PCA projections of sample expression profiles onto any pair of components, a scree plot, a zoomed PCA plot, a plot of the genes with top and bottom loadings. 
Additionally, this section presents a PCA plot where it is possible to remove samples deemed to be outliers in the analysis, which is very useful to check the effect of excluding them.
If needed, an interactive 3D visualization of the principal components is also available.

<p align="center">
<img src="newsnap_05_samples.png" style="width:1000px;"/>
</p>

## Genes View

This panel displays the PCA projections of genes abundances onto any pair of components, with samples as biplot variables, to identify interesting groups of genes. 
Zooming is also possible, and clicking on single genes, a boxplot is returned, grouped by the factors of interest. 
A static and an interactive heatmap are provided, including the subset of selected genes, also displayed as (standardized) expression profiles across the samples. 
These are also reported in `datatable` objects, accessible in the bottom part of the tab.

<p align="center">
<img src="newsnap_06_genes.png" style="width:1000px;"/>
</p>

## GeneFinder

The user can search and display the expression values of a gene of interest, either by ID or gene name, as provided in the `annotation`. 
A handy panel for quick screening of shortlisted genes, again grouped by the factors of interest. 
The graphic can be readily exported as it is, and this can be iterated on a shortlisted set of genes. 
For each of them, the underlying data is displayed in an interactive table, also exportable with a click.

<p align="center">
<img src="newsnap_07_finder.png" style="width:1000px;"/>
</p>

## PCA2GO

This panel shows the functional annotation of the principal components, with GO functions enriched in the genes with high loadings on the selected principal components. 
It allows for the live computing of the object, that can otherwise provided as a parameter when launching the app. 
The panel displays a PCA plot for the samples, surrounded on each side by the tables with the functions enriched in each component and direction.

<p align="center">
<img src="newsnap_08_pca2go.png" style="width:1000px;"/>
</p>

### More on the `pca2go` parameter

A note on the functionality provided by the PCA2GO tab: if it is not provided in the `pca2go` parameter, the user can still compute this object while using the app, and this is done using `limma::goana`. 
The implementation of this function supports a few organism packages, which cover many use cases (human, mouse, rat, fruit fly, or chimpanzee), but some use cases are not directly covered (e.g. if you are working with plants like Arabidopsis Thaliana).

For example, with a dataset from Arabidopsis where the genes are encoded as TAIR (The Arabidopsis Information Resource) identifiers, one would ideally call the following commands

```{r eval=FALSE}
BiocManager::install("org.At.tair.db")
library("org.At.tair.db")
# skipping the steps where you normally would generate your dds_at object...
dds_at
vst_at <- DESeq2::vst(dds_at)
anno_at <- get_annotation_orgdb(dds_at,"org.At.tair.db", idtype = "TAIR")
# subset the background to include only the expressed genes
bg_ids <- rownames(dds_at)[rowSums(counts(dds_at)) > 0]
library(topGO)
pca2go_at <- pca2go(vst_at,
                    annotation = anno_at,
                    annopkg = "org.At.tair.db",
                    ensToGeneSymbol = TRUE,
                    background_genes = bg_ids)
# and finally, with all the objects prepared...
pcaExplorer(dds = dds_at, dst = vst_at, annotation = anno_at, pca2go = pca2go_at)
```

## Multifactor Exploration

This panel allows for the multifactor exploration of datasets with 2 or more experimental factors. 
The user has to select first the two factors and the levels for each. 
Then, it is possible to combine samples from Factor1-Level1 in the selected order by clicking on each sample name, one for each level available in the selected Factor2. 
In order to build the matrix, an equal number of samples for each level of Factor 1 is required, to keep the design somehow balanced.
A typical case for choosing factors 1 and 2 is for example when different conditions and tissues are present.

Once constructed, a plot is returned that tries to represent simultaneously the effect of the two factors on the data.
Each gene is represented by a dot-line-dot structure, with the color that is indicating the tissue (factor 2) where the gene is mostly expressed.
Each gene has two dots, one for each condition level (factor 1), and the position of the points is dictated by the scores of the principal components calculated on the matrix object. 
The line connecting the dots is darker when the tissue where the gene is mostly expressed varies throughout the conditions. 

This representation is under active development, and it is promising for identifying interesting sets or clusters of genes according to their behavior on the Principal Components subspaces. 
Zooming and exporting of the underlying genes is also allowed by brushing on the main plot.

<p align="center">
<img src="newsnap_09_multifac.png" style="width:1000px;"/>
</p>

## Report Editor

The report editor is the backbone for generating and editing the interactive report on the basis of the uploaded data and the current state of the application. 
General `Markdown options` and `Editor options` are available, and the text editor, based on the `shinyAce` package, contains a comprehensive template report, that can be edited to the best convenience of the user.

The editor supports R code autocompletion, making it easy to add new code chunks for additional sections.
A preview is available in the tab itself, and the report can be generated, saved and subsequently shared with simple mouse clicks.

<p align="center">
<img src="newsnap_10_editor.png" style="width:1000px;"/>
</p>

The functionality to display the report preview is based on `knit2html`, and some elements such as `DataTable` objects might not render correctly. 
To render them correctly, please install the PhantomJS executable before launching the app. 
This can be done by using the `r CRANpkg("webshot")` package and calling `webshot::install_phantomjs()` - HTML widgets will be rendered automatically as screenshots.
Alternatively, the more recent `r BiocStyle::CRANpkg("webshot2")` package uses the headless Chrome browser (via the `r BiocStyle::CRANpkg("chromote")` package, requiring Google Chrome or other Chromium-based browser).
Keep in mind that the fully rendered report (the one you can obtain with the "Generate & Save" button) is not affected by this, since it uses `rmarkdown::render()`.

## About

Contains general information on `r Biocpkg("pcaExplorer")`, including the developer's contact, the link to the development version in Github, as well as the output of `sessionInfo`, to use for reproducibility sake - or bug reporting. 
Information for citing `r Biocpkg("pcaExplorer")` is also reported.

<p align="center">
<img src="newsnap_11_about.png" style="width:1000px;"/>
</p>

# Running `pcaExplorer` on published datasets

We can run `r Biocpkg("pcaExplorer")` for demonstration purpose on published datasets that are available as SummarizedExperiment in a Bioconductor experiment package.

We will use the `r Biocpkg("airway")` dataset, which can be installed with this command:

```{r installairway, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("airway")
```

The `r Biocpkg("airway")` package provides a `RangedSummarizedExperiment` object of read counts in genes for an RNA-Seq experiment on four human airway smooth muscle cell lines treated with dexamethasone. 
More details such as gene models and count quantifications can be found in the `r Biocpkg("airway")` package vignette. 

The easiest way to explore the `r Biocpkg("airway")` dataset is by clicking on the dedicated button in the **Data Upload** panel.

<button id="btn_loaddemo" type="button" class="btn btn-default action-button shiny-bound-input" style="color: #0092AC" data-original-title="" title=""><i class="fa fa-play-circle"></i> Load the demo airway data</button>

Otherwise, to run `r Biocpkg("pcaExplorer")` on this dataset from the terminal/RStudio IDE, the following commands are required. 
First, prepare the objects to be passed as parameters of `r Biocpkg("pcaExplorer")`.

```{r loadairway, message=FALSE}
library("airway")
library("DESeq2")

data("airway", package = "airway")

dds_airway <- DESeqDataSet(airway,design= ~ cell + dex)
dds_airway
rld_airway <- rlogTransformation(dds_airway)
rld_airway
```

Then launch the app itself.

```{r launchairway, eval=FALSE}
pcaExplorer(dds = dds_airway,
            dst = rld_airway)
```

The `annotation` for this dataset can be built by exploiting the `r Biocpkg("org.Hs.eg.db")` package.

```{r annoairway, message = FALSE}
library(org.Hs.eg.db)
genenames_airway <- mapIds(org.Hs.eg.db,keys = rownames(dds_airway),column = "SYMBOL",keytype="ENSEMBL")
annotation_airway <- data.frame(gene_name = genenames_airway,
                                row.names = rownames(dds_airway),
                                stringsAsFactors = FALSE)
head(annotation_airway)                                
```

or alternatively, by using the `get_annotation` or `get_annotation_orgdb` wrappers.

```{r annofuncs, eval=FALSE}
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")

anno_df_biomart <- get_annotation(dds = dds_airway,
                                  biomart_dataset = "hsapiens_gene_ensembl",
                                  idtype = "ensembl_gene_id")
```

```{r echo=FALSE}
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")
```

```{r}
head(anno_df_orgdb)
```


Then again, the app can be launched with:

```{r launchairwayanno, eval=FALSE}
pcaExplorer(dds = dds_airway,
            dst = rld_airway,
            annotation = annotation_airway) # or anno_df_orgdb, or anno_df_biomart
```

If desired, alternatives can be used. 
See the well written annotation workflow available at the Bioconductor site (https://bioconductor.org/help/workflows/annotation/annotation/).

# Running `pcaExplorer` on synthetic datasets

For testing and demonstration purposes, a function is also available to generate synthetic datasets whose counts are generated based on two or more experimental factors.

This can be called with the command:

```{r ddsmultifac}
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 1)
```

See all the available parameters by typing `?makeExampleDESeqDataSet_multifac`. 
Credits are given to the initial implementation by Mike Love in the `r Biocpkg("DESeq2")` package.

The following steps run the app with the synthetic dataset.

```{r prepsimul}
dds_multifac <- makeExampleDESeqDataSet_multifac(betaSD_condition = 1,betaSD_tissue = 3)
dds_multifac
rld_multifac <- rlogTransformation(dds_multifac)
rld_multifac
## checking how the samples cluster on the PCA plot
pcaplot(rld_multifac,intgroup = c("condition","tissue"))
```

Launch the app for exploring this dataset with:

```{r launchsimul, eval=FALSE}
pcaExplorer(dds = dds_multifac,
            dst = rld_multifac)
```

When such a dataset is provided, the panel for multifactorial exploration is also usable at its best.

# Functions exported by the package for standalone usage

The functions exported by the `r Biocpkg("pcaExplorer")` package can be also used in a standalone scenario, provided the required objects are in the working environment. 
They are listed here for an overview, but please refer to the documentation for additional details. 
Where possible, for each function a code snippet will be provided for its typical usage.

## `pcaplot`

`pcaplot` plots the sample PCA for `DESeqTransform` objects, such as rlog-transformed data. 
This is the workhorse of the Samples View tab.

```{r func-pcaplot}
pcaplot(rld_airway,intgroup = c("cell","dex"),ntop = 1000,
        pcX = 1, pcY = 2, title = "airway dataset PCA on samples - PC1 vs PC2")

# on a different set of principal components...
pcaplot(rld_airway,intgroup = c("dex"),ntop = 1000,
        pcX = 1, pcY = 4, title = "airway dataset PCA on samples - PC1 vs PC4",
        ellipse = TRUE)
```

## `pcaplot3d`

Same as for `pcaplot`, but it uses the `threejs` package for the 3d interactive view.

```{r func-pcaplot3d, eval=FALSE}
pcaplot3d(rld_airway,intgroup = c("cell","dex"),ntop = 1000,
        pcX = 1, pcY = 2, pcZ = 3)
# will open up in the viewer
```

## `pcascree`

`pcascree` produces a scree plot of the PC computed on the samples. 
A `prcomp` object needs to be passed as main argument.

```{r func-pcascree}
pcaobj_airway <- prcomp(t(assay(rld_airway)))
pcascree(pcaobj_airway,type="pev",
         title="Proportion of explained proportion of variance - airway dataset")
```

## `correlatePCs` and `plotPCcorrs`

`correlatePCs` and `plotPCcorrs` respectively compute and plot significance of the (cor)relation  of each covariate versus a principal component. 
The input for `correlatePCs` is a `prcomp` object.

```{r func-correlatepcs}
res_pcairway <- correlatePCs(pcaobj_airway,colData(dds_airway))

res_pcairway

plotPCcorrs(res_pcairway)
```

## `hi_loadings`

`hi_loadings` extracts and optionally plots the genes with the highest loadings.

```{r func-hiloadings}
# extract the table of the genes with high loadings
hi_loadings(pcaobj_airway,topN = 10,exprTable=counts(dds_airway))
# or alternatively plot the values
hi_loadings(pcaobj_airway,topN = 10,annotation = annotation_airway)
```

## `genespca`

`genespca` computes and plots the principal components of the genes, eventually displaying the samples as in a typical biplot visualization.
This is the function in action for the Genes View tab.

```{r func-genespca}
groups_airway <- colData(dds_airway)$dex
cols_airway <- scales::hue_pal()(2)[groups_airway]
# with many genes, do not plot the labels of the genes
genespca(rld_airway,ntop=5000,
         choices = c(1,2),
         arrowColors=cols_airway,groupNames=groups_airway,
         alpha = 0.2,
         useRownamesAsLabels=FALSE,
         varname.size = 5
        )
# with a smaller number of genes, plot gene names included in the annotation
genespca(rld_airway,ntop=100,
         choices = c(1,2),
         arrowColors=cols_airway,groupNames=groups_airway,
         alpha = 0.7,
         varname.size = 5,
         annotation = annotation_airway
        )
```

## `topGOtable` 

`topGOtable` is a convenient wrapper for extracting functional GO terms enriched in a subset of genes (such as the differentially expressed genes), based on the algorithm and the implementation in the `r Biocpkg("topGO")` package.

```{r func-topGOtable, eval=FALSE}
# example not run due to quite long runtime
dds_airway <- DESeq(dds_airway)
res_airway <- results(dds_airway)
res_airway$symbol <- mapIds(org.Hs.eg.db,
                            keys=row.names(res_airway),
                            column="SYMBOL",
                            keytype="ENSEMBL",
                            multiVals="first")
res_airway$entrez <- mapIds(org.Hs.eg.db,
                            keys=row.names(res_airway),
                            column="ENTREZID",
                            keytype="ENSEMBL",
                            multiVals="first")
resOrdered <- as.data.frame(res_airway[order(res_airway$padj),])
head(resOrdered)
# extract DE genes
de_df <- resOrdered[resOrdered$padj < .05 & !is.na(resOrdered$padj),]
de_symbols <- de_df$symbol
# extract background genes
bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
bg_symbols <- mapIds(org.Hs.eg.db,
                     keys=bg_ids,
                     column="SYMBOL",
                     keytype="ENSEMBL",
                     multiVals="first")
# run the function
topgoDE_airway <- topGOtable(de_symbols, bg_symbols,
                             ontology = "BP",
                             mapping = "org.Hs.eg.db",
                             geneID = "symbol")
```

From version 2.32.0 onwards, the `topGOtable()` function has been deprecated, in favor of the equivalent `mosdef::run_topGO()` function, which is more robust and flexible in its usage.

## `pca2go` {#pca2go-docs}

`pca2go` provides a functional interpretation of the principal components, by extracting the genes with the highest loadings for each PC, and then runs internally `topGOtable` on them for efficient functional enrichment analysis.
This function requires a `DESeqTransform` object as main parameter.

```{r func-pca2go, eval=FALSE}
pca2go_airway <- pca2go(rld_airway,
                        annotation = annotation_airway,
                        organism = "Hs",
                        ensToGeneSymbol = TRUE,
                        background_genes = bg_ids)
# for a smooth interactive exploration, use DT::datatable
datatable(pca2go_airway$PC1$posLoad)
# display it in the normal R session...
head(pca2go_airway$PC1$posLoad)
# ... or use it for running the app and display in the dedicated tab
pcaExplorer(dds_airway,rld_airway,
            pca2go = pca2go_airway,
            annotation = annotation_airway)
```

## `limmaquickpca2go`

`limmaquickpca2go` is an alternative to `pca2go`, used in the live running app, thanks to its fast implementation based on the `limma::goana` function.

```{r func, message = FALSE, eval = FALSE}
goquick_airway <- limmaquickpca2go(rld_airway,
                                   pca_ngenes = 10000,
                                   inputType = "ENSEMBL",
                                   organism = "Hs")
# display it in the normal R session...
head(goquick_airway$PC1$posLoad)
# ... or use it for running the app and display in the dedicated tab
pcaExplorer(dds_airway,rld_airway,
            pca2go = goquick_airway,
            annotation = annotation_airway)
```

## `makeExampleDESeqDataSet_multifac`

`makeExampleDESeqDataSet_multifac` constructs a simulated `DESeqDataSet` of Negative Binomial dataset from different conditions. 
The fold changes between the conditions can be adjusted with the `betaSD_condition` and `betaSD_tissue` arguments.

```{r func-makedataset}

dds_simu <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 0.5)
dds_simu
dds2_simu <- makeExampleDESeqDataSet_multifac(betaSD_condition = 0.5,betaSD_tissue = 2)
dds2_simu

rld_simu <- rlogTransformation(dds_simu)
rld2_simu <- rlogTransformation(dds2_simu)
pcaplot(rld_simu,intgroup = c("condition","tissue")) + 
  ggplot2::ggtitle("Simulated data - Big condition effect, small tissue effect")
pcaplot(rld2_simu,intgroup = c("condition","tissue")) + 
  ggplot2::ggtitle("Simulated data - Small condition effect, bigger tissue effect")
```

## `distro_expr`

Plots the distribution of expression values, either with density lines, boxplots or violin plots.

```{r eval=FALSE}
distro_expr(rld_airway,plot_type = "density")
distro_expr(rld_airway,plot_type = "violin")
```

```{r}
distro_expr(rld_airway,plot_type = "boxplot")
```

## `geneprofiler` 

Plots the profile expression of a subset of genes, optionally as standardized values.

```{r}
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3,betaSD_tissue = 1)
dst <- DESeq2::rlogTransformation(dds)
set.seed(42)
geneprofiler(dst,paste0("gene",sample(1:1000,20)), plotZ = FALSE)
```

## `get_annotation` and `get_annotation_orgdb`

These two wrapper functions retrieve the latest annotations for the `dds` object, to be used in the call to the `pcaExplorer` function. 
They use respectively the `biomaRt` package and the `org.XX.eg.db` packages.

```{r eval=FALSE}
anno_df_biomart <- get_annotation(dds = dds_airway,
                                  biomart_dataset = "hsapiens_gene_ensembl",
                                  idtype = "ensembl_gene_id")
```

```{r}
anno_df_orgdb <- get_annotation_orgdb(dds = dds_airway,
                                      orgdb_species = "org.Hs.eg.db",
                                      idtype = "ENSEMBL")

head(anno_df_orgdb)
```

If using datasets and annotation packages for yeast samples (*Saccharomyces cerevisiae*, and the `org.Sc.sgd.db` package), remember to specify the `key_for_genenames` in the call to `get_annotation_orgdb` (an error message is thrown otherwise).

## `pair_corr`

Plots the pairwise scatter plots and computes the correlation coefficient on the expression matrix provided.

```{r}
# use a subset of the counts to reduce plotting time, it can be time consuming with many samples
pair_corr(counts(dds_airway)[1:100,])
```

# Further development

Additional functionality for the `r Biocpkg("pcaExplorer")` will be added in the future, as it is tightly related to a topic under current development research. 

Improvements, suggestions, bugs, issues and feedback of any type can be sent to marinif@uni-mainz.de.

# Session info {-}

```{r}
sessionInfo()
```

---
title: >
  Up and running with `r Biocpkg("pcaExplorer")`
author: 
- name: Federico Marini
  affiliation: 
  - &id1 Institute of Medical Biostatistics, Epidemiology and Informatics (IMBEI), Mainz
  - Center for Thrombosis and Hemostasis (CTH), Mainz
  email: marinif@uni-mainz.de
- name: Harald Binder
  affiliation: *id1
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('pcaExplorer')`"
output: 
  BiocStyle::html_document:
    toc_float: true
    fig_caption: TRUE
vignette: >
  %\VignetteIndexEntry{Up and running with pcaExplorer}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
  %\VignettePackage{pcaExplorer}
  %\VignetteKeywords{Visualization, RNASeq, DimensionReduction, PrincipalComponent, QualityControl, GUI, ReportWriting}
---

<!-- For rendering in-app: -->
<!-- - change output format to -->
<!-- --- -->
<!-- output:  -->
<!--   md_document: -->
<!--     variant: markdown_github -->
<!-- --- -->
<!-- - replace links to imgs with github hosted to provide permanent link -->
<!-- - enforce width="80%" for all imgs (50% for the smaller screenshot) -->
<!-- - copy content to inst/extdata/instructions_unr.md -->

```{r}
knitr::opts_chunk$set(crop = NULL)
```

# Setup

First things first: install `r Biocpkg("pcaExplorer")` and load it into your R session.
You should receive a message notification if this is completed without errors.

```{r eval=FALSE}
BiocManager::install("pcaExplorer")
library("pcaExplorer")
```

This document describes a use case for `r Biocpkg("pcaExplorer")`, based on the dataset in the `r Biocpkg("airway")` package.
If this package is not available on your machine, please install it by executing:

```{r eval=FALSE}
BiocManager::install("airway")
```

This dataset consists of the gene-level expression measurements (as raw read counts) for an experiment where four different human airway smooth muscle cell lines are either treated with dexamethasone or left untreated.

# Start exploring - the beauty of interactivity

To start the exploration, you just need the following lines:

```{r, eval=FALSE}
library("pcaExplorer")
pcaExplorer()
```

The easiest way to explore the `r Biocpkg("airway")` dataset is by clicking on the dedicated button in the **Data Upload** panel.
This action will:

- load the `r Biocpkg("airway")` package
- load the count matrix and the experimental metadata
- compose the `dds` object, normalize the expression values (using the robust method proposed by Anders and Huber in the original DESeq manuscript), and compute the variance stabilizing transformed expression values (stored in the `dst` object)
- retrieve the gene annotation information via the `r Biocpkg("org.Hs.eg.db")`, adding gene symbols to the ENSEMBL ids - this step is optional, but recommended for more human-readable identifiers to be used.

If you want to load your expression data, please refer to the `r Biocpkg("pcaExplorer", vignette="pcaExplorer.html", label="User Guide")`, which contains detailed information on the formats your data have to respect.

Once the preprocessing of the input is done, you should get a notification in the lower right corner that you're all set.
The whole preprocessing should take around 5-6 seconds (tested on a MacBook Pro, with i7 and 16 Gb RAM).
You can check how each component looks like by clicking on its respective button, once they appeared in the lower half of the panel.

```{r ss00, echo=FALSE, fig.cap="Overview of the Data Upload panel. After clicking on the 'Load the demo airway data' button, all widgets are automatically populated, and each data component (count matrix, experimental data, dds object, annotation) can be previewed in a modal window by clicking on its respective button."}
knitr::include_graphics("unr_00_demo_loaded.png")
```

You can proceed to explore the expression values of your dataset in the **Counts Table** tab.
You can change the data type you are displaying between raw counts, normalized, or transformed, and plot their values in a scatterplot matrix to explore their sample-to-sample correlations.
To try this, select for example "Normalized counts", change the correlation coefficient to "spearman", and click on the `Run` action button. 
The correlation values will also be displayed as a heatmap.

```{r ss01, echo=FALSE, fig.cap="Screenshot of the sample to sample scatter plot matrix. The user can select the correlation method to use, the option to plot values on log2 scales, and the possibility to use a subset of genes (to obtain a quicker overview if many samples are provided)."}
knitr::include_graphics("unr_01_splom.png")
```

Additional features, both for samples and for features, are displayed in the **Data overview** panel.
A closer look at the metadata of the `airway` set highlights how each combination of cell type (`cell`) and dexamethasone treatment (`dex`) is represented by a single sequencing experiment.
The 8 samples in the demo dataset are themselves a subsample of the [full GEO record](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE52778), namely the ones non treated with albuterol (`alb` column).

The relationship among samples can be seen in the sample-to-sample heatmap.
For example, by selecting the Manhattan distance metric, it is evident how the samples cluster by dex treatment, yet they show a dendrogram structure that recalls the 4 different cell types used.
The total sum of counts per sample is displayed as a bar plot.

```{r ss02, echo=FALSE, fig.cap="Screenshot of the sample to sample heatmap. Selected is the Manhattan distance, but Euclidean and correlation-based distance are also provided as options. In this case, the user has also selected the dex and cell factors in the 'Group/color by' widget in the sidebar menu, and these covariates decorate the heatmap to facilitate identification of patterns."}
knitr::include_graphics("unr_02_sts_heatmap.png")
```

Patterns can become clearer after selecting, in the **App settings** on the left, an experimental factor to group and color by: try selecting `dex`, for example. 
If more than one covariate is selected, the interaction between these will be taken as a grouping factor.
To remove one, simply click on it to highlight and press the del or backspace key to delete it.
Try doing so by also clicking on `cell`, and then removing `dex` afterwards.

Basic summary information is also displayed for the genes.
In the count matrix provided, one can check how many genes were detected, by selecting a "Threshold on the row sums of the counts" or on the row means of the normalized counts (more stringent). 
For example, selecting 5 in both cases, only 24345 genes have a total number of counts, summed by row, and 17745 genes have more than 5 counts (normalized) on average.

```{r ss03, echo=FALSE, fig.cap="Screenshot of the Basic Summary of the counts in the Data Overview panel. General information are provided, together with an overview on detected genes according to different filtering criteria."}
knitr::include_graphics("unr_03_summary_counts.png")
```

The **Samples View** and the **Genes View** are the tabs where most results coming from Principal Component Analysis, either performed on the samples or on the genes, can be explored in depth.
Assuming you selected `cell` in the "Group/color by" option on the left, the Samples PCA plot should clearly display how the cell type explain a considerable portion of the variability in the dataset (corresponding to the second PC).
To check that `dex` treatment is the main source of variability, select that instead of `cell`.

```{r ss04a, echo=FALSE, fig.cap="The Samples View panel. Displayed are a PCA plot (left) and the corresponding scree plot (right), with the samples colored and labeled by cell type - separating on the second principal component."}
knitr::include_graphics("unr_04a_samplespca.png")
```

The scree plot on the right shows how many components should be retained for a satisfactory reduced dimension view of the original set, with their eigenvalues from largest to smallest.
To explore the PCs other than the first and the second one, you can just select them in the x-axis PC and y-axis PC widgets in the left sidebar.

```{r ss04b, echo=FALSE, fig.cap="PCA plot for the samples, colored by dexamethasone treatment. The dex factor is the main driver of the variability in the data, and samples separate nicely on the first principal component."}
knitr::include_graphics("unr_04b_samples_dex.png")
```

If you brush (left-click and hold) on the PCA plot, you can display a zoomed version of it in the frame below.
If you suspect some samples might be outliers (this is not the case in the `airway` set, still), you can select them in the dedicated plot, and give a first check on how the remainder of the samples would look like.
On the right side, you can quickly check which genes show the top and bottom loadings, split by principal component. 
First, change the value in the input widget to 20; then, select one of each list and try to check them in the **Gene Finder** tab; try for example with *DUSP1*, *PER1*, and *DDX3Y*.

```{r ss05, echo=FALSE, fig.cap="Genes with highest loadings on the first and second principal components. The user can select how many top and bottom genes will be displayed, and the gene names are printed below each gene's contribution on each PC."}
knitr::include_graphics("unr_05_loadings.png")
```

While *DUSP1* and *PER1* clearly show a change in expression upon dexamethasone treatment (and indeed where reported among the well known glucocorticoid-responsive genes in the original publication of Himes et al., 2014), *DDX3Y* displays variability at the cell type level (select `cell` in the Group/color by widget): this gene is almost undetected in N061011 cells, and this high variance is what determines its high loading on the second principal component.

```{r ss06a, echo=FALSE, fig.cap="Plot of the gene expression levels of DUSP1. Points are split according to dex treatment, and both graphics and table are displayed."}
knitr::include_graphics("unr_06a_genefinder_dusp1.png")
```

```{r ss06b, echo=FALSE, fig.cap="Plot of the gene expression levels of PER1. Points are split according to dex treatment."}
knitr::include_graphics("unr_06b_genefinder_per1.png")
```

```{r ss06c, echo=FALSE, fig.cap="Plot of the gene expression levels of DDX3Y. Points are split according to cell type, as this gene was highly variable across this experimental factor - indeed, in one cell type it is barely detected."}
knitr::include_graphics("unr_06c_genefinder_ddx3y.png")
```

You can see the single expression values in a table as well, and this information can be downloaded with a simple click.

Back to the **Samples View**, you can experiment with the number of top variable genes to see how the results of PCA are in this case robust to a wide range of this value - this might not be the case with other datasets, and the simplicity of interacting with these parameters makes it easy to iterate in the exploration steps.

Proceeding to the **Genes View**, you can see the dual of the Samples PCA: now the samples are displayed as arrows in the genes biplot, which can show which genes display a similar behaviour.
You can capture this with a simple brushing action on the plot, and notice how their profiles throughout all samples are shown in the Profile explorer below; moreover, a static and an interactive heatmap, together with a table containing the underlying data, are generated in the rows below.

```{r ss07, echo=FALSE, fig.cap="The Genes View panel. Upper panel: the genes biplot, and its zoomed plot, with gene names displayed. Lower panel: the profile explorer of the selected subset of genes (corresponding to the zoomed window), and the boxplot for the gene selected by clicking close to a location in the zoomed window."}
knitr::include_graphics("unr_07_genespca.png")
```

Since we compute the gene annotation table as well, it's nice to read the gene symbols in the zoomed window (instead of the ENSEMBL ids).
By clicking close enough to any of these genes, the expression values are plotted, in a similar fashion as in the **Gene Finder**.

The tab **PCA2GO** helps you understanding which are the biological common themes (default: the Gene Ontology Biological Process terms) in the genes showing up in the top and in the bottom loadings for each principal component.
Since we launched the `pcaExplorer` app without additional parameters, this information is not available, but can be computed live (this might take a while).

```{r ss08, echo=FALSE, fig.cap="The PCA2GO panel. Four tables (2 per dimension, here only 3 are displayed) decorate the PCA plot in the middle, and display the top enriched functional categories in each subset of gene with high loadings."}
knitr::include_graphics("unr_08_pca2go_topgo.png")
```

Still, a previous call to `pca2go` is recommended, as it relies on the algorithm of the `r Biocpkg("topGO")` package: it will require some additional computing time, but it is likely to deliver more precise terms (i.e. in turn more relevant from the point of view of their biological relevance). To do so, you should exit the live session, compute this object, and provide it in the call to `pcaExplorer` (see more how to do so in `r Biocpkg("pcaExplorer", vignette="pcaExplorer.html", label="the main user guide")`).

# When you're done - the power of reproducibility

A typical session with `pcaExplorer` includes one or more iterations on each of these tabs.
Once you are finished, you might want to store the results of your analysis in different formats.

```{r ss90, echo=FALSE, fig.cap="The pcaExplorer task menu. Buttons for saving the session to binary data or to a dedicated environment are displayed.",out.width="80%"}
knitr::include_graphics("unr_90_exitsave.png")
```

With `pcaExplorer` you can do all of the following:

- save every plot and table by simply clicking on the respective button, below each element
- save the state of the entire app and its reactive elements as a binary `.RData` file, as if it was a workspace (clicking on the cog icon in the right side of the task menu)
- use the "Exit `pcaExplorer` and save" saves the state but in a specific environment of your R session, which you can later access by its name, which normally could look like `pcaExplorerState_YYYYMMDD_HHMMSS` (also accessible from the cog)
- enjoy the beauty of reproducible research in the **Report Editor**: `pcaExplorer` comes with a template analysis, that picks the latest status of the app during your session, and combines these reactive values together in a R Markdown document, which you can first preview live in the app, and then download as standalone HTML file - to store or share.
  This document stiches together narrative text, code, and output objects, and constitutes a compendium where all actions are recorded. 
  If you are familiar with R, you can edit that live, with support for autocompletion, in the "Edit report" tab.

```{r ss99, echo=FALSE, fig.cap="The Report Editor tab. The collapsible elements control general markdown and editor options, which are regarded when the report is compiled. Its content is specified in the Ace editor, integrated in the Shiny app."}
knitr::include_graphics("unr_99_editreport.png")
```

The functionality to display the report preview is based on `knit2html`, and some elements such as `DataTable` objects might not render correctly. 
To render them correctly, please install the PhantomJS executable before launching the app. 
This can be done by using the `r CRANpkg("webshot")` package and calling `webshot::install_phantomjs()` - HTML widgets will be rendered automatically as screenshots.
Alternatively, the more recent `r BiocStyle::CRANpkg("webshot2")` package uses the headless Chrome browser (via the `r BiocStyle::CRANpkg("chromote")` package, requiring Google Chrome or other Chromium-based browser).
Keep in mind that the fully rendered report (the one you can obtain with the "Generate & Save" button) is not affected by this, since it uses `rmarkdown::render()`.

# Session Info {.unnumbered}

```{r sessioninfo}
sessionInfo()
```

# About pcaExplorer

`pcaExplorer` is a Bioconductor package containing a Shiny application for
analyzing expression data in different conditions and experimental factors. 

`pcaExplorer` guides the user in exploring the Principal Components of the data, 
providing tools and functionality to detect outlier samples, genes that show 
particular patterns, and additionally provides a functional interpretation of 
the principal components for further quality assessment and hypothesis generation
on the input data. 

Thanks to its interactive/reactive design, it is designed to become a practical
companion to any RNA-seq dataset analysis, making exploratory data analysis 
accessible also to the bench biologist, while providing additional insight also
for the experienced data analyst.

Moreover, `pcaExplorer` supports reproducible research with state saving and automated 
report generation. 

`pcaExplorer` was developed in the Bioinformatics Division led by Harald Binder 
at the IMBEI (Institut für Medizinische Biometrie, Epidemiologie und Informatik) 
in the University Medical Center of the Johannes Gutenberg University Mainz.

## Developers

<a href="mailto:mailto:marinif@uni-mainz.de?subject=[pcaExplorer_feedback]" class="btn btn-primary">Federico Marini</a>

## Code

All code for `pcaExplorer` is available on 
<a href="https://github.com/federicomarini/pcaExplorer" target="_blank">GitHub</a>.

# Citation info

If you use `pcaExplorer` for your analysis, please cite it as here below:

```r
citation("pcaExplorer")
```

```
To cite package ‘pcaExplorer’ in publications use:

  Federico Marini (2018). pcaExplorer: Interactive Visualization of RNA-seq Data Using
  a Principal Components Approach. R package version 2.6.0.
  https://github.com/federicomarini/pcaExplorer

A BibTeX entry for LaTeX users is

  @Manual{,
    title = {pcaExplorer: Interactive Visualization of RNA-seq Data Using a Principal Components Approach},
    author = {Federico Marini},
    year = {2018},
    note = {R package version 2.6.0},
    url = {https://github.com/federicomarini/pcaExplorer},
  }
```

- `pcaExplorer` accepts only **text files, either comma, semicolon, or tab-separated**. This avoids proprietary formats such as Excel, which can also inadvertently convert your gene identifiers to dates or floating point numbers (SEPT2, see more [here](https://genomebiology.biomedcentral.com/articles/10.1186/s13059-016-1044-7))
- by default, tab-separated values are expected, but you can change this for each input file with the related radio buttons
- for **count data**: features are in the rows, samples are stored in the columns
- for the **metadata**: each row stores the relevant experimental variables of each sample
- for the **gene annotation**: each row relates to a feature (i.e. a gene), with its id in the row names, and at least a column called gene_name, containing a more readable format (e.g. HGNC gene symbols)
- it is important to have **headers**, as they are used in constructing the `dds` and `dst` objects and checking their validity: for example, the column names of the count matrix have to be identical to the row names of the sample metadata. This small constraint guarantees a higher degree of robustness for all the subsequent steps
- if your data in stored in Excel sheets, export them to csv format (specify the correct separator accordingly when loading the data - you can always open them in a text editor to check)
- general reminder: if you launch `pcaExplorer` directly from the terminal/RStudio IDE, you can pre-compute the objects, this can speed up

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_annotation.R
\name{get_annotation}
\alias{get_annotation}
\title{Get an annotation data frame from biomaRt}
\usage{
get_annotation(dds, biomart_dataset, idtype)
}
\arguments{
\item{dds}{A \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}} object}

\item{biomart_dataset}{A biomaRt dataset to use. To see the list, type
\code{mart = useMart('ensembl')}, followed by \code{listDatasets(mart)}.}

\item{idtype}{Character, the ID type of the genes as in the row names of
\code{dds}, to be used for the call to \code{\link[biomaRt:getBM]{biomaRt::getBM()}}}
}
\value{
A data frame for ready use in \code{pcaExplorer}, retrieved from biomaRt.
}
\description{
Get an annotation data frame from biomaRt
}
\examples{
library("airway")
data("airway", package = "airway")
airway
dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
                                             colData = colData(airway),
                                             design = ~dex+cell)
\dontrun{
get_annotation(dds_airway, "hsapiens_gene_ensembl", "ensembl_gene_id")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pca2go.R
\name{limmaquickpca2go}
\alias{limmaquickpca2go}
\title{Functional interpretation of the principal components, based on simple
overrepresentation analysis}
\usage{
limmaquickpca2go(
  se,
  pca_ngenes = 10000,
  inputType = "ENSEMBL",
  organism = "Mm",
  loadings_ngenes = 500,
  background_genes = NULL,
  scale = FALSE,
  ...
)
}
\arguments{
\item{se}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object, with data in \code{assay(se)},
produced for example by either \code{\link[DESeq2:rlog]{DESeq2::rlog()}} or
\code{\link[DESeq2:varianceStabilizingTransformation]{DESeq2::varianceStabilizingTransformation()}}}

\item{pca_ngenes}{Number of genes to use for the PCA}

\item{inputType}{Input format type of the gene identifiers. Deafults to \code{ENSEMBL}, that then will
be converted to ENTREZ ids. Can assume values such as \code{ENTREZID},\code{GENENAME} or \code{SYMBOL},
like it is normally used with the \code{select} function of \code{AnnotationDbi}}

\item{organism}{Character abbreviation for the species, using \code{org.XX.eg.db} for annotation}

\item{loadings_ngenes}{Number of genes to extract the loadings (in each direction)}

\item{background_genes}{Which genes to consider as background.}

\item{scale}{Logical, defaults to FALSE, scale values for the PCA}

\item{...}{Further parameters to be passed to the goana routine}
}
\value{
A nested list object containing for each principal component the terms enriched
in each direction. This object is to be thought in combination with the displaying feature
of the main \code{\link[=pcaExplorer]{pcaExplorer()}} function
}
\description{
Extracts the genes with the highest loadings for each principal component, and
performs functional enrichment analysis on them using the simple and quick routine
provided by the \code{limma} package
}
\examples{
library("airway")
library("DESeq2")
library("limma")
data("airway", package = "airway")
airway
dds_airway <- DESeqDataSet(airway, design = ~ cell + dex)
\dontrun{
rld_airway <- rlogTransformation(dds_airway)
goquick_airway <- limmaquickpca2go(rld_airway,
                                   pca_ngenes = 10000,
                                   inputType = "ENSEMBL",
                                   organism = "Hs")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_annotation.R
\name{get_annotation_orgdb}
\alias{get_annotation_orgdb}
\title{Get an annotation data frame from org db packages}
\usage{
get_annotation_orgdb(dds, orgdb_species, idtype, key_for_genenames = "SYMBOL")
}
\arguments{
\item{dds}{A \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}} object}

\item{orgdb_species}{Character string, named as the \code{org.XX.eg.db}
package which should be available in Bioconductor}

\item{idtype}{Character, the ID type of the genes as in the row names of
\code{dds}, to be used for the call to \code{\link[AnnotationDbi:AnnotationDb-class]{AnnotationDbi::mapIds()}}}

\item{key_for_genenames}{Character, corresponding to the column name for the
key in the orgDb package containing the official gene name (often called
gene symbol).
This parameter defaults to "SYMBOL", but can be adjusted in case the key is not
found in the annotation package (e.g. for \code{org.Sc.sgd.db}).}
}
\value{
A data frame for ready use in \code{pcaExplorer}, retrieved from the
org db packages
}
\description{
Get an annotation data frame from org db packages
}
\examples{
library("airway")
data("airway", package = "airway")
airway
dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
                                             colData = colData(airway),
                                             design = ~dex+cell)
anno_df <- get_annotation_orgdb(dds_airway, "org.Hs.eg.db", "ENSEMBL")
head(anno_df)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/profile_explore.R
\name{geneprofiler}
\alias{geneprofiler}
\title{Extract and plot the expression profile of genes}
\usage{
geneprofiler(se, genelist = NULL, intgroup = "condition", plotZ = FALSE)
}
\arguments{
\item{se}{A \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}} object, or a
\code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object.}

\item{genelist}{An array of characters, including the names of the genes of
interest of which the profile is to be plotted}

\item{intgroup}{A factor, needs to be in the \code{colnames} of \code{colData(se)}}

\item{plotZ}{Logical, whether to plot the scaled expression values. Defaults to
\code{FALSE}}
}
\value{
A plot of the expression profile for the genes
}
\description{
Extract and plot the expression profile of genes
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
geneprofiler(rlt, paste0("gene", sample(1:1000, 20)))
geneprofiler(rlt, paste0("gene", sample(1:1000, 20)), plotZ = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pair_corr.R
\name{pair_corr}
\alias{pair_corr}
\title{Pairwise scatter and correlation plot of counts}
\usage{
pair_corr(df, log = FALSE, method = "pearson", use_subset = TRUE)
}
\arguments{
\item{df}{A data frame, containing the (raw/normalized/transformed) counts}

\item{log}{Logical, whether to convert the input values to log2 (with addition
of a pseudocount). Defaults to FALSE.}

\item{method}{Character string, one of \code{pearson} (default), \code{kendall}, or
\code{spearman} as in \code{cor}}

\item{use_subset}{Logical value. If TRUE, only 1000 values per sample will be used
to speed up the plotting operations.}
}
\value{
A plot with pairwise scatter plots and correlation coefficients
}
\description{
Pairwise scatter and correlation plot of counts
}
\examples{
library("airway")
data("airway", package = "airway")
airway
dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
                                             colData = colData(airway),
                                             design = ~dex+cell)
pair_corr(counts(dds_airway)[1:100, ]) # use just a subset for the example
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pcaExplorer.R
\name{pcaExplorer}
\alias{pcaExplorer}
\title{Explore a dataset from a PCA perspective}
\usage{
pcaExplorer(
  dds = NULL,
  dst = NULL,
  countmatrix = NULL,
  coldata = NULL,
  pca2go = NULL,
  annotation = NULL,
  runLocal = TRUE
)
}
\arguments{
\item{dds}{A \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}} object. If not provided, then a \code{countmatrix}
and a \code{coldata} need to be provided. If none of the above is provided, it is possible
to upload the data during the execution of the Shiny App}

\item{dst}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object. Can be computed from the \code{dds} object
if left NULL. If none is provided, then a \code{countmatrix}
and a \code{coldata} need to be provided. If none of the above is provided, it is possible
to upload the data during the execution of the Shiny App}

\item{countmatrix}{A count matrix, with genes as rows and samples as columns. If not provided, it is possible
to upload the data during the execution of the Shiny App}

\item{coldata}{A data.frame containing the info on the covariates of each sample. If not provided, it is possible
to upload the data during the execution of the Shiny App}

\item{pca2go}{An object generated by the \code{\link[=pca2go]{pca2go()}} function, which contains
the information on enriched functional categories in the genes that show the top or bottom loadings
in each principal component of interest. If not provided, it is possible
to compute live during the execution of the Shiny App}

\item{annotation}{A \code{data.frame} object, with row.names as gene identifiers (e.g. ENSEMBL ids)
and a column, \code{gene_name}, containing e.g. HGNC-based gene symbols}

\item{runLocal}{A logical indicating whether the app is to be run locally or remotely on a server, which determines how documentation will be accessed.}
}
\value{
A Shiny App is launched for interactive data exploration
}
\description{
Launch a Shiny App for interactive exploration of a dataset from the perspective
of Principal Components Analysis
}
\examples{
library("airway")
data("airway", package = "airway")
airway
dds_airway <- DESeq2::DESeqDataSetFromMatrix(assay(airway),
                                             colData = colData(airway),
                                             design = ~dex+cell)
\dontrun{
rld_airway <- DESeq2::rlogTransformation(dds_airway)

pcaExplorer(dds_airway, rld_airway)

pcaExplorer(countmatrix = counts(dds_airway), coldata = colData(dds_airway))

pcaExplorer() # and then upload count matrix, covariate matrix (and eventual annotation)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hi_loadings.R
\name{hi_loadings}
\alias{hi_loadings}
\title{Extract genes with highest loadings}
\usage{
hi_loadings(
  pcaobj,
  whichpc = 1,
  topN = 10,
  exprTable = NULL,
  annotation = NULL,
  title = "Top/bottom loadings"
)
}
\arguments{
\item{pcaobj}{A \code{prcomp} object}

\item{whichpc}{An integer number, corresponding to the principal component of
interest}

\item{topN}{Integer, number of genes with top and bottom loadings}

\item{exprTable}{A \code{matrix} object, e.g. the counts of a \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}}.
If not NULL, returns the counts matrix for the selected genes}

\item{annotation}{A \code{data.frame} object, with row.names as gene identifiers (e.g. ENSEMBL ids)
and a column, \code{gene_name}, containing e.g. HGNC-based gene symbols}

\item{title}{The title of the plot}
}
\value{
A ggplot2 object, or a \code{matrix}, if \code{exprTable} is not null
}
\description{
Extract genes with highest loadings
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
pcaobj <- prcomp(t(SummarizedExperiment::assay(rlt)))
hi_loadings(pcaobj, topN = 20)
hi_loadings(pcaobj, topN = 10, exprTable = dds)
hi_loadings(pcaobj, topN = 10, exprTable = counts(dds))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pcaplot.R
\name{pcascree}
\alias{pcascree}
\title{Scree plot of the PCA on the samples}
\usage{
pcascree(obj, type = c("pev", "cev"), pc_nr = NULL, title = NULL)
}
\arguments{
\item{obj}{A \code{prcomp} object}

\item{type}{Display absolute proportions or cumulative proportion. Possible values:
"pev" or "cev"}

\item{pc_nr}{How many principal components to display max}

\item{title}{Title of the plot}
}
\value{
An object created by \code{ggplot}, which can be assigned and further customized.
}
\description{
Produces a scree plot for investigating the proportion of explained variance, or
alternatively the cumulative value
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
pcaobj <- prcomp(t(SummarizedExperiment::assay(rlt)))
pcascree(pcaobj, type = "pev")
pcascree(pcaobj, type = "cev", title = "Cumulative explained proportion of variance - Test dataset")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pcaplot.R
\name{pcaplot3d}
\alias{pcaplot3d}
\title{Sample PCA plot for transformed data}
\usage{
pcaplot3d(
  x,
  intgroup = "condition",
  ntop = 500,
  returnData = FALSE,
  title = NULL,
  pcX = 1,
  pcY = 2,
  pcZ = 3,
  text_labels = TRUE,
  point_size = 3
)
}
\arguments{
\item{x}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object, with data in \code{assay(x)},
produced for example by either \code{\link[DESeq2:rlog]{DESeq2::rlog()}} or
\code{\link[DESeq2:varianceStabilizingTransformation]{DESeq2::varianceStabilizingTransformation()}}}

\item{intgroup}{Interesting groups: a character vector of
names in \code{colData(x)} to use for grouping}

\item{ntop}{Number of top genes to use for principal components,
selected by highest row variance}

\item{returnData}{logical, if TRUE returns a data.frame for further use, containing the
selected principal components and intgroup covariates for custom plotting}

\item{title}{The plot title}

\item{pcX}{The principal component to display on the x axis}

\item{pcY}{The principal component to display on the y axis}

\item{pcZ}{The principal component to display on the z axis}

\item{text_labels}{Logical, whether to display the labels with the sample identifiers}

\item{point_size}{Integer, the size of the points for the samples}
}
\value{
A html-based visualization of the 3d PCA plot
}
\description{
Plots the results of PCA on a 3-dimensional space, interactively
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
pcaplot3d(rlt, ntop = 200)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distro_expr.R
\name{distro_expr}
\alias{distro_expr}
\title{Plot distribution of expression values}
\usage{
distro_expr(rld, plot_type = "density")
}
\arguments{
\item{rld}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object.}

\item{plot_type}{Character, choose one of \code{boxplot}, \code{violin} or
\code{density}. Defaults to \code{density}}
}
\value{
A plot with the distribution of the expression values
}
\description{
Plot distribution of expression values
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
distro_expr(rlt)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pca2go.R
\name{topGOtable}
\alias{topGOtable}
\title{Extract functional terms enriched in the DE genes, based on topGO}
\usage{
topGOtable(
  DEgenes,
  BGgenes,
  ontology = "BP",
  annot = annFUN.org,
  mapping = "org.Mm.eg.db",
  geneID = "symbol",
  topTablerows = 200,
  fullNamesInRows = TRUE,
  addGeneToTerms = TRUE,
  plotGraph = FALSE,
  plotNodes = 10,
  writeOutput = FALSE,
  outputFile = "",
  topGO_method2 = "elim",
  do_padj = FALSE
)
}
\arguments{
\item{DEgenes}{A vector of (differentially expressed) genes}

\item{BGgenes}{A vector of background genes, e.g. all (expressed) genes in the assays}

\item{ontology}{Which Gene Ontology domain to analyze: \code{BP} (Biological Process), \code{MF} (Molecular Function), or \code{CC} (Cellular Component)}

\item{annot}{Which function to use for annotating genes to GO terms. Defaults to \code{annFUN.org}}

\item{mapping}{Which \code{org.XX.eg.db} to use for annotation - select according to the species}

\item{geneID}{Which format the genes are provided. Defaults to \code{symbol}, could also be
\code{entrez} or \code{ENSEMBL}}

\item{topTablerows}{How many rows to report before any filtering}

\item{fullNamesInRows}{Logical, whether to display or not the full names for the GO terms}

\item{addGeneToTerms}{Logical, whether to add a column with all genes annotated to each GO term}

\item{plotGraph}{Logical, if TRUE additionally plots a graph on the identified GO terms}

\item{plotNodes}{Number of nodes to plot}

\item{writeOutput}{Logical, if TRUE additionally writes out the result to a file}

\item{outputFile}{Name of the file the result should be written into}

\item{topGO_method2}{Character, specifying which of the methods implemented by \code{topGO} should be used, in addition to the \code{classic} algorithm. Defaults to \code{elim}}

\item{do_padj}{Logical, whether to perform the adjustment on the p-values from the specific
topGO method, based on the FDR correction. Defaults to FALSE, since the assumption of
independent hypotheses is somewhat violated by the intrinsic DAG-structure of the Gene
Ontology Terms}
}
\value{
A table containing the computed GO Terms and related enrichment scores
}
\description{
A wrapper for extracting functional GO terms enriched in the DE genes, based on
the algorithm and the implementation in the topGO package
}
\details{
Allowed values assumed by the \code{topGO_method2} parameter are one of the
following: \code{elim}, \code{weight}, \code{weight01}, \code{lea},
\code{parentchild}. For more details on this, please refer to the original
documentation of the \code{topGO} package itself
}
\examples{
library("airway")
library("DESeq2")
data("airway", package = "airway")
airway
dds_airway <- DESeqDataSet(airway, design= ~ cell + dex)
# Example, performing extraction of enriched functional categories in
# detected significantly expressed genes
\dontrun{
dds_airway <- DESeq(dds_airway)
res_airway <- results(dds_airway)
library("AnnotationDbi")
library("org.Hs.eg.db")
res_airway$symbol <- mapIds(org.Hs.eg.db,
                            keys = row.names(res_airway),
                            column = "SYMBOL",
                            keytype = "ENSEMBL",
                            multiVals = "first")
res_airway$entrez <- mapIds(org.Hs.eg.db,
                            keys = row.names(res_airway),
                            column = "ENTREZID",
                            keytype = "ENSEMBL",
                            multiVals = "first")
resOrdered <- as.data.frame(res_airway[order(res_airway$padj),])
de_df <- resOrdered[resOrdered$padj < .05 & !is.na(resOrdered$padj),]
de_symbols <- de_df$symbol
bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
bg_symbols <- mapIds(org.Hs.eg.db,
                     keys = bg_ids,
                     column = "SYMBOL",
                     keytype = "ENSEMBL",
                     multiVals = "first")
library(topGO)
topgoDE_airway <- topGOtable(de_symbols, bg_symbols,
                             ontology = "BP",
                             mapping = "org.Hs.eg.db",
                             geneID = "symbol")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeds.R
\name{makeExampleDESeqDataSet_multifac}
\alias{makeExampleDESeqDataSet_multifac}
\title{Make a simulated DESeqDataSet for two or more experimental factors}
\usage{
makeExampleDESeqDataSet_multifac(
  n = 1000,
  m = 12,
  betaSD_condition = 1,
  betaSD_tissue = 3,
  interceptMean = 4,
  interceptSD = 2,
  dispMeanRel = function(x) 4/x + 0.1,
  sizeFactors = rep(1, m)
)
}
\arguments{
\item{n}{number of rows (genes)}

\item{m}{number of columns (samples)}

\item{betaSD_condition}{the standard deviation for condition betas, i.e. beta ~ N(0,betaSD)}

\item{betaSD_tissue}{the standard deviation for tissue betas, i.e. beta ~ N(0,betaSD)}

\item{interceptMean}{the mean of the intercept betas (log2 scale)}

\item{interceptSD}{the standard deviation of the intercept betas (log2 scale)}

\item{dispMeanRel}{a function specifying the relationship of the dispersions on
\code{2^trueIntercept}}

\item{sizeFactors}{multiplicative factors for each sample}
}
\value{
a \code{\link[DESeq2:DESeqDataSet]{DESeq2::DESeqDataSet()}} with true dispersion,
intercept for two factors (condition and tissue) and beta values in the
metadata columns.  Note that the true betas are provided on the log2 scale.
}
\description{
Constructs a simulated dataset of Negative Binomial data from different conditions.
The fold changes between the conditions can be adjusted with the \code{betaSD_condition}
and the \code{betaSD_tissue} arguments.
}
\details{
This function is designed and inspired following the proposal of
\code{\link[DESeq2:makeExampleDESeqDataSet]{DESeq2::makeExampleDESeqDataSet()}} from the \code{DESeq2} package. Credits are given
to Mike Love for the nice initial implementation
}
\examples{
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
dds
dds2 <- makeExampleDESeqDataSet_multifac(betaSD_condition = 1, betaSD_tissue = 4)
dds2

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/correlatePCs.R
\name{plotPCcorrs}
\alias{plotPCcorrs}
\title{Plot significance of (cor)relations of covariates VS principal components}
\usage{
plotPCcorrs(pccorrs, pc = 1, logp = TRUE)
}
\arguments{
\item{pccorrs}{A \code{data.frame} object generated by \link{correlatePCs}}

\item{pc}{An integer number, corresponding to the principal component of
interest}

\item{logp}{Logical, defaults to \code{TRUE}, displays the -\code{log10} of
the pvalue instead of the p value itself}
}
\value{
A base plot object
}
\description{
Plots the significance of the (cor)relation of each covariate vs a principal component
}
\examples{
library(DESeq2)
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- rlogTransformation(dds)
pcaobj <- prcomp(t(assay(rlt)))
res <- correlatePCs(pcaobj, colData(dds))
plotPCcorrs(res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genespca.R
\name{genespca}
\alias{genespca}
\title{Principal components analysis on the genes}
\usage{
genespca(
  x,
  ntop,
  choices = c(1, 2),
  arrowColors = "steelblue",
  groupNames = "group",
  biplot = TRUE,
  scale = 1,
  pc.biplot = TRUE,
  obs.scale = 1 - scale,
  var.scale = scale,
  groups = NULL,
  ellipse = FALSE,
  ellipse.prob = 0.68,
  labels = NULL,
  labels.size = 3,
  alpha = 1,
  var.axes = TRUE,
  circle = FALSE,
  circle.prob = 0.69,
  varname.size = 4,
  varname.adjust = 1.5,
  varname.abbrev = FALSE,
  returnData = FALSE,
  coordEqual = FALSE,
  scaleArrow = 1,
  useRownamesAsLabels = TRUE,
  point_size = 2,
  annotation = NULL
)
}
\arguments{
\item{x}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object, with data in \code{assay(x)},
produced for example by either \code{\link[DESeq2:rlog]{DESeq2::rlog()}} or
\code{\link[DESeq2:varianceStabilizingTransformation]{DESeq2::varianceStabilizingTransformation()}}}

\item{ntop}{Number of top genes to use for principal components,
selected by highest row variance}

\item{choices}{Vector of two numeric values, to select on which principal components to plot}

\item{arrowColors}{Vector of character, either as long as the number of the samples, or one single value}

\item{groupNames}{Factor containing the groupings for the input data. Is efficiently chosen
as the (interaction of more) factors in the colData for the object provided}

\item{biplot}{Logical, whether to additionally draw the samples labels as in a biplot representation}

\item{scale}{Covariance biplot (scale = 1), form biplot (scale = 0). When scale = 1,
the inner product between the variables approximates the covariance and the
distance between the points approximates the Mahalanobis distance.}

\item{pc.biplot}{Logical, for compatibility with biplot.princomp()}

\item{obs.scale}{Scale factor to apply to observations}

\item{var.scale}{Scale factor to apply to variables}

\item{groups}{Optional factor variable indicating the groups that the observations
belong to. If provided the points will be colored according to groups}

\item{ellipse}{Logical, draw a normal data ellipse for each group}

\item{ellipse.prob}{Size of the ellipse in Normal probability}

\item{labels}{optional Vector of labels for the observations}

\item{labels.size}{Size of the text used for the labels}

\item{alpha}{Alpha transparency value for the points (0 = transparent, 1 = opaque)}

\item{var.axes}{Logical, draw arrows for the variables?}

\item{circle}{Logical, draw a correlation circle? (only applies when prcomp
was called with scale = TRUE and when var.scale = 1)}

\item{circle.prob}{Size of the correlation circle in Normal probability}

\item{varname.size}{Size of the text for variable names}

\item{varname.adjust}{Adjustment factor the placement of the variable names,
'>= 1' means farther from the arrow}

\item{varname.abbrev}{Logical, whether or not to abbreviate the variable names}

\item{returnData}{Logical, if TRUE returns a data.frame for further use, containing the
selected principal components for custom plotting}

\item{coordEqual}{Logical, default FALSE, for allowing brushing. If TRUE, plot using
equal scale cartesian coordinates}

\item{scaleArrow}{Multiplicative factor, usually >=1, only for visualization purposes,
to allow for distinguishing where the variables are plotted}

\item{useRownamesAsLabels}{Logical, if TRUE uses the row names as labels for plotting}

\item{point_size}{Size of the points to be plotted for the observations (genes)}

\item{annotation}{A \code{data.frame} object, with row.names as gene identifiers (e.g. ENSEMBL ids)
and a column, \code{gene_name}, containing e.g. HGNC-based gene symbols}
}
\value{
An object created by \code{ggplot}, which can be assigned and further customized.
}
\description{
Computes and plots the principal components of the genes, eventually displaying
the samples as in a typical biplot visualization.
}
\details{
The implementation of this function is based on the beautiful \code{ggbiplot}
package developed by Vince Vu, available at https://github.com/vqv/ggbiplot.
The adaptation and additional parameters are tailored to display typical genomics data
such as the transformed counts of RNA-seq experiments
}
\examples{

library(DESeq2)
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- rlogTransformation(dds)
groups <- colData(dds)$condition
groups <- factor(groups, levels = unique(groups))
cols <- scales::hue_pal()(2)[groups]
genespca(rlt, ntop=100, arrowColors = cols, groupNames = groups)

groups_multi <- interaction(as.data.frame(colData(rlt)[, c("condition", "tissue")]))
groups_multi <- factor(groups_multi, levels = unique(groups_multi))
cols_multi <- scales::hue_pal()(length(levels(groups_multi)))[factor(groups_multi)]
genespca(rlt, ntop = 100, arrowColors = cols_multi, groupNames = groups_multi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pca2go.R
\name{pca2go}
\alias{pca2go}
\title{Functional interpretation of the principal components}
\usage{
pca2go(
  se,
  pca_ngenes = 10000,
  annotation = NULL,
  inputType = "geneSymbol",
  organism = "Mm",
  ensToGeneSymbol = FALSE,
  loadings_ngenes = 500,
  background_genes = NULL,
  scale = FALSE,
  return_ranked_gene_loadings = FALSE,
  annopkg = NULL,
  ...
)
}
\arguments{
\item{se}{A \code{\link[DESeq2:DESeqTransform]{DESeq2::DESeqTransform()}} object, with data in \code{assay(se)},
produced for example by either \code{\link[DESeq2:rlog]{DESeq2::rlog()}} or
\code{\link[DESeq2:varianceStabilizingTransformation]{DESeq2::varianceStabilizingTransformation()}}}

\item{pca_ngenes}{Number of genes to use for the PCA}

\item{annotation}{A \code{data.frame} object, with row.names as gene identifiers (e.g. ENSEMBL ids)
and a column, \code{gene_name}, containing e.g. HGNC-based gene symbols}

\item{inputType}{Input format type of the gene identifiers. Will be used by the routines of \code{topGO}}

\item{organism}{Character abbreviation for the species, using \code{org.XX.eg.db} for annotation}

\item{ensToGeneSymbol}{Logical, whether to expect ENSEMBL gene identifiers, to convert to gene symbols
with the \code{annotation} provided}

\item{loadings_ngenes}{Number of genes to extract the loadings (in each direction)}

\item{background_genes}{Which genes to consider as background.}

\item{scale}{Logical, defaults to FALSE, scale values for the PCA}

\item{return_ranked_gene_loadings}{Logical, defaults to FALSE. If TRUE, simply returns
a list containing the top ranked genes with hi loadings in each PC and in each direction}

\item{annopkg}{String containing the name of the organism annotation package. Can be used to
override the \code{organism} parameter, e.g. in case of alternative identifiers used
in the annotation package (Arabidopsis with TAIR)}

\item{...}{Further parameters to be passed to the topGO routine}
}
\value{
A nested list object containing for each principal component the terms enriched
in each direction. This object is to be thought in combination with the displaying feature
of the main \code{\link[=pcaExplorer]{pcaExplorer()}} function
}
\description{
Extracts the genes with the highest loadings for each principal component, and
performs functional enrichment analysis on them using routines and algorithms from
the \code{topGO} package
}
\examples{
library("airway")
library("DESeq2")
data("airway", package = "airway")
airway
dds_airway <- DESeqDataSet(airway, design= ~ cell + dex)
\dontrun{
rld_airway <- rlogTransformation(dds_airway)
# constructing the annotation object
anno_df <- data.frame(gene_id = rownames(dds_airway),
                      stringsAsFactors = FALSE)
library("AnnotationDbi")
library("org.Hs.eg.db")
anno_df$gene_name <- mapIds(org.Hs.eg.db,
                            keys = anno_df$gene_id,
                            column = "SYMBOL",
                            keytype = "ENSEMBL",
                            multiVals = "first")
rownames(anno_df) <- anno_df$gene_id
bg_ids <- rownames(dds_airway)[rowSums(counts(dds_airway)) > 0]
library(topGO)
pca2go_airway <- pca2go(rld_airway,
                        annotation = anno_df,
                        organism = "Hs",
                        ensToGeneSymbol = TRUE,
                        background_genes = bg_ids)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pcaExplorer-pkg.R
\docType{package}
\name{pcaExplorer-pkg}
\alias{pcaExplorer-package}
\alias{pcaExplorer-pkg}
\title{pcaExplorer: analyzing time-lapse microscopy imaging, from detection to tracking}
\description{
pcaExplorer provides functionality for interactive visualization of RNA-seq datasets
based on Principal Components Analysis. The methods provided allow for quick information
extraction and effective data exploration. A Shiny application encapsulates the whole analysis.
}
\details{
pcaExplorer provides functionality for interactive visualization of RNA-seq datasets
based on Principal Components Analysis. The methods provided allow for quick information
extraction and effective data exploration. A Shiny application encapsulates the whole analysis.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/federicomarini/pcaExplorer}
  \item \url{https://federicomarini.github.io/pcaExplorer/}
  \item Report bugs at \url{https://github.com/federicomarini/pcaExplorer/issues}
}

}
\author{
Federico Marini \email{marinif@uni-mainz.de}, 2016

Maintainer: Federico Marini \email{marinif@uni-mainz.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/correlatePCs.R
\name{correlatePCs}
\alias{correlatePCs}
\title{Principal components (cor)relation with experimental covariates}
\usage{
correlatePCs(pcaobj, coldata, pcs = 1:4)
}
\arguments{
\item{pcaobj}{A \code{prcomp} object}

\item{coldata}{A \code{data.frame} object containing the experimental
covariates}

\item{pcs}{A numeric vector, containing the corresponding PC number}
}
\value{
A \code{data.frame} object with computed p values for each covariate
and for each principal component
}
\description{
Computes the significance of (cor)relations between PCA scores and the sample
experimental covariates, using Kruskal-Wallis test for categorial variables
and the \code{cor.test} based on Spearman's correlation for continuous
variables
}
\examples{
library(DESeq2)
dds <- makeExampleDESeqDataSet_multifac(betaSD_condition = 3, betaSD_tissue = 1)
rlt <- DESeq2::rlogTransformation(dds)
pcaobj <- prcomp(t(assay(rlt)))
correlatePCs(pcaobj, colData(dds))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecated.R
\name{deprecated}
\alias{deprecated}
\title{Deprecated functions in pcaExplorer}
\arguments{
\item{...}{Ignored arguments.}
}
\value{
All functions throw a warning, with a deprecation message pointing
towards its descendent (if available).
}
\description{
Functions that are on their way to the function afterlife.
Their successors are also listed.
}
\details{
The successors of these functions are likely coming after the rework that
led to the creation of the \code{mosdef} package. See more into its
documentation for more details.
}
\section{Transitioning to the mosdef framework}{

\itemize{
\item \code{\link[=topGOtable]{topGOtable()}} is now being replaced by the more flexible
\code{\link[mosdef:run_topGO]{mosdef::run_topGO()}} function
}
}

\examples{
# try(topGOtable())

}
\author{
Federico Marini
}
